(* Content-type: application/vnd.wolfram.cdf.text *)

(*** Wolfram CDF File ***)
(* http://www.wolfram.com/cdf *)

(* CreatedBy='Mathematica 8.0' *)

(*************************************************************************)
(*                                                                       *)
(*  The Mathematica License under which this file was created prohibits  *)
(*  restricting third parties in receipt of this file from republishing  *)
(*  or redistributing it by any means, including but not limited to      *)
(*  rights management or terms of use, without the express consent of    *)
(*  Wolfram Research, Inc.                                               *)
(*                                                                       *)
(*************************************************************************)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       835,         17]
NotebookDataLength[    199147,       6188]
NotebookOptionsPosition[    149948,       4967]
NotebookOutlinePosition[    187013,       5748]
CellTagsIndexPosition[    186970,       5745]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {
    ButtonBox[Cell[GraphicsData["CompressedBitmap", "\<\
eJzVWL1uFDEQduzd2/wgISEkRHco0NGlAN0DAAXcC1CdIqSkQKAkokjDC9Aj
UoBESUt5LW9AR5UHiQ782fPtzXq9l70lKKLwrj3jmfHOfPaM98Xs5ODV69nJ
4f5s/PRo9vbgcP94/OTNkSe5DWPML9/ujA36v31XHlPz6ebuB7O3t2fMuv0t
9M3I/Dh5H3ps3x4/M9+fv6zCoAzsxcVF3TAuA8+Znx+/BBpGhdAwBj2O2rRR
eFYwUctTL8eFzNRyaMJ3YjBh2/BdpTk9PTXn5+dmsViY+XxuptOpnwzeKPRB
Aw8N8zzNBbYzZ2dngYwRRbQ6vEVlISIgQwwjm6EVmVXhDX5PE2CDhcWXPdSl
HynqSmHr1aHJR7vM4scRKpsSR8QMTv/64JH/1jYGSoktaXjruOJd/AV2iDtA
lLixsBCm9ULNTouNL4TH6Cl6Fv3okyrwQaOnMYdzc9hxSeQw12Jkg4oYIvof
TZyei4GTsFE/7WLslV1iqmqZ4rfobXGJbroHYjYwXQ0+rWYossoGQkCJCAMl
oo7BsgkCMN8liAIvpQ1BGWU/330Y59neKOs8m3Qw6HS6B85nYBj0NHgiExxu
dYgmk0mIHN45f+eOJpuENwY2HlqJ4U5bW5062sjTH6htc7cNh1Glkgo9z4OK
fYseMcCsVsfWP9FnJroK/OTm0e6Sti6SdIDUts05p1pxMulUU4RnTEM9DyWb
qAYUqk7VrqE6XVYq2zz4cssfDpHtRkQ1VBAZwse/04D9f0CxAhQmBsldubql
Eyhh2xeyqcFhHFcdJ71w0ql581rQMZKAEAEsivG2UpPiMFGoYaSuOxW1Kxpt
ncmUH2WX0HB1yo+5aVgWUiIIFVXrmpX5QJvTVdcyZ6yXR7rsXX1O2mmtnfU1
9Wlb9zSmqkbgdThAt8l2B/7cwCraJRimHGBga9CIEI87oo5CmZI6FYtT4p7Q
6/J2FLrK2oVSTDagMLSg1oW6ldk6NHJqgVQ2FKelas+Kt8vO9npqVhbOYbmR
W9Wz0dK1C67KJGTLNBQxw22PxlS1xEz/Gz3xpG/pTdyW9biNzT43/Corj/2h
z93kBwXzGiEku463W15+9eV4jRs+g+nPlrQcZSgkNCOBed+LvdJ8o4foykt8
1VoUf3SAFm9+rpECJc/tSGSZy9Bu9UxQ9/GUn0fjfy1zO+4M76F3w6Xj7Qpp
gm44vkxZs4zy22d3zdUUDcz7/m7GBdwaOseThreW6fMvz2z8AbMc9mc=\
\>"], "Graphics",
      Evaluatable->False,
      GeneratedCell->False,
      CellAutoOverwrite->False,
      ImageSize->{218, 23},
      ImageMargins->{{0, 0}, {0, 0}},
      ImageRegion->{{0, 1}, {0, 1}}],
     Active->True,
     Appearance->{Automatic, None},
     BaseStyle->"Hyperlink",
     ButtonData:>{
       URL["http://www.wolframscience.com"], None},
     ButtonNote->"A New Kind of Science"]}
  }]], "TitleCell1",
 CellMargins->{{Inherited, Inherited}, {0, Inherited}}],

Cell[TextData[{
 "From: ",
 StyleBox["A New Kind of Science",
  FontSlant->"Italic"],
 ", by Stephen Wolfram \[Copyright] 2002 Stephen Wolfram, LLC"
}], "Text",
 ShowCellBracket->False,
 CellMargins->{{36, Inherited}, {Inherited, 5}}],

Cell["NOTES FOR CHAPTER 3", "TitleHeader"],

Cell[CellGroupData[{

Cell["The World of Simple Programs", "Title"],

Cell[CellGroupData[{

Cell["More Cellular Automata", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Rule 150", "Subsection"], Cell[" (page 885)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Apply", "[", 
  RowBox[{"Times", ",", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["2", 
          RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
           RowBox[{"#", "+", "2"}]}]], "-", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
           RowBox[{"#", "+", "2"}]}]]}], ")"}], "/", "3"}], "&"}], ",", 
     RowBox[{"Cases", "[", 
      RowBox[{
       RowBox[{"Split", "[", 
        RowBox[{"IntegerDigits", "[", 
         RowBox[{"t", ",", "2"}], "]"}], "]"}], ",", 
       RowBox[{
        RowBox[{"k", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"(", "1", ")"}], ".."}], "}"}]}], "\[RuleDelayed]", 
        RowBox[{"Length", "[", "k", "]"}]}]}], "]"}]}], "]"}]}], 
  "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"Apply", "[", 
    RowBox[{"Times", ",", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["2", 
            RowBox[{"\[VeryThinSpace]", 
             RowBox[{"#", "+", "2"}]}]], "-", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"\[VeryThinSpace]", 
             RowBox[{"#", "+", "2"}]}]]}], ")"}], "/", 
         "\[NegativeVeryThinSpace]\[NegativeVeryThinSpace]", "3"}], "&"}], 
       ",", 
       RowBox[{"Cases", "[", 
        RowBox[{
         RowBox[{"Split", "[", 
          RowBox[{"IntegerDigits", "[", 
           RowBox[{"t", ",", "2"}], "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"k", ":", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"(", "1", ")"}], ".."}], "}"}]}], "\[RuleDelayed]", 
          RowBox[{"Length", "[", "k", "]"}]}]}], "]"}]}], "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "4"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "3", ",", "3", ",", "5", ",", "3"}], "}"}]], "Output",
 CellChangeTimes->{3.413572565524061*^9, 3.4323117085297422`*^9, 
  3.500208259231607*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Two-cell neighborhoods", "Subsection"], Cell[" (page 885)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"k_", ",", "rule_"}], "}"}], ",", "a_List"}], "]"}], ":=", 
  RowBox[{"rule", "\[LeftDoubleBracket]", 
   RowBox[{
    SuperscriptBox["k", 
     RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "2"}]], "-", 
    RowBox[{"RotateLeft", "[", "a", "]"}], "-", 
    RowBox[{"k", " ", "a"}]}], "\[RightDoubleBracket]"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"k_", ",", "rule_"}], "}"}], ",", "a_List"}], "]"}], ":=", 
  RowBox[{"rule", "\[LeftDoubleBracket]", 
   RowBox[{
    SuperscriptBox["k", 
     RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "2"}]], "-", 
    RowBox[{"RotateLeft", "[", "a", "]"}], "-", 
    RowBox[{"k", " ", "a"}]}], "\[RightDoubleBracket]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Grid", "[", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CAStep", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"3", ",", 
         RowBox[{"IntegerDigits", "[", 
          RowBox[{"7743", ",", "3", ",", 
           SuperscriptBox["3", "2"]}], "]"}]}], "}"}], ",", "#"}], "]"}], 
     "&"}], ",", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "2", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", "5"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.512914001752111*^9, 3.512914006405012*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "0", "0", "0", "0", "2", "0", "0", "0", "0", "0"},
    {"0", "0", "0", "0", "2", "1", "0", "0", "0", "0", "0"},
    {"0", "0", "0", "2", "0", "1", "0", "0", "0", "0", "0"},
    {"0", "0", "2", "1", "1", "1", "0", "0", "0", "0", "0"},
    {"0", "2", "0", "2", "2", "1", "0", "0", "0", "0", "0"},
    {"2", "1", "2", "1", "0", "1", "0", "0", "0", "0", "0"}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{3.413572565670619*^9, 3.428239190246602*^9, 
  3.432311708712161*^9, 3.5002082750926533`*^9, 3.5129140104687138`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Implementation of general cellular automata", "Subsection"], Cell[
     " (page 886)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"CARule", "[", 
     RowBox[{"rule_List", ",", "k_", ",", "r_"}], "]"}], ",", "a_List"}], 
   "]"}], ":=", 
  RowBox[{"rule", "\[LeftDoubleBracket]", 
   RowBox[{
    RowBox[{"-", "1"}], "-", 
    RowBox[{"ListConvolve", "[", 
     RowBox[{
      RowBox[{"k", "^", 
       RowBox[{"Range", "[", 
        RowBox[{"0", ",", 
         RowBox[{"2", " ", "r"}]}], "]"}]}], ",", "a", ",", 
      RowBox[{"r", "+", "1"}]}], "]"}]}], 
   "\[RightDoubleBracket]"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"CARule", "[", 
     RowBox[{"rule_List", ",", "k_", ",", "r_"}], "]"}], ",", "a_List"}], 
   "]"}], ":=", 
  RowBox[{"rule", "\[LeftDoubleBracket]", 
   RowBox[{
    RowBox[{"-", "1"}], "-", 
    RowBox[{"ListConvolve", "[", 
     RowBox[{
      RowBox[{"k", "^", 
       RowBox[{"Range", "[", 
        RowBox[{"0", ",", 
         RowBox[{"2", " ", "r"}]}], "]"}]}], ",", "a", ",", 
      RowBox[{"r", "+", "1"}]}], "]"}]}], 
   "\[RightDoubleBracket]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Grid", "[", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"k", "=", "2"}], ",", 
      RowBox[{"r", "=", "1"}], ",", 
      RowBox[{"num", "=", "30"}]}], "}"}], ",", 
    RowBox[{"NestList", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"CAStep", "[", 
        RowBox[{
         RowBox[{"CARule", "[", 
          RowBox[{
           RowBox[{"IntegerDigits", "[", 
            RowBox[{"num", ",", "k", ",", 
             SuperscriptBox["k", 
              RowBox[{
               RowBox[{"2", " ", "r"}], "+", "1"}]]}], "]"}], ",", "k", ",", 
           "r"}], "]"}], ",", "#"}], "]"}], "&"}], ",", 
      RowBox[{"{", 
       RowBox[{
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
        "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", "5"}], "]"}]}], 
   "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.512914041628647*^9, 3.512914044420676*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0"},
    {"0", "0", "0", "0", "1", "1", "1", "0", "0", "0", "0"},
    {"0", "0", "0", "1", "1", "0", "0", "1", "0", "0", "0"},
    {"0", "0", "1", "1", "0", "1", "1", "1", "1", "0", "0"},
    {"0", "1", "1", "0", "0", "1", "0", "0", "0", "1", "0"},
    {"1", "1", "0", "1", "1", "1", "1", "0", "1", "1", "1"}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{
  3.413572565756873*^9, 3.4323117087797003`*^9, 3.500208287961176*^9, {
   3.51291404526818*^9, 3.5129140481138287`*^9}}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Implementation of totalistic cellular automata", "Subsection"], 
     Cell[" (page 886)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CAStep", "[", 
    RowBox[{
     RowBox[{"TotalisticCARule", "[", 
      RowBox[{"rule_List", ",", "r_Integer"}], "]"}], ",", "a_List"}], "]"}], 
   ":=", 
   RowBox[{"rule", "\[LeftDoubleBracket]", 
    RowBox[{
     RowBox[{"-", "1"}], "-", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{"RotateLeft", "[", 
        RowBox[{"a", ",", "i"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"-", "r"}], ",", "r"}], "}"}]}], "]"}]}], 
    "\[RightDoubleBracket]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"ToTotalisticCARule", "[", 
   RowBox[{"num_Integer", ",", "k_Integer", ",", "r_Integer"}], "]"}], ":=", 
  RowBox[{"TotalisticCARule", "[", 
   RowBox[{
    RowBox[{"IntegerDigits", "[", 
     RowBox[{"num", ",", "k", ",", 
      RowBox[{"1", "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"k", "-", "1"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "r"}], "+", "1"}], ")"}]}]}]}], "]"}], ",", "r"}],
    "]"}]}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"TotalisticCARule", "[", 
     RowBox[{"rule_List", ",", "1"}], "]"}], ",", "a_List"}], "]"}], ":=", 
  RowBox[{"rule", "\[LeftDoubleBracket]", 
   RowBox[{
    RowBox[{"-", "1"}], "-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"RotateLeft", "[", "a", "]"}], "+", "a", "+", 
      RowBox[{"RotateRight", "[", "a", "]"}]}], ")"}]}], 
   "\[RightDoubleBracket]"}]}], "\n", 
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"TotalisticCARule", "[", 
     RowBox[{"rule_List", ",", "r_Integer"}], "]"}], ",", "a_List"}], "]"}], ":=", 
  RowBox[{"rule", "\[LeftDoubleBracket]", 
   RowBox[{
    RowBox[{"-", "1"}], "-", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{"RotateLeft", "[", 
       RowBox[{"a", ",", "i"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"-", "r"}], ",", "r"}], "}"}]}], "]"}]}], 
   "\[RightDoubleBracket]"}]}], "\n", 
 RowBox[{
  RowBox[{"ToTotalisticCARule", "[", 
   RowBox[{"num_Integer", ",", "k_Integer", ",", "r_Integer"}], "]"}], ":=", 
  RowBox[{"TotalisticCARule", "[", 
   RowBox[{
    RowBox[{"IntegerDigits", "[", 
     RowBox[{"num", ",", "k", ",", 
      RowBox[{"1", "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"k", "-", "1"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "r"}], "+", "1"}], ")"}]}]}]}], "]"}], ",", "r"}],
    "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Grid", "[", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CAStep", "[", 
      RowBox[{
       RowBox[{"ToTotalisticCARule", "[", 
        RowBox[{"777", ",", "3", ",", "1"}], "]"}], ",", "#"}], "]"}], "&"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", "5"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.512914111133628*^9, 3.512914113768906*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0"},
    {"0", "0", "0", "0", "1", "1", "1", "0", "0", "0", "0"},
    {"0", "0", "0", "1", "2", "1", "2", "1", "0", "0", "0"},
    {"0", "0", "1", "1", "0", "0", "0", "1", "1", "0", "0"},
    {"0", "1", "2", "2", "1", "0", "1", "2", "2", "1", "0"},
    {"1", "1", "0", "0", "1", "2", "1", "0", "0", "1", "1"}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{3.41357256585718*^9, 3.43231170884529*^9, 
  3.5002082990819683`*^9, 3.512914117791498*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Rules based on algebraic systems", "Subsection"], Cell[
     " (page 886)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{"t_", ",", "i_"}], "]"}], ":=", 
   RowBox[{"f", "[", 
    RowBox[{
     RowBox[{"a", "[", 
      RowBox[{
       RowBox[{"t", "-", "1"}], ",", 
       RowBox[{"i", "-", "1"}]}], "]"}], ",", 
     RowBox[{"a", "[", 
      RowBox[{
       RowBox[{"t", "-", "1"}], ",", "i"}], "]"}]}], "]"}]}], "\n"}], "\n", 
 RowBox[{"NestList", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"f", "[", 
     RowBox[{
      RowBox[{"RotateRight", "[", "#", "]"}], ",", "#"}], "]"}], "&"}], ",", 
   "init", ",", "t"}], "]"}]}], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Grid", "[", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"f", "=", "Times"}], ",", 
      RowBox[{"init", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "1", ",", "1",
          ",", "1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}]}], ",", 
      RowBox[{"t", "=", "10"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"t_", ",", "i_"}], "]"}], ":=", 
      RowBox[{"f", "[", 
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{
          RowBox[{"t", "-", "1"}], ",", 
          RowBox[{"i", "-", "1"}]}], "]"}], ",", 
        RowBox[{"a", "[", 
         RowBox[{
          RowBox[{"t", "-", "1"}], ",", "i"}], "]"}]}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"NestList", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"f", "[", 
          RowBox[{
           RowBox[{"RotateRight", "[", "#", "]"}], ",", "#"}], "]"}], "&"}], 
        ",", "init", ",", "t"}], "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "\[Rule]", "1"}], ",", 
        RowBox[{"1", "\[Rule]", "0"}]}], "}"}]}]}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.512914126441617*^9, 3.5129141290505457`*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
    {"1", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
    {"1", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0"},
    {"1", "1", "1", "1", "0", "0", "0", "0", "0", "0", "0"},
    {"1", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0"},
    {"1", "1", "0", "0", "1", "1", "0", "0", "0", "0", "0"},
    {"1", "0", "1", "0", "1", "0", "1", "0", "0", "0", "0"},
    {"1", "1", "1", "1", "1", "1", "1", "1", "0", "0", "0"},
    {"1", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0"},
    {"1", "1", "0", "0", "0", "0", "0", "0", "1", "1", "0"},
    {"1", "0", "1", "0", "0", "0", "0", "0", "1", "0", "1"}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{3.413572565918125*^9, 3.428239251320259*^9, 
  3.432311708884679*^9, 3.500208306213483*^9, 3.512914131235214*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Mobile Automata", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Implementation", "Subsection"], Cell[" (page 887)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]}], "}"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MAStep", "[", 
     RowBox[{"rule_", ",", 
      RowBox[{"{", 
       RowBox[{"list_List", ",", "n_Integer"}], "}"}]}], "]"}], "/;", 
    RowBox[{"1", "<", "n", "<", 
     RowBox[{"Length", "[", "list", "]"}]}]}], ":=", 
   RowBox[{"Apply", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ReplacePart", "[", 
         RowBox[{"list", ",", "#1", ",", "n"}], "]"}], ",", 
        RowBox[{"n", "+", "#2"}]}], "}"}], "&"}], ",", 
     RowBox[{"Replace", "[", 
      RowBox[{
       RowBox[{"Take", "[", 
        RowBox[{"list", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"n", "-", "1"}], ",", 
           RowBox[{"n", "+", "1"}]}], "}"}]}], "]"}], ",", "rule"}], "]"}]}], 
    "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"MAEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"MAStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MAStep", "[", 
    RowBox[{"rule_", ",", 
     RowBox[{"{", 
      RowBox[{"list_List", ",", "n_Integer"}], "}"}]}], "]"}], "/;", 
   RowBox[{"1", "<", "n", "<", 
    RowBox[{"Length", "[", "list", "]"}]}]}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ReplacePart", "[", 
        RowBox[{"list", ",", "#1", ",", "n"}], "]"}], ",", 
       RowBox[{"n", "+", "#2"}]}], "}"}], "&"}], ",", 
    RowBox[{"Replace", "[", 
     RowBox[{
      RowBox[{"Take", "[", 
       RowBox[{"list", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"n", "-", "1"}], ",", 
          RowBox[{"n", "+", "1"}]}], "}"}]}], "]"}], ",", "rule"}], "]"}]}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"MAEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"MAStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MAEvolveList", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "0"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "1"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"-", "1"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"-", "1"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", "15", "}"}]}], "]"}], ",", "7"}], "}"}], ",", "5"}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "6"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.413572566006576*^9, 3.432311708966123*^9, 
  3.5002083173167*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"-", "1"}]}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"-", "1"}]}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", "1"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", "1"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "1"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"-", "1"}]}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", "1"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", "1"}], "}"}]}]}], 
   "}"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"MAStep", "[", 
    RowBox[{"rule_", ",", 
     RowBox[{"{", 
      RowBox[{"list_List", ",", "n_Integer"}], "}"}]}], "]"}], "/;", 
   RowBox[{"1", "<", "n", "<", 
    RowBox[{"Length", "[", "list", "]"}]}]}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"Take", "[", 
          RowBox[{"list", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"n", "-", "2"}]}], "}"}]}], "]"}], ",", "#1", ",", 
         RowBox[{"Take", "[", 
          RowBox[{"list", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"n", "+", "2"}], ",", 
             RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"n", "+", "#2"}]}], "}"}], "&"}], ",", 
    RowBox[{"Replace", "[", 
     RowBox[{
      RowBox[{"Take", "[", 
       RowBox[{"list", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"n", "-", "1"}], ",", 
          RowBox[{"n", "+", "1"}]}], "}"}]}], "]"}], ",", "rule"}], "]"}]}], 
   "]"}]}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MAStep", "[", 
    RowBox[{"rule_", ",", 
     RowBox[{"{", 
      RowBox[{"list_List", ",", "n_Integer"}], "}"}]}], "]"}], "/;", 
   RowBox[{"1", "<", "n", "<", 
    RowBox[{"Length", "[", "list", "]"}]}]}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"Take", "[", 
          RowBox[{"list", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"n", "-", "2"}]}], "}"}]}], "]"}], ",", "#1", ",", 
         RowBox[{"Take", "[", 
          RowBox[{"list", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"n", "+", "2"}], ",", 
             RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"n", "+", "#2"}]}], "}"}], "&"}], ",", 
    RowBox[{"Replace", "[", 
     RowBox[{
      RowBox[{"Take", "[", 
       RowBox[{"list", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"n", "-", "1"}], ",", 
          RowBox[{"n", "+", "1"}]}], "}"}]}], "]"}], ",", "rule"}], "]"}]}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"MAEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"MAStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MAEvolveList", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
        RowBox[{"-", "1"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "0"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
        RowBox[{"-", "1"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "1"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "1", ",", "1"}], "}"}], ",", 
        RowBox[{"-", "1"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", "1"}], "}"}]}]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", "15", "}"}]}], "]"}], ",", "7"}], "}"}], ",", "5"}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "6"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.413572566076684*^9, 3.432311709032826*^9, 
  3.500208331572639*^9}]
}, Open  ]],

Cell[BoxData[""], "Input"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Implementation of generalized mobile automata", "Subsection"], 
     Cell[" (page 887)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"GMAStep", "[", 
   RowBox[{"rules_", ",", 
    RowBox[{"{", 
     RowBox[{"list_", ",", "nlist_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a", ",", "na"}], "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"a", ",", "na"}], "}"}], "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Replace", "[", 
           RowBox[{
            RowBox[{"Take", "[", 
             RowBox[{"list", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"#", "-", "1"}], ",", 
                RowBox[{"#", "+", "1"}]}], "}"}]}], "]"}], ",", "rules"}], 
           "]"}], "&"}], ",", "nlist"}], "]"}], "]"}]}], ";", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Fold", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ReplacePart", "[", 
           RowBox[{"#1", ",", 
            RowBox[{"Last", "[", "#2", "]"}], ",", 
            RowBox[{"First", "[", "#2", "]"}]}], "]"}], "&"}], ",", "list", 
         ",", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"nlist", ",", "a"}], "}"}], "]"}]}], "]"}], ",", 
       RowBox[{"Union", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{"nlist", "+", "na"}], "]"}], "]"}]}], "}"}]}]}], 
   "]"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GMAStep", "[", 
   RowBox[{"rules_", ",", 
    RowBox[{"{", 
     RowBox[{"list_", ",", "nlist_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a", ",", "na"}], "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"a", ",", "na"}], "}"}], "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Replace", "[", 
           RowBox[{
            RowBox[{"Take", "[", 
             RowBox[{"list", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"#", "-", "1"}], ",", 
                RowBox[{"#", "+", "1"}]}], "}"}]}], "]"}], ",", "rules"}], 
           "]"}], "&"}], ",", "nlist"}], "]"}], "]"}]}], ";", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Fold", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ReplacePart", "[", 
           RowBox[{"#1", ",", 
            RowBox[{"Last", "[", "#2", "]"}], ",", 
            RowBox[{"First", "[", "#2", "]"}]}], "]"}], "&"}], ",", "list", 
         ",", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"nlist", ",", "a"}], "}"}], "]"}]}], "]"}], ",", 
       RowBox[{"Union", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{"nlist", "+", "na"}], "]"}], "]"}]}], "}"}]}]}], 
   "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NestList", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"GMAStep", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1"}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"{", 
            RowBox[{"-", "1"}], "}"}]}], "}"}]}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0"}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"{", 
            RowBox[{"-", "1"}], "}"}]}], "}"}]}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0"}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}]}], "}"}]}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "1"}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"{", "1", "}"}]}], "}"}]}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0"}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"{", "1", "}"}]}], "}"}]}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"{", "1", "}"}]}], "}"}]}]}], "}"}], ",", "#"}], "]"}], 
    "&"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", "23", "}"}]}], "]"}], ",", 
     RowBox[{"{", "11", "}"}]}], "}"}], ",", "5"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", "11", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "12"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9", ",", "12", ",", "13"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "13", ",", "14"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7", ",", "12", ",", "14", ",", "15"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "13", ",", "15", ",", "16"}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.413572566170117*^9, 3.428239306915358*^9, 
  3.4323117091321287`*^9, 3.5002083461145163`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Turing Machines", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Implementation", "Subsection"], Cell[" (page 888)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0", ",", "1"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "1"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", 
       RowBox[{"-", "1"}]}], "}"}]}]}], "}"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TMStep", "[", 
     RowBox[{"rule_List", ",", 
      RowBox[{"{", 
       RowBox[{"s_", ",", "a_List", ",", "n_"}], "}"}]}], "]"}], "/;", 
    RowBox[{"1", "\[LessEqual]", "n", "\[LessEqual]", 
     RowBox[{"Length", "[", "a", "]"}]}]}], ":=", 
   RowBox[{"Apply", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"#1", ",", 
        RowBox[{"ReplacePart", "[", 
         RowBox[{"a", ",", "#2", ",", "n"}], "]"}], ",", 
        RowBox[{"n", "+", "#3"}]}], "}"}], "&"}], ",", 
     RowBox[{"Replace", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"s", ",", 
         RowBox[{
         "a", "\[LeftDoubleBracket]", "n", "\[RightDoubleBracket]"}]}], "}"}],
        ",", "rule"}], "]"}]}], "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"TMEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"TMStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"TMStep", "[", 
    RowBox[{"rule_List", ",", 
     RowBox[{"{", 
      RowBox[{"s_", ",", "a_List", ",", "n_"}], "}"}]}], "]"}], "/;", 
   RowBox[{"1", "\[LessEqual]", "n", "\[LessEqual]", 
    RowBox[{"Length", "[", "a", "]"}]}]}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"#1", ",", 
       RowBox[{"ReplacePart", "[", 
        RowBox[{"a", ",", "#2", ",", "n"}], "]"}], ",", 
       RowBox[{"n", "+", "#3"}]}], "}"}], "&"}], ",", 
    RowBox[{"Replace", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"s", ",", 
        RowBox[{"a", "\[LeftDoubleBracket]", "n", "\[RightDoubleBracket]"}]}],
        "}"}], ",", "rule"}], "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"TMEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"TMStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TMEvolveList", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"3", ",", "1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"2", ",", "0", ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "0"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"3", ",", "1", ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"3", ",", "0"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1", ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"Table", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", "30", "}"}]}], "]"}], ",", "15"}], "}"}], ",", "5"}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0"}], "}"}], ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0"}], "}"}], ",", "14"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0"}], "}"}], ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0"}], "}"}], ",", "16"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0"}], "}"}], ",", "17"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0"}], "}"}], ",", "18"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.413572566243401*^9, 3.428239320801367*^9, 
  3.4323117092174177`*^9, 3.5002083561475363`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"TMStep", "[", 
   RowBox[{"rule_", ",", "c_"}], "]"}], ":=", 
  RowBox[{"Replace", "[", 
   RowBox[{"c", ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a___", ",", "x_", ",", "h_List", ",", "y_", ",", "b___"}], 
      "}"}], "\[RuleDelayed]", 
     RowBox[{"Apply", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"a", ",", "x", ",", "#2", ",", 
             RowBox[{"{", 
              RowBox[{"#1", ",", "y"}], "}"}], ",", "b"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"a", ",", 
             RowBox[{"{", 
              RowBox[{"#1", ",", "x"}], "}"}], ",", "#2", ",", "y", ",", 
             "b"}], "}"}]}], "}"}], "\[LeftDoubleBracket]", "#3", 
         "\[RightDoubleBracket]"}], "&"}], ",", 
       RowBox[{"h", "/.", "\[InvisibleSpace]", "rule"}]}], "]"}]}]}], 
   "]"}]}]], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"TMEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"TMStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"TMStep", "[", 
   RowBox[{"rule_", ",", "c_"}], "]"}], ":=", 
  RowBox[{"Replace", "[", 
   RowBox[{"c", ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a___", ",", "x_", ",", "h_List", ",", "y_", ",", "b___"}], 
      "}"}], "\[RuleDelayed]", 
     RowBox[{"Apply", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"a", ",", "x", ",", "#2", ",", 
             RowBox[{"{", 
              RowBox[{"#1", ",", "y"}], "}"}], ",", "b"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"a", ",", 
             RowBox[{"{", 
              RowBox[{"#1", ",", "x"}], "}"}], ",", "#2", ",", "y", ",", 
             "b"}], "}"}]}], "}"}], "\[LeftDoubleBracket]", "#3", 
         "\[RightDoubleBracket]"}], "&"}], ",", 
       RowBox[{"h", "/.", "\[InvisibleSpace]", "rule"}]}], "]"}]}]}], 
   "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TMEvolveList", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"3", ",", "1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"2", ",", "0", ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "0"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"3", ",", "1", ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"3", ",", "0"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1", ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", "5"}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "0"}], "}"}], ",", "1", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}], ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", 
     ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "0"}], "}"}], ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", 
     ",", "1", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0"}], "}"}], ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", 
     ",", "1", ",", "1", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.413572566309721*^9, 3.428239334864666*^9, 
  3.432311709286021*^9, 3.50020836618193*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"s", "=", "1"}], ";", 
  RowBox[{
   RowBox[{"a", "[", "_", "]"}], "=", "0"}], ";", 
  RowBox[{"n", "=", "0"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"s", ",", 
        RowBox[{"a", "[", "n", "]"}], ",", "d"}], "}"}], "=", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"s", ",", 
         RowBox[{"a", "[", "n", "]"}]}], "}"}], "/.", "\[InvisibleSpace]", 
       "rule"}]}], ";", 
     RowBox[{"n", "+=", "d"}]}], ",", 
    RowBox[{"{", "t", "}"}]}], "]"}]}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "=", "5"}], ",", "a", ",", "s", ",", "n"}], "}"}], ",", 
   RowBox[{
    RowBox[{"s", "=", "1"}], ";", 
    RowBox[{
     RowBox[{"a", "[", "_", "]"}], "=", "0"}], ";", 
    RowBox[{"n", "=", "0"}], ";", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"s", ",", 
          RowBox[{"a", "[", "n", "]"}], ",", "d"}], "}"}], "=", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"s", ",", 
           RowBox[{"a", "[", "n", "]"}]}], "}"}], "/.", "\[InvisibleSpace]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0", ",", "1"}], "}"}]}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}], "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}]}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "0"}], "}"}], "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "1"}], "}"}]}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]}], "}"}]}]}], ";", 
       RowBox[{"n", "+=", "d"}]}], ",", 
      RowBox[{"{", "t", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"s", ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"a", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"-", "5"}], ",", "5"}], "}"}]}], "]"}], ",", "n"}], 
     "}"}]}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1",
      ",", "0", ",", "0", ",", "0"}], "}"}], ",", "3"}], "}"}]], "Output",
 CellChangeTimes->{3.4135725663564053`*^9, 3.4282393418334227`*^9, 
  3.432311709317883*^9, 3.5002083711337433`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Numbering scheme", "Subsection"], Cell[" (page 888)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Flatten", "[", 
  RowBox[{"MapIndexed", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}]}], "}"}], " ", "#2"}], "+", 
       RowBox[{"{", 
        RowBox[{"0", ",", "k"}], "}"}]}], "\[Rule]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "2"}], "}"}], " ", 
        RowBox[{"Mod", "[", 
         RowBox[{
          RowBox[{"Quotient", "[", 
           RowBox[{"#1", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"2", " ", "k"}], ",", "2", ",", "1"}], "}"}]}], "]"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{"s", ",", "k", ",", "2"}], "}"}]}], "]"}]}], "+", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", 
         RowBox[{"-", "1"}]}], "}"}]}]}], "&"}], ",", 
    RowBox[{"Partition", "[", 
     RowBox[{
      RowBox[{"IntegerDigits", "[", 
       RowBox[{"n", ",", 
        RowBox[{"2", " ", "s", " ", "k"}], ",", 
        RowBox[{"s", " ", "k"}]}], "]"}], ",", "k"}], "]"}], ",", 
    RowBox[{"{", "2", "}"}]}], "]"}], "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Sort", "[", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"s", "=", "2"}], ",", 
      RowBox[{"k", "=", "2"}], ",", 
      RowBox[{"n", "=", "3024"}]}], "}"}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{"MapIndexed", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"-", "1"}]}], "}"}], " ", 
           TagBox["#2",
            #& ,
            SyntaxForm->"a"]}], "+", 
          RowBox[{"{", 
           RowBox[{"0", ",", "k"}], "}"}]}], "\[Rule]", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "1", ",", "2"}], "}"}], " ", 
           RowBox[{"Mod", "[", 
            RowBox[{
             RowBox[{"Quotient", "[", 
              RowBox[{
               TagBox["#1",
                #& ,
                SyntaxForm->"a"], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"2", " ", "k"}], ",", "2", ",", "1"}], "}"}]}], 
              "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"s", ",", "k", ",", "2"}], "}"}]}], "]"}]}], "+", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]}], "&"}], ",", 
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"IntegerDigits", "[", 
          RowBox[{"n", ",", 
           RowBox[{"2", " ", "s", " ", "k"}], ",", 
           RowBox[{"s", " ", "k"}]}], "]"}], ",", "k"}], "]"}], ",", 
       RowBox[{"{", "2", "}"}]}], "]"}], "]"}]}], "]"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"2", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"2", ",", "0", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "0"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", 
      RowBox[{"-", "1"}]}], "}"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.41357256642416*^9, 3.428239353069934*^9, 
  3.4323117093543673`*^9, 3.50020837863225*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Substitution Systems", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Implementation", "Subsection"], Cell[" (page 889)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SSEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Flatten", "[", 
      RowBox[{"#", "/.", "\[InvisibleSpace]", "rule"}], "]"}], "&"}], ",", 
    "init", ",", "t"}], "]"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SSEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Flatten", "[", 
      RowBox[{"#", "/.", "\[InvisibleSpace]", "rule"}], "]"}], "&"}], ",", 
    "init", ",", "t"}], "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SSEvolveList", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"1", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}], ",", 
     RowBox[{"0", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}]}], "}"}], ",", 
   RowBox[{"{", "1", "}"}], ",", "5"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "1", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0",
      ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", 
     ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0",
      ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", 
     ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", 
     ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.4135725664928217`*^9, 3.428239372652672*^9, 
  3.4323117094368677`*^9, 3.5002083945218477`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SSEvolveList", "[", 
   RowBox[{"rule_", ",", "init_String", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"StringReplace", "[", 
      RowBox[{"#", ",", "rule"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SSEvolveList", "[", 
   RowBox[{"rule_", ",", "init_String", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"StringReplace", "[", 
      RowBox[{"#", ",", "rule"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SSEvolveList", "[", " ", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\"\<B\>\"", "\[Rule]", "\"\<BA\>\""}], ",", 
     RowBox[{"\"\<A\>\"", "\[Rule]", "\"\<AB\>\""}]}], "}"}], ",", 
   "\"\<B\>\"", ",", "5"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"B\"\>", ",", "\<\"BA\"\>", ",", "\<\"BAAB\"\>", 
   ",", "\<\"BAABABBA\"\>", ",", "\<\"BAABABBAABBABAAB\"\>", 
   ",", "\<\"BAABABBAABBABAABABBABAABBAABABBA\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.413572566615198*^9, 3.42823938464739*^9, 
  3.43231170951665*^9, 3.500208400687539*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}], "\[Rule]", 
     RowBox[{"{", "0", "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}]}], "}"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"SS2EvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{"#", ",", "2", ",", "1"}], "]"}], "/.", "\[InvisibleSpace]", 
       "rule"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}]}], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SS2EvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{"#", ",", "2", ",", "1"}], "]"}], "/.", "\[InvisibleSpace]", 
       "rule"}], "]"}], "&"}], ",", "init", ",", "t"}], "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SS2EvolveList", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], "\[Rule]", 
      RowBox[{"{", "0", "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", "3"}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1",
      ",", "1", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.413572566667883*^9, 3.428239392997512*^9, 
  3.432311709661537*^9, 3.500208407509425*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 83 \[CenterDot] Properties", "Subsection"], Cell[
     " (page 889)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"CoefficientList", "[", 
     RowBox[{
      RowBox[{"Product", "[", 
       RowBox[{
        RowBox[{"1", "-", 
         SuperscriptBox["z", 
          RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
           SuperscriptBox["2", 
            RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "s"}]]}]]}], ",", 
        RowBox[{"{", 
         RowBox[{"s", ",", "0", ",", 
          RowBox[{"m", "-", "1"}]}], "}"}]}], "]"}], ",", "z"}], "]"}], "+", 
    "1"}], ")"}], "/", "2"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"m", "=", "3"}], "}"}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"CoefficientList", "[", 
       RowBox[{
        RowBox[{"Product", "[", 
         RowBox[{
          RowBox[{"1", "-", 
           RowBox[{"z", "^", 
            RowBox[{"(", 
             RowBox[{"2", "^", "s"}], ")"}]}]}], ",", 
          RowBox[{"{", 
           RowBox[{"s", ",", "0", ",", 
            RowBox[{"m", "-", "1"}]}], "}"}]}], "]"}], ",", "z"}], "]"}], "+",
       "1"}], ")"}], "/", "2"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0"}],
   "}"}]], "Output",
 CellChangeTimes->{3.413572566742014*^9, 3.4282394028719597`*^9, 
  3.4323117097445087`*^9, 3.500208413721698*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Mod", "[", 
  RowBox[{
   RowBox[{"CoefficientList", "[", 
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"Sqrt", "[", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "-", 
              RowBox[{"3", " ", "x"}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"1", "+", "x"}], ")"}]}], "]"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"2", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", "x"}], ")"}]}], ")"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", 
         RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}], ",", "x"}], "]"}], ",", 
   "2"}], "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"n", "=", "16"}], "}"}], ",", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"CoefficientList", "[", 
      RowBox[{
       RowBox[{"Series", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"Sqrt", "[", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"3", " ", "x"}]}], ")"}], "/", 
              RowBox[{"(", 
               RowBox[{"1", "+", "x"}], ")"}]}], "]"}]}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"2", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", "x"}], ")"}]}], ")"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "0", ",", 
           RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}], ",", "x"}], "]"}], ",", 
     "2"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
   ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
   "1"}], "}"}]], "Output",
 CellChangeTimes->{3.413572567076901*^9, 3.428239410722209*^9, 
  3.4323117100652857`*^9, 3.5002084190988503`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"OddQ", "[", "n", "]"}], ",", 
   RowBox[{"Sign", "[", 
    RowBox[{"Mod", "[", 
     RowBox[{
      RowBox[{"Binomial", "[", 
       RowBox[{
        RowBox[{"n", "-", "1"}], ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"n", "-", "1"}], ")"}], "/", "2"}]}], "]"}], ",", "3"}], 
     "]"}], "]"}], ",", "0", ",", "1"}], "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"OddQ", "[", "n", "]"}], ",", 
     RowBox[{"Sign", "[", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"Binomial", "[", 
         RowBox[{
          RowBox[{"n", "-", "1"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"n", "-", "1"}], ")"}], "/", "2"}]}], "]"}], ",", "3"}], 
       "]"}], "]"}], ",", "0", ",", "1"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "1", ",", "27"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", 
   ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", 
   ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{3.428239426574595*^9, 3.432311710108735*^9, 
  3.500208422483333*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Fibonacci numbers", "Subsection"], Cell[" (page 890)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", "n_", "]"}], ":=", 
   RowBox[{
    RowBox[{"f", "[", "n", "]"}], "=", 
    RowBox[{
     RowBox[{"f", "[", 
      RowBox[{"n", "-", "1"}], "]"}], "+", 
     RowBox[{"f", "[", 
      RowBox[{"n", "-", "2"}], "]"}]}]}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"f", "[", "1", "]"}], "=", 
  RowBox[{
   RowBox[{"f", "[", "2", "]"}], "=", "1"}]}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"f", "[", "n_", "]"}], ":=", 
  RowBox[{
   RowBox[{"f", "[", "n", "]"}], "=", 
   RowBox[{
    RowBox[{"f", "[", 
     RowBox[{"n", "-", "1"}], "]"}], "+", 
    RowBox[{"f", "[", 
     RowBox[{"n", "-", "2"}], "]"}]}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"f", "[", "2", "]"}], "=", "1"}]}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"f", "[", "n", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "1", ",", "10"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "2", ",", "3", ",", "5", ",", "8", ",", "13", ",", "21",
    ",", "34", ",", "55"}], "}"}]], "Output",
 CellChangeTimes->{3.4135725671956043`*^9, 3.428239439002406*^9, 
  3.43231171018643*^9, 3.500208429528797*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a_", ",", "b_", ",", "s_"}], "}"}], ",", "0"}], "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", " ", 
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"2", " ", "b"}]}], ")"}]}], ",", 
     RowBox[{"s", "+", 
      RowBox[{"a", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "a"}], "-", "b"}], ")"}]}]}], ",", "1"}], "}"}]}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a_", ",", "b_", ",", "s_"}], "}"}], ",", "1"}], "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "s"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "+", "b"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"2", " ", "b"}]}], ")"}]}]}], ",", 
     RowBox[{"a", " ", 
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"2", " ", "b"}]}], ")"}]}], ",", 
     RowBox[{"-", "1"}]}], "}"}]}], "\n"}], "\n", 
 RowBox[{"First", "[", 
  RowBox[{"Fold", "[", 
   RowBox[{"f", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", 
      RowBox[{"-", "1"}]}], "}"}], ",", 
    RowBox[{"Rest", "[", 
     RowBox[{"IntegerDigits", "[", 
      RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}], "]"}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a_", ",", "b_", ",", "s_"}], "}"}], ",", "0"}], "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", " ", 
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"2", " ", "b"}]}], ")"}]}], ",", 
     RowBox[{"s", "+", 
      RowBox[{"a", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "a"}], "-", "b"}], ")"}]}]}], ",", "1"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a_", ",", "b_", ",", "s_"}], "}"}], ",", "1"}], "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "s"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "+", "b"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"2", " ", "b"}]}], ")"}]}]}], ",", 
     RowBox[{"a", " ", 
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"2", " ", "b"}]}], ")"}]}], ",", 
     RowBox[{"-", "1"}]}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.432311628866228*^9, 3.4323116298877563`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"First", "[", 
    RowBox[{"Fold", "[", 
     RowBox[{"f", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", 
      RowBox[{"Rest", "[", 
       RowBox[{"IntegerDigits", "[", 
        RowBox[{"n", ",", "2"}], "]"}], "]"}]}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "1", ",", "10"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "2", ",", "3", ",", "5", ",", "8", ",", "13", ",", "21",
    ",", "34", ",", "55"}], "}"}]], "Output",
 CellChangeTimes->{3.4135725672585983`*^9, 3.428239450526067*^9, 
  3.4323117102545156`*^9, 3.5002084365246696`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Flatten", "[", 
  RowBox[{
   RowBox[{"Array", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"NestList", "[", 
       RowBox[{"RotateRight", ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "#1"}]], " ", 
           "GoldenRatio"}], ",", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "#2"}]]}], "}"}], ",", 
        "3"}], "]"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2"}], "}"}]}], "]"}], ",", "2"}], 
  "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Flatten", "[", 
   RowBox[{
    RowBox[{"Array", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"NestList", "[", 
        RowBox[{"RotateRight", ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "#1"}]], " ", 
            "GoldenRatio"}], ",", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "#2"}]]}], "}"}], ",",
          "3"}], "]"}], "&"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2"}], "}"}]}], "]"}], ",", "2"}], "]"}], "//", 
  "N"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.`", ",", 
     RowBox[{"-", "1.618033988749895`"}], ",", 
     RowBox[{"-", "1.`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.`"}], ",", "0.`", ",", 
     RowBox[{"-", "1.618033988749895`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.618033988749895`"}], ",", 
     RowBox[{"-", "1.`"}], ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", 
     RowBox[{"-", "1.618033988749895`"}], ",", 
     RowBox[{"-", "1.`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", 
     RowBox[{"-", "1.618033988749895`"}], ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.`", ",", "0.`", ",", 
     RowBox[{"-", "1.618033988749895`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.618033988749895`"}], ",", "1.`", ",", "0.`"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", 
     RowBox[{"-", "1.618033988749895`"}], ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", "1.618033988749895`", ",", 
     RowBox[{"-", "1.`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.`"}], ",", "0.`", ",", "1.618033988749895`"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"1.618033988749895`", ",", 
     RowBox[{"-", "1.`"}], ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", "1.618033988749895`", ",", 
     RowBox[{"-", "1.`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", "1.618033988749895`", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.`", ",", "0.`", ",", "1.618033988749895`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.618033988749895`", ",", "1.`", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", "1.618033988749895`", ",", "1.`"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.41357256731215*^9, 3.432311710298712*^9, 
  3.500208441363327*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Connections with digit sequences", "Subsection"], Cell[
     " (page 891)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Fold", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Replace", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"#1", ",", "#2"}], "}"}], ",", "rule"}], "]"}], "&"}], ",", 
   "1", ",", 
   RowBox[{"IntegerDigits", "[", 
    RowBox[{
     RowBox[{"n", "-", "1"}], ",", "2"}], "]"}]}], "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"Fold", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Replace", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          TagBox["#1",
           #& ,
           SyntaxForm->"a"], ",", 
          TagBox["#2",
           #& ,
           SyntaxForm->"a"]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}], "\[Rule]", "0"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}], "\[Rule]", "1"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", "1"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "0"}]}], "}"}]}], 
       "]"}], "&"}], ",", "1", ",", 
     RowBox[{"IntegerDigits", "[", 
      RowBox[{
       RowBox[{"n", "-", "1"}], ",", "2"}], "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "8"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0"}],
   "}"}]], "Output",
 CellChangeTimes->{3.413572567362167*^9, 3.4282394694321623`*^9, 
  3.4323117103437843`*^9, 3.50020844627171*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Fold", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"rule", "\[LeftDoubleBracket]", 
      RowBox[{"#1", ",", "#2"}], "\[RightDoubleBracket]"}], "&"}], ",", "1", 
    ",", 
    RowBox[{
     RowBox[{"IntegerDigits", "[", 
      RowBox[{
       RowBox[{"n", "-", "1"}], ",", "k"}], "]"}], "+", "1"}]}], "]"}], "-", 
  "1"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"k", "=", "2"}], ",", 
     RowBox[{"rule", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "2"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}]}], "}"}]}]}], "}"}], ",", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Fold", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"rule", "\[LeftDoubleBracket]", 
          RowBox[{"#1", ",", "#2"}], "\[RightDoubleBracket]"}], "&"}], ",", 
        "1", ",", 
        RowBox[{
         RowBox[{"IntegerDigits", "[", 
          RowBox[{
           RowBox[{"n", "-", "1"}], ",", "k"}], "]"}], "+", "1"}]}], "]"}], 
      "-", "1"}], ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", "8"}], "}"}]}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1"}],
   "}"}]], "Output",
 CellChangeTimes->{3.413572567432021*^9, 3.4282399466549788`*^9, 
  3.4323117103926764`*^9, 3.500208450061719*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Nest", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Flatten", "[", 
      RowBox[{"rule", "\[LeftDoubleBracket]", "#", "\[RightDoubleBracket]"}], 
      "]"}], "&"}], ",", "1", ",", "m"}], "]"}], "-", "1"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"m", "=", "3"}], ",", 
     RowBox[{"rule", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "2"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}]}], "}"}]}]}], "}"}], ",", 
   RowBox[{
    RowBox[{"Nest", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{
        "rule", "\[LeftDoubleBracket]", "#", "\[RightDoubleBracket]"}], "]"}],
        "&"}], ",", "1", ",", "m"}], "]"}], "-", "1"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1"}],
   "}"}]], "Output",
 CellChangeTimes->{3.413572567496578*^9, 3.4282399557962217`*^9, 
  3.432311710442645*^9, 3.500208453317108*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 84 \[CenterDot] Other examples", "Subsection"], Cell[
     " (page 892)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"1", "-", 
  RowBox[{"Mod", "[", 
   RowBox[{
    RowBox[{"Flatten", "[", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"FoldList", "[", 
        RowBox[{"Plus", ",", "0", ",", "list"}], "]"}], ",", "1", ",", "2"}], 
      "]"}], "]"}], ",", "2"}], "]"}]}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"1", "-", 
  RowBox[{"Mod", "[", 
   RowBox[{
    RowBox[{"Flatten", "[", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"FoldList", "[", 
        RowBox[{"Plus", ",", "0", ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Mod", "[", 
            RowBox[{
             RowBox[{"IntegerExponent", "[", 
              RowBox[{"i", ",", "2"}], "]"}], ",", "2"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "15"}], "}"}]}], "]"}]}], "]"}], ",", 
       "1", ",", "2"}], "]"}], "]"}], ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5002084567494*^9, 3.500208458292852*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0"}],
   "}"}]], "Output",
 CellChangeTimes->{3.413572567546811*^9, 3.428239963132124*^9, 
  3.432311710492567*^9, 3.500208458658738*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Sequential Substitution Systems", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Implementation", "Subsection"], Cell[" (page 893)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Attributes", "[", "s", "]"}], "=", "Flat"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"s", "[", 
    RowBox[{"1", ",", "0"}], "]"}], "\[Rule]", 
   RowBox[{"s", "[", 
    RowBox[{"0", ",", "1", ",", "0"}], "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"s", "[", 
      RowBox[{"0", ",", "1", ",", "0"}], "]"}], "\[Rule]", 
     RowBox[{"s", "[", 
      RowBox[{"0", ",", "0", ",", "1"}], "]"}]}], ",", 
    RowBox[{
     RowBox[{"s", "[", "0", "]"}], "\[Rule]", 
     RowBox[{"s", "[", 
      RowBox[{"0", ",", "1", ",", "0"}], "]"}]}]}], "}"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"SSSEvolveList", "[", 
   RowBox[{"rule_", ",", "init_s", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"#", "/.", "\[InvisibleSpace]", "rule"}], "&"}], ",", "init", 
    ",", "t"}], "]"}]}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Attributes", "[", "s", "]"}], "=", "Flat"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SSSEvolveList", "[", 
   RowBox[{"rule_", ",", "init_s", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"#", "/.", "\[InvisibleSpace]", "rule"}], "&"}], ",", "init", 
    ",", "t"}], "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SSSEvolveList", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"s", "[", 
     RowBox[{"1", ",", "0"}], "]"}], "\[Rule]", 
    RowBox[{"s", "[", 
     RowBox[{"0", ",", "1", ",", "0"}], "]"}]}], ",", 
   RowBox[{"s", "[", 
    RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "]"}], ",", "3"}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"s", "[", 
    RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "]"}], ",", 
   RowBox[{"s", "[", 
    RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0"}], "]"}], ",", 
   RowBox[{"s", "[", 
    RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "]"}], 
   ",", 
   RowBox[{"s", "[", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}],
     "]"}]}], "}"}]], "Output",
 CellChangeTimes->{3.413572567732994*^9, 3.428239974862978*^9, 
  3.432311710573146*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SSSEvolveList", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"s", "[", 
       RowBox[{"0", ",", "1", ",", "0"}], "]"}], "\[Rule]", 
      RowBox[{"s", "[", 
       RowBox[{"0", ",", "0", ",", "1"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"s", "[", "0", "]"}], "\[Rule]", 
      RowBox[{"s", "[", 
       RowBox[{"0", ",", "1", ",", "0"}], "]"}]}]}], "}"}], ",", 
   RowBox[{"s", "[", 
    RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "]"}], ",", "3"}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"s", "[", 
    RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "]"}], ",", 
   RowBox[{"s", "[", 
    RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "]"}], ",", 
   RowBox[{"s", "[", 
    RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1"}], "]"}], 
   ",", 
   RowBox[{"s", "[", 
    RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], "]"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.413572567780694*^9, 3.428239976702818*^9, 
  3.432311710708634*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tag Systems", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Implementation", "Subsection"], Cell[" (page 894)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{"2", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}]}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}]}]}], "}"}]}], "}"}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{"TSEvolveList", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"n_", ",", "rule_"}], "}"}], ",", "init_", ",", "t_"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "#", "]"}], "<", "n"}], ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"Drop", "[", 
          RowBox[{"#", ",", "n"}], "]"}], ",", 
         RowBox[{
          RowBox[{"Take", "[", 
           RowBox[{"#", ",", "n"}], "]"}], "/.", "\[InvisibleSpace]", 
          "rule"}]}], "]"}]}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}]}], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TSEvolveList", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"n_", ",", "rule_"}], "}"}], ",", "init_", ",", "t_"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "#", "]"}], "<", "n"}], ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"Drop", "[", 
          RowBox[{"#", ",", "n"}], "]"}], ",", 
         RowBox[{
          RowBox[{"Take", "[", 
           RowBox[{"#", ",", "n"}], "]"}], "/.", "\[InvisibleSpace]", 
          "rule"}]}], "]"}]}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TSEvolveList", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0"}], "}"}]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", "5"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.4135725678499393`*^9, 3.428240005844688*^9, 
  3.432311710778406*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "s___"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"s", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "s___"}], "}"}], "\[Rule]", 
    RowBox[{"{", "s", "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "s___"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"s", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "s___"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"s", ",", "0", ",", "0", ",", "0"}], "}"}]}]}], 
  "}"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NestList", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"#", "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "s___"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"s", ",", "1", ",", "1"}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "s___"}], "}"}], "\[Rule]", 
        RowBox[{"{", "s", "}"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "1", ",", "s___"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"s", ",", "1", ",", "0"}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "s___"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"s", ",", "0", ",", "0", ",", "0"}], "}"}]}]}], "}"}]}], 
    "&"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", "5"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.413572567898705*^9, 3.428240018873789*^9, 
  3.43231171082885*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Cyclic Tag Systems", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Implementation", "Subsection"], Cell[" (page 895)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CTEvolveList", "[", 
    RowBox[{"rules_", ",", "init_", ",", "t_"}], "]"}], ":=", 
   RowBox[{"Map", "[", 
    RowBox[{"Last", ",", 
     RowBox[{"NestList", "[", 
      RowBox[{"CTStep", ",", 
       RowBox[{"{", 
        RowBox[{"rules", ",", "init"}], "}"}], ",", "t"}], "]"}]}], "]"}]}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"CTStep", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"r_", ",", "s___"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "a___"}], "}"}]}], "}"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"s", ",", "r"}], "}"}], ",", 
     RowBox[{"{", "a", "}"}]}], "}"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"CTStep", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"r_", ",", "s___"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "a___"}], "}"}]}], "}"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"s", ",", "r"}], "}"}], ",", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"{", "a", "}"}], ",", "r"}], "]"}]}], "}"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"CTStep", "[", 
   RowBox[{"{", 
    RowBox[{"u_", ",", 
     RowBox[{"{", "}"}]}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"u", ",", 
    RowBox[{"{", "}"}]}], "}"}]}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CTEvolveList", "[", 
   RowBox[{"rules_", ",", "init_", ",", "t_"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Last", ",", 
    RowBox[{"NestList", "[", 
     RowBox[{"CTStep", ",", 
      RowBox[{"{", 
       RowBox[{"rules", ",", "init"}], "}"}], ",", "t"}], "]"}]}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CTStep", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r_", ",", "s___"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "a___"}], "}"}]}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"s", ",", "r"}], "}"}], ",", 
    RowBox[{"{", "a", "}"}]}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"CTStep", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r_", ",", "s___"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "a___"}], "}"}]}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"s", ",", "r"}], "}"}], ",", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", "a", "}"}], ",", "r"}], "]"}]}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"CTStep", "[", 
   RowBox[{"{", 
    RowBox[{"u_", ",", 
     RowBox[{"{", "}"}]}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"u", ",", 
    RowBox[{"{", "}"}]}], "}"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CTEvolveList", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", "1", "}"}], ",", "5"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "1", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.413572567967855*^9, 3.4282400298846807`*^9, 
  3.43231171090662*^9, 3.5002085761168137`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CTList", "[", 
    RowBox[{"rules_", ",", "init_", ",", "t_"}], "]"}], ":=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"Map", "[", 
     RowBox[{"Last", ",", 
      RowBox[{"NestList", "[", 
       RowBox[{"CTListStep", ",", 
        RowBox[{"{", 
         RowBox[{"rules", ",", "init"}], "}"}], ",", "t"}], "]"}]}], "]"}], 
    "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"CTListStep", "[", 
   RowBox[{"{", 
    RowBox[{"rules_", ",", "list_"}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"RotateLeft", "[", 
     RowBox[{"rules", ",", 
      RowBox[{"Length", "[", "list", "]"}]}], "]"}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{"rules", "\[LeftDoubleBracket]", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{"Position", "[", 
          RowBox[{"list", ",", "1"}], "]"}], "]"}], ",", 
        RowBox[{"Length", "[", "rules", "]"}], ",", "1"}], "]"}], 
      "\[RightDoubleBracket]"}], "]"}]}], "}"}]}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CTList", "[", 
   RowBox[{"rules_", ",", "init_", ",", "t_"}], "]"}], ":=", 
  RowBox[{"Flatten", "[", 
   RowBox[{"Map", "[", 
    RowBox[{"Last", ",", 
     RowBox[{"NestList", "[", 
      RowBox[{"CTListStep", ",", 
       RowBox[{"{", 
        RowBox[{"rules", ",", "init"}], "}"}], ",", "t"}], "]"}]}], "]"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CTListStep", "[", 
   RowBox[{"{", 
    RowBox[{"rules_", ",", "list_"}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"RotateLeft", "[", 
     RowBox[{"rules", ",", 
      RowBox[{"Length", "[", "list", "]"}]}], "]"}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{"rules", "\[LeftDoubleBracket]", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{"Position", "[", 
          RowBox[{"list", ",", "1"}], "]"}], "]"}], ",", 
        RowBox[{"Length", "[", "rules", "]"}], ",", "1"}], "]"}], 
      "\[RightDoubleBracket]"}], "]"}]}], "}"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CTList", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", "1", "}"}], ",", "5"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
   "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
   ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
   "1"}], "}"}]], "Output",
 CellChangeTimes->{3.413572568041394*^9, 3.4282400396789627`*^9, 
  3.432311710991769*^9, 3.500208580588585*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 95 \[CenterDot] Generalizations", "Subsection"], Cell[
     " (page 895)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CTStep", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"r_", ",", "s___"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"n_", ",", "a___"}], "}"}]}], "}"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"s", ",", "r"}], "}"}], ",", 
     RowBox[{"Flatten", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"r", ",", 
          RowBox[{"{", "n", "}"}]}], "]"}]}], "}"}], "]"}]}], "}"}]}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{"CTListStep", "[", 
   RowBox[{"{", 
    RowBox[{"rules_", ",", "list_"}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"RotateLeft", "[", 
     RowBox[{"rules", ",", 
      RowBox[{"Length", "[", "list", "]"}]}], "]"}], ",", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"n", "=", 
        RowBox[{"Length", "[", "rules", "]"}]}], "}"}], ",", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Apply", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{"#1", ",", 
            RowBox[{"{", "#2", "}"}]}], "]"}], "&"}], ",", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"rules", ",", "#"}], "}"}], "]"}], "&"}], ",", 
           RowBox[{"Partition", "[", 
            RowBox[{"list", ",", "n", ",", "n", ",", "1", ",", "0"}], "]"}]}],
           "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}], "]"}]}], "]"}]}], 
   "}"}]}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CTList", "[", 
   RowBox[{"rules_", ",", "init_", ",", "t_"}], "]"}], ":=", 
  RowBox[{"Flatten", "[", 
   RowBox[{"Map", "[", 
    RowBox[{"Last", ",", 
     RowBox[{"NestList", "[", 
      RowBox[{"CTListStep", ",", 
       RowBox[{"{", 
        RowBox[{"rules", ",", "init"}], "}"}], ",", "t"}], "]"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CTStep", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r_", ",", "s___"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"n_", ",", "a___"}], "}"}]}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"s", ",", "r"}], "}"}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{"a", ",", 
       RowBox[{"Table", "[", 
        RowBox[{"r", ",", 
         RowBox[{"{", "n", "}"}]}], "]"}]}], "}"}], "]"}]}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"CTListStep", "[", 
   RowBox[{"{", 
    RowBox[{"rules_", ",", "list_"}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"RotateLeft", "[", 
     RowBox[{"rules", ",", 
      RowBox[{"Length", "[", "list", "]"}]}], "]"}], ",", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"n", "=", 
        RowBox[{"Length", "[", "rules", "]"}]}], "}"}], ",", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Apply", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{"#1", ",", 
            RowBox[{"{", "#2", "}"}]}], "]"}], "&"}], ",", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"rules", ",", "#"}], "}"}], "]"}], "&"}], ",", 
           RowBox[{"Partition", "[", 
            RowBox[{"list", ",", "n", ",", "n", ",", "1", ",", "0"}], "]"}]}],
           "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}], "]"}]}], "]"}]}], 
   "}"}]}]}], "Input",
 CellChangeTimes->{{3.5002086053374557`*^9, 3.500208611494574*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CTList", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", "1", "}"}], ",", "5"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
   "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
   ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
   "1"}], "}"}]], "Output",
 CellChangeTimes->{3.41357256809128*^9, 3.432311711075736*^9, 
  3.500208618918146*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 96 \[CenterDot] Properties", "Subsection"], Cell[
     " (page 895)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Flatten", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "0", ",", 
    RowBox[{"CTList", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], ",", "t"}], "]"}]}], "}"}], 
  "]"}]], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CTList", "[", 
   RowBox[{"rules_", ",", "init_", ",", "t_"}], "]"}], ":=", 
  RowBox[{"Flatten", "[", 
   RowBox[{"Map", "[", 
    RowBox[{"Last", ",", 
     RowBox[{"NestList", "[", 
      RowBox[{"CTListStep", ",", 
       RowBox[{"{", 
        RowBox[{"rules", ",", "init"}], "}"}], ",", "t"}], "]"}]}], "]"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CTListStep", "[", 
   RowBox[{"{", 
    RowBox[{"rules_", ",", "list_"}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"RotateLeft", "[", 
     RowBox[{"rules", ",", 
      RowBox[{"Length", "[", "list", "]"}]}], "]"}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{"rules", "\[LeftDoubleBracket]", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{"Position", "[", 
          RowBox[{"list", ",", "1"}], "]"}], "]"}], ",", 
        RowBox[{"Length", "[", "rules", "]"}], ",", "1"}], "]"}], 
      "\[RightDoubleBracket]"}], "]"}]}], "}"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"t", "=", "4"}], "}"}], ",", 
   RowBox[{"Flatten", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", 
      RowBox[{"CTList", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], ",", "t"}], "]"}]}], "}"}], "]"}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
   ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
   "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", 
   ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
   "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", 
   ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", 
   ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
   "1", ",", "0", ",", "0", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{3.413572568141917*^9, 3.428240062761653*^9, 
  3.4323117111574717`*^9, 3.500208632092143*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["History", "Subsection"], Cell[" (page 895)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Join", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"Map", "[", 
    RowBox[{"First", ",", 
     RowBox[{"CTEvolveList", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", 
         RowBox[{"{", "2", "}"}]}], "}"}], ",", 
       RowBox[{"{", "2", "}"}], ",", "t"}], "]"}]}], "]"}]}], 
  "]"}]], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CTEvolveList", "[", 
   RowBox[{"rules_", ",", "init_", ",", "t_"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Last", ",", 
    RowBox[{"NestList", "[", 
     RowBox[{"CTStep", ",", 
      RowBox[{"{", 
       RowBox[{"rules", ",", "init"}], "}"}], ",", "t"}], "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CTStep", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r_", ",", "s___"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"n_", ",", "a___"}], "}"}]}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"s", ",", "r"}], "}"}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{"a", ",", 
       RowBox[{"Table", "[", 
        RowBox[{"r", ",", 
         RowBox[{"{", "n", "}"}]}], "]"}]}], "}"}], "]"}]}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"CTListStep", "[", 
   RowBox[{"{", 
    RowBox[{"rules_", ",", "list_"}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"RotateLeft", "[", 
     RowBox[{"rules", ",", 
      RowBox[{"Length", "[", "list", "]"}]}], "]"}], ",", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"n", "=", 
        RowBox[{"Length", "[", "rules", "]"}]}], "}"}], ",", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Apply", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{"#1", ",", 
            RowBox[{"{", "#2", "}"}]}], "]"}], "&"}], ",", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"rules", ",", "#"}], "}"}], "]"}], "&"}], ",", 
           RowBox[{"Partition", "[", 
            RowBox[{"list", ",", "n", ",", "n", ",", "1", ",", "0"}], "]"}]}],
           "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}], "]"}]}], "]"}]}], 
   "}"}]}]}], "Input",
 CellChangeTimes->{{3.500208653708435*^9, 3.5002086552968407`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"t", "=", "4"}], "}"}], ",", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"Map", "[", 
      RowBox[{"First", ",", 
       RowBox[{"CTEvolveList", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "1", "}"}], ",", 
           RowBox[{"{", "2", "}"}]}], "}"}], ",", 
         RowBox[{"{", "2", "}"}], ",", "t"}], "]"}]}], "]"}]}], "]"}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "1", ",", "2", ",", "1"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.413572568208961*^9, 3.4282400723119373`*^9, 3.4323117112400513`*^9, {
   3.5002086398146563`*^9, 3.500208658931631*^9}}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Register Machines", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Implementation", "Subsection"], Cell[" (page 896)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"i", "[", "1", "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"2", ",", "1"}], "]"}], ",", 
    RowBox[{"i", "[", "2", "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"1", ",", "3"}], "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"2", ",", "1"}], "]"}]}], "}"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"RMStep", "[", 
    RowBox[{"prog_", ",", 
     RowBox[{"{", 
      RowBox[{"n_Integer", ",", "list_List"}], "}"}]}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"n", ">", 
      RowBox[{"Length", "[", "prog", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", "list"}], "}"}], ",", 
     RowBox[{"RMExecute", "[", 
      RowBox[{
       RowBox[{"prog", "\[LeftDoubleBracket]", "n", "\[RightDoubleBracket]"}],
        ",", 
       RowBox[{"{", 
        RowBox[{"n", ",", "list"}], "}"}]}], "]"}]}], "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"RMExecute", "[", 
    RowBox[{
     RowBox[{"i", "[", "r_", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"n", "+", "1"}], ",", 
     RowBox[{"MapAt", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "+", "1"}], "&"}], ",", "list", ",", "r"}], "]"}]}], 
    "}"}]}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RMExecute", "[", 
    RowBox[{
     RowBox[{"d", "[", 
      RowBox[{"r_", ",", "m_"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"list", "\[LeftDoubleBracket]", "r", "\[RightDoubleBracket]"}], 
      ">", "0"}], ",", 
     RowBox[{"{", 
      RowBox[{"m", ",", 
       RowBox[{"MapAt", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"#", "-", "1"}], "&"}], ",", "list", ",", "r"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"n", "+", "1"}], ",", "list"}], "}"}]}], "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"RMEvolveList", "[", 
   RowBox[{"prog_", ",", 
    RowBox[{"init", ":", 
     RowBox[{"{", 
      RowBox[{"_Integer", ",", "_List"}], "}"}]}], ",", "t_Integer"}], "]"}], 
  ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"RMStep", "[", 
      RowBox[{"prog", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RMStep", "[", 
   RowBox[{"prog_", ",", 
    RowBox[{"{", 
     RowBox[{"n_Integer", ",", "list_List"}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"n", ">", 
     RowBox[{"Length", "[", "prog", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "list"}], "}"}], ",", 
    RowBox[{"RMExecute", "[", 
     RowBox[{
      RowBox[{"prog", "\[LeftDoubleBracket]", "n", "\[RightDoubleBracket]"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "list"}], "}"}]}], "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"RMExecute", "[", 
   RowBox[{
    RowBox[{"i", "[", "r_", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"n", "+", "1"}], ",", 
    RowBox[{"MapAt", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "+", "1"}], "&"}], ",", "list", ",", "r"}], "]"}]}], 
   "}"}]}], "\n", 
 RowBox[{
  RowBox[{"RMExecute", "[", 
   RowBox[{
    RowBox[{"d", "[", 
     RowBox[{"r_", ",", "m_"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"list", "\[LeftDoubleBracket]", "r", "\[RightDoubleBracket]"}], 
     ">", "0"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{"MapAt", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "-", "1"}], "&"}], ",", "list", ",", "r"}], "]"}]}], 
     "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", "+", "1"}], ",", "list"}], "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"RMEvolveList", "[", 
   RowBox[{"prog_", ",", 
    RowBox[{"init", ":", 
     RowBox[{"{", 
      RowBox[{"_Integer", ",", "_List"}], "}"}]}], ",", "t_Integer"}], "]"}], 
  ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"RMStep", "[", 
      RowBox[{"prog", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.512914348785531*^9, 3.5129143495884447`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RMEvolveList", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"i", "[", "1", "]"}], ",", 
     RowBox[{"d", "[", 
      RowBox[{"2", ",", "1"}], "]"}], ",", 
     RowBox[{"i", "[", "2", "]"}], ",", 
     RowBox[{"d", "[", 
      RowBox[{"1", ",", "3"}], "]"}], ",", 
     RowBox[{"d", "[", 
      RowBox[{"2", ",", "1"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}]}], "}"}], ",", "5"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "2"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.413572568276672*^9, 3.4282400847906446`*^9, 
  3.4323117113270473`*^9, 3.500208672422662*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Halting", "Subsection"], Cell[" (page 896)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"i", "[", "1", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"2", ",", "7"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"2", ",", "1"}], "]"}], ",", 
   RowBox[{"i", "[", "2", "]"}], ",", 
   RowBox[{"i", "[", "2", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "4"}], "]"}], ",", 
   RowBox[{"i", "[", "1", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"2", ",", "3"}], "]"}]}], "}"}]], "Subsubsection"],

Cell["\<\
According to the notes, this program should take 1280 steps to halt on a \
repeating sequence. Using 
FixedPointList, the length should be 1282 counting the initial step and the \
final step repeated once.\
\>", "Text",
 CellChangeTimes->{{3.534788558515173*^9, 3.5347885616974907`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RMStep", "[", 
   RowBox[{"prog_", ",", 
    RowBox[{"{", 
     RowBox[{"n_Integer", ",", "list_List"}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"n", ">", 
     RowBox[{"Length", "[", "prog", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "list"}], "}"}], ",", 
    RowBox[{"RMExecute", "[", 
     RowBox[{
      RowBox[{"prog", "\[LeftDoubleBracket]", "n", "\[RightDoubleBracket]"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "list"}], "}"}]}], "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"RMExecute", "[", 
   RowBox[{
    RowBox[{"i", "[", "r_", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"n", "+", "1"}], ",", 
    RowBox[{"MapAt", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "+", "1"}], "&"}], ",", "list", ",", "r"}], "]"}]}], 
   "}"}]}], "\n", 
 RowBox[{
  RowBox[{"RMExecute", "[", 
   RowBox[{
    RowBox[{"d", "[", 
     RowBox[{"r_", ",", "m_"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"list", "\[LeftDoubleBracket]", "r", "\[RightDoubleBracket]"}], 
     ">", "0"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{"MapAt", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "-", "1"}], "&"}], ",", "list", ",", "r"}], "]"}]}], 
     "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", "+", "1"}], ",", "list"}], "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"RMExecute", "[", 
   RowBox[{
    RowBox[{"d", "[", 
     RowBox[{"r_", ",", "m_"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"list", "\[LeftDoubleBracket]", "r", "\[RightDoubleBracket]"}], 
     ">", "0"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{"MapAt", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "-", "1"}], "&"}], ",", "list", ",", "r"}], "]"}]}], 
     "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", "+", "1"}], ",", "list"}], "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"RMEvolveList", "[", 
   RowBox[{"prog_", ",", 
    RowBox[{"init", ":", 
     RowBox[{"{", 
      RowBox[{"_Integer", ",", "_List"}], "}"}]}], ",", "t_Integer"}], "]"}], 
  ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"RMStep", "[", 
      RowBox[{"prog", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", 
  RowBox[{"FixedPointList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"RMStep", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i", "[", "1", "]"}], ",", 
         RowBox[{"d", "[", 
          RowBox[{"2", ",", "7"}], "]"}], ",", 
         RowBox[{"d", "[", 
          RowBox[{"2", ",", "1"}], "]"}], ",", 
         RowBox[{"i", "[", "2", "]"}], ",", 
         RowBox[{"i", "[", "2", "]"}], ",", 
         RowBox[{"d", "[", 
          RowBox[{"1", ",", "4"}], "]"}], ",", 
         RowBox[{"i", "[", "1", "]"}], ",", 
         RowBox[{"d", "[", 
          RowBox[{"2", ",", "3"}], "]"}]}], "}"}], ",", "#"}], "]"}], "&"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}], "]"}], "]"}]], "Input"],

Cell[BoxData["1282"], "Output",
 CellChangeTimes->{3.413572568359859*^9, 3.42824010710567*^9, 
  3.432311711410365*^9, 3.5002086824691343`*^9, 3.512914228513729*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 101 \[CenterDot] Extended instruction sets\
\>", "Subsection"], Cell[" (page 896)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RMExecute", "[", 
    RowBox[{
     RowBox[{"eq", "[", 
      RowBox[{"r1_", ",", "r2_", ",", "m_"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"list", "\[LeftDoubleBracket]", "r1", "\[RightDoubleBracket]"}],
       "==", 
      RowBox[{
      "list", "\[LeftDoubleBracket]", "r2", "\[RightDoubleBracket]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"m", ",", "list"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"n", "+", "1"}], ",", "list"}], "}"}]}], "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"RMExecute", "[", 
    RowBox[{
     RowBox[{"add", "[", 
      RowBox[{"r1_", ",", "r2_"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"n", "+", "1"}], ",", 
     RowBox[{"ReplacePart", "[", 
      RowBox[{"list", ",", 
       RowBox[{
        RowBox[{
        "list", "\[LeftDoubleBracket]", "r1", "\[RightDoubleBracket]"}], "+", 
        RowBox[{
        "list", "\[LeftDoubleBracket]", "r2", "\[RightDoubleBracket]"}]}], 
       ",", "r1"}], "]"}]}], "}"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"RMExecute", "[", 
    RowBox[{
     RowBox[{"jmp", "[", "r1_", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"list", "\[LeftDoubleBracket]", "r1", "\[RightDoubleBracket]"}], 
     ",", "list"}], "}"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RMExecute", "[", 
    RowBox[{
     RowBox[{"i", "[", "r_", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"n", "+", "1"}], ",", 
     RowBox[{"MapAt", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "+", "1"}], "&"}], ",", "list", ",", "r"}], "]"}]}], 
    "}"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RMExecute", "[", 
   RowBox[{
    RowBox[{"d", "[", 
     RowBox[{"r_", ",", "m_"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"list", "\[LeftDoubleBracket]", "r", "\[RightDoubleBracket]"}], 
     ">", "0"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{"MapAt", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "-", "1"}], "&"}], ",", "list", ",", "r"}], "]"}]}], 
     "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", "+", "1"}], ",", "list"}], "}"}]}], 
   "]"}]}]}], "Subsubsection",
 CellChangeTimes->{{3.520259420392663*^9, 3.5202594269832163`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RMExecute", "[", 
   RowBox[{
    RowBox[{"eq", "[", 
     RowBox[{"r1_", ",", "r2_", ",", "m_"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"list", "\[LeftDoubleBracket]", "r1", "\[RightDoubleBracket]"}], 
     "==", 
     RowBox[{
     "list", "\[LeftDoubleBracket]", "r2", "\[RightDoubleBracket]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", "list"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", "+", "1"}], ",", "list"}], "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"RMExecute", "[", 
   RowBox[{
    RowBox[{"add", "[", 
     RowBox[{"r1_", ",", "r2_"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"n", "+", "1"}], ",", 
    RowBox[{"ReplacePart", "[", 
     RowBox[{"list", ",", 
      RowBox[{
       RowBox[{
       "list", "\[LeftDoubleBracket]", "r1", "\[RightDoubleBracket]"}], "+", 
       RowBox[{
       "list", "\[LeftDoubleBracket]", "r2", "\[RightDoubleBracket]"}]}], ",",
       "r1"}], "]"}]}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"RMExecute", "[", 
   RowBox[{
    RowBox[{"jmp", "[", "r1_", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"list", "\[LeftDoubleBracket]", "r1", "\[RightDoubleBracket]"}], 
    ",", "list"}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"RMExecute", "[", 
   RowBox[{
    RowBox[{"i", "[", "r_", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"n", "+", "1"}], ",", 
    RowBox[{"MapAt", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "+", "1"}], "&"}], ",", "list", ",", "r"}], "]"}]}], 
   "}"}]}], "\n", 
 RowBox[{
  RowBox[{"RMExecute", "[", 
   RowBox[{
    RowBox[{"d", "[", 
     RowBox[{"r_", ",", "m_"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"list", "\[LeftDoubleBracket]", "r", "\[RightDoubleBracket]"}], 
     ">", "0"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{"MapAt", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "-", "1"}], "&"}], ",", "list", ",", "r"}], "]"}]}], 
     "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", "+", "1"}], ",", "list"}], "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"RMEvolveList", "[", 
   RowBox[{"prog_", ",", 
    RowBox[{"init", ":", 
     RowBox[{"{", 
      RowBox[{"_Integer", ",", "_List"}], "}"}]}], ",", "t_Integer"}], "]"}], 
  ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"RMStep", "[", 
      RowBox[{"prog", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"RMStep", "[", 
   RowBox[{"prog_", ",", 
    RowBox[{"{", 
     RowBox[{"n_Integer", ",", "list_List"}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"n", ">", 
     RowBox[{"Length", "[", "prog", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "list"}], "}"}], ",", 
    RowBox[{"RMExecute", "[", 
     RowBox[{
      RowBox[{"prog", "\[LeftDoubleBracket]", "n", "\[RightDoubleBracket]"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "list"}], "}"}]}], "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.520259403147757*^9, 3.520259403721484*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"FixedPoint", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"RMStep", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"add", "[", 
          RowBox[{"1", ",", "2"}], "]"}], ",", 
         RowBox[{"eq", "[", 
          RowBox[{"2", ",", "3", ",", "99"}], "]"}], ",", 
         RowBox[{"i", "[", "2", "]"}], ",", 
         RowBox[{"jmp", "[", "4", "]"}]}], "}"}], ",", "#"}], "]"}], "&"}], 
    ",", " ", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "10", ",", "1"}], "}"}]}], "}"}]}], "]"}], 
  "[", 
  RowBox[{"[", 
   RowBox[{"2", ",", "1"}], "]"}], "]"}]], "Input"],

Cell[BoxData["55"], "Output",
 CellChangeTimes->{3.413572568409937*^9, 3.4282401290953493`*^9, 
  3.4323117114937897`*^9, 3.5002086897696657`*^9, 3.520259442859123*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Symbolic Systems", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Implementation", "Subsection"], Cell[" (page 896)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NestList", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"#", "/.", "\[InvisibleSpace]", 
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptE]", "[", "x_", "]"}], "[", "y_", "]"}], "\[Rule]", 
      RowBox[{"x", "[", 
       RowBox[{"x", "[", "y", "]"}], "]"}]}]}], "&"}], ",", "init", ",", 
   "t"}], "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NestList", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"#", "/.", "\[InvisibleSpace]", 
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptE]", "[", "x_", "]"}], "[", "y_", "]"}], "\[Rule]", 
      RowBox[{"x", "[", 
       RowBox[{"x", "[", "y", "]"}], "]"}]}]}], "&"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"\[ScriptE]", "[", 
      RowBox[{
       RowBox[{"\[ScriptE]", "[", "\[ScriptE]", "]"}], "[", "\[ScriptE]", 
       "]"}], "]"}], "[", "\[ScriptE]", "]"}], "[", "\[ScriptE]", "]"}], ",", 
   "4"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"\[ScriptE]", "[", 
      RowBox[{
       RowBox[{"\[ScriptE]", "[", "\[ScriptE]", "]"}], "[", "\[ScriptE]", 
       "]"}], "]"}], "[", "\[ScriptE]", "]"}], "[", "\[ScriptE]", "]"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[ScriptE]", "[", "\[ScriptE]", "]"}], "[", "\[ScriptE]", 
      "]"}], "[", 
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptE]", "[", "\[ScriptE]", "]"}], "[", "\[ScriptE]", 
       "]"}], "[", "\[ScriptE]", "]"}], "]"}], "[", "\[ScriptE]", "]"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"\[ScriptE]", "[", 
      RowBox[{"\[ScriptE]", "[", "\[ScriptE]", "]"}], "]"}], "[", 
     RowBox[{
      RowBox[{"\[ScriptE]", "[", 
       RowBox[{"\[ScriptE]", "[", "\[ScriptE]", "]"}], "]"}], "[", 
      "\[ScriptE]", "]"}], "]"}], "[", "\[ScriptE]", "]"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"\[ScriptE]", "[", "\[ScriptE]", "]"}], "[", 
     RowBox[{
      RowBox[{"\[ScriptE]", "[", "\[ScriptE]", "]"}], "[", 
      RowBox[{
       RowBox[{"\[ScriptE]", "[", 
        RowBox[{"\[ScriptE]", "[", "\[ScriptE]", "]"}], "]"}], "[", 
       "\[ScriptE]", "]"}], "]"}], "]"}], "[", "\[ScriptE]", "]"}], ",", 
   RowBox[{
    RowBox[{"\[ScriptE]", "[", 
     RowBox[{"\[ScriptE]", "[", 
      RowBox[{
       RowBox[{"\[ScriptE]", "[", "\[ScriptE]", "]"}], "[", 
       RowBox[{
        RowBox[{"\[ScriptE]", "[", 
         RowBox[{"\[ScriptE]", "[", "\[ScriptE]", "]"}], "]"}], "[", 
        "\[ScriptE]", "]"}], "]"}], "]"}], "]"}], "[", "\[ScriptE]", "]"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.413572568452712*^9, 3.42824013910036*^9, 
  3.4323117115530567`*^9, 3.500208695591144*^9, 3.5129142206752253`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Representations", "Subsection"], Cell[" (page 896)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Flatten", "[", 
  RowBox[{"expr", "//.", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"x_", "[", "y_", "]"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\[EmptySmallCircle]", ",", "x", ",", "y"}], "}"}]}]}], 
  "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Flatten", "[", 
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{"b", "[", 
     RowBox[{"c", "[", "d", "]"}], "]"}], "]"}], "//.", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"x_", "[", "y_", "]"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\[EmptySmallCircle]", ",", "x", ",", "y"}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.4135772431504507`*^9, 3.4135772442811613`*^9}, {
  3.432311684323834*^9, 3.432311685100275*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "\[EmptySmallCircle]", ",", "a", ",", "\[EmptySmallCircle]", ",", "b", ",", 
   "\[EmptySmallCircle]", ",", "c", ",", "d"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4135725685015087`*^9, {3.413577235009585*^9, 3.413577254061059*^9}, 
   3.428240149651636*^9, 3.432311711728589*^9, 3.50020870138314*^9, 
   3.512914210338509*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"First", "[", 
  RowBox[{
   RowBox[{"Reverse", "[", "list", "]"}], "//.", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "w___", ",", "x_", ",", "y_", ",", "\[EmptySmallCircle]", ",", "z___"}], 
     "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"w", ",", 
      RowBox[{"y", "[", "x", "]"}], ",", "z"}], "}"}]}]}], 
  "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"First", "[", 
  RowBox[{
   RowBox[{"Reverse", "[", 
    RowBox[{"{", 
     RowBox[{
     "\[EmptySmallCircle]", ",", "a", ",", "\[EmptySmallCircle]", ",", "b", 
      ",", "\[EmptySmallCircle]", ",", "c", ",", "d"}], "}"}], "]"}], "//.", 
   "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "w___", ",", "x_", ",", "y_", ",", "\[EmptySmallCircle]", ",", "z___"}], 
     "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"w", ",", 
      RowBox[{"y", "[", "x", "]"}], ",", "z"}], "}"}]}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"a", "[", 
  RowBox[{"b", "[", 
   RowBox[{"c", "[", "d", "]"}], "]"}], "]"}]], "Output",
 CellChangeTimes->{3.413572568551758*^9, 3.4135772562936172`*^9, 
  3.428240157737228*^9, 3.43231171180373*^9, 3.500208719614167*^9, 
  3.5129142140691566`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Flatten", "[", 
  RowBox[{
   RowBox[{"Characters", "[", 
    RowBox[{"ToString", "[", "expr", "]"}], "]"}], "/.", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\"\<[\>\"", "\[Rule]", "1"}], ",", 
     RowBox[{"\"\<]\>\"", "\[Rule]", "0"}], ",", 
     RowBox[{"\"\<\[ScriptE]\>\"", "\[Rule]", 
      RowBox[{"{", "}"}]}]}], "}"}]}], "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Flatten", "[", 
  RowBox[{
   RowBox[{"Characters", "[", 
    RowBox[{"ToString", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptE]", "[", 
        RowBox[{
         RowBox[{"\[ScriptE]", "[", "\[ScriptE]", "]"}], "[", "\[ScriptE]", 
         "]"}], "]"}], "[", "\[ScriptE]", "]"}], "[", "\[ScriptE]", "]"}], 
     "]"}], "]"}], "/.", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\"\<[\>\"", "\[Rule]", "1"}], ",", 
     RowBox[{"\"\<]\>\"", "\[Rule]", "0"}], ",", 
     RowBox[{"\"\<\[ScriptE]\>\"", "\[Rule]", 
      RowBox[{"{", "}"}]}]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", 
   ",", "1", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.413572568603011*^9, 3.428240166810829*^9, 
  3.4323117118499537`*^9, 3.500208727859622*^9, 3.512914217551236*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Possible expressions", "Subsection"], Cell[" (page 897)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", 
    RowBox[{"s_", ",", "1"}], "]"}], "=", "s"}], ";", 
  RowBox[{
   RowBox[{"c", "[", 
    RowBox[{"s_", ",", "n_"}], "]"}], ":=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Outer", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "[", "#2", "]"}], "&"}], ",", 
        RowBox[{"c", "[", 
         RowBox[{"s", ",", 
          RowBox[{"n", "-", "m"}]}], "]"}], ",", 
        RowBox[{"c", "[", 
         RowBox[{"s", ",", "m"}], "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"m", ",", 
        RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}], "]"}]}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", 
    RowBox[{"s_", ",", "1"}], "]"}], "=", "s"}], ";", 
  RowBox[{
   RowBox[{"c", "[", 
    RowBox[{"s_", ",", "n_"}], "]"}], ":=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Outer", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "[", "#2", "]"}], "&"}], ",", 
        RowBox[{"c", "[", 
         RowBox[{"s", ",", 
          RowBox[{"n", "-", "m"}]}], "]"}], ",", 
        RowBox[{"c", "[", 
         RowBox[{"s", ",", "m"}], "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"m", ",", 
        RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}], "]"}]}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b"}], "}"}], ",", "3"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "[", "a", "]"}], "[", "a", "]"}], ",", 
   RowBox[{
    RowBox[{"a", "[", "a", "]"}], "[", "b", "]"}], ",", 
   RowBox[{
    RowBox[{"a", "[", "b", "]"}], "[", "a", "]"}], ",", 
   RowBox[{
    RowBox[{"a", "[", "b", "]"}], "[", "b", "]"}], ",", 
   RowBox[{
    RowBox[{"b", "[", "a", "]"}], "[", "a", "]"}], ",", 
   RowBox[{
    RowBox[{"b", "[", "a", "]"}], "[", "b", "]"}], ",", 
   RowBox[{
    RowBox[{"b", "[", "b", "]"}], "[", "a", "]"}], ",", 
   RowBox[{
    RowBox[{"b", "[", "b", "]"}], "[", "b", "]"}], ",", 
   RowBox[{"a", "[", 
    RowBox[{"a", "[", "a", "]"}], "]"}], ",", 
   RowBox[{"a", "[", 
    RowBox[{"a", "[", "b", "]"}], "]"}], ",", 
   RowBox[{"a", "[", 
    RowBox[{"b", "[", "a", "]"}], "]"}], ",", 
   RowBox[{"a", "[", 
    RowBox[{"b", "[", "b", "]"}], "]"}], ",", 
   RowBox[{"b", "[", 
    RowBox[{"a", "[", "a", "]"}], "]"}], ",", 
   RowBox[{"b", "[", 
    RowBox[{"a", "[", "b", "]"}], "]"}], ",", 
   RowBox[{"b", "[", 
    RowBox[{"b", "[", "a", "]"}], "]"}], ",", 
   RowBox[{"b", "[", 
    RowBox[{"b", "[", "b", "]"}], "]"}]}], "}"}]], "Output",
 CellChangeTimes->{3.4135725687548018`*^9, 3.428240175795949*^9, 
  3.4323117119456377`*^9, 3.500208734136901*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", 
  RowBox[{"c", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a", ",", "b", ",", "c"}], "}"}], ",", "5"}], "]"}], 
  "]"}]], "Input"],

Cell[BoxData["3402"], "Output",
 CellChangeTimes->{3.413572568803358*^9, 3.428240177269219*^9, 
  3.432311712004827*^9, 3.5002087357627897`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 103 \[CenterDot] Properties", "Subsection"], Cell[
     " (page 897)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FoldList", "[", 
  RowBox[{"Plus", ",", "0", ",", 
   RowBox[{"Flatten", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"IntegerExponent", "[", 
             RowBox[{"i", ",", "2"}], "]"}], "+", "1"}], "}"}]}], "]"}]}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "m"}], "}"}]}], "]"}], "]"}]}], 
  "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Take", "[", 
  RowBox[{
   RowBox[{"FoldList", "[", 
    RowBox[{"Plus", ",", "0", ",", 
     RowBox[{"Flatten", "[", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"IntegerExponent", "[", 
               RowBox[{"i", ",", "2"}], "]"}], "+", "1"}], "}"}]}], "]"}]}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1024"}], "}"}]}], "]"}], "]"}]}], "]"}], ",", 
   RowBox[{"-", "20"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "10", ",", "11", ",", "10", ",", "9", ",", "10", ",", "11", ",", "10", ",", 
   "11", ",", "12", ",", "11", ",", "10", ",", "9", ",", "8", ",", "7", ",", 
   "6", ",", "5", ",", "4", ",", "3", ",", "2", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{3.413572568854569*^9, 3.4282401963101177`*^9, 
  3.432311712073235*^9, 3.5002087405175962`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Order dependence", "Subsection"], Cell[" (page 898)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Module", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"i", "=", "1"}], "}"}], ",", 
   RowBox[{"expr", "/.", "\[InvisibleSpace]", 
    RowBox[{"lhs", "\[RuleDelayed]", 
     RowBox[{"rhs", "/;", 
      RowBox[{
       RowBox[{"i", "++"}], "==", "1"}]}]}]}]}], "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Module", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"i", "=", "1"}], "}"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"foo", ",", "foo", ",", "foo"}], "}"}], "/.", 
    "\[InvisibleSpace]", 
    RowBox[{"foo", "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"Bar", "[", "foo", "]"}], "/;", 
      RowBox[{
       RowBox[{"i", "++"}], "==", "1"}]}]}]}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Bar", "[", "foo", "]"}], ",", "foo", ",", "foo"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.413572568906843*^9, 3.428240200270608*^9, 
  3.432311712138575*^9, 3.500208745019327*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.538498899745914*^9, 3.538498902766322*^9}}]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{699, 852},
WindowMargins->{{31, Automatic}, {Automatic, 4}},
CellContext->CellGroup,
Magnification->1.,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 5, \
2011)",
StyleDefinitions->Notebook[{
   Cell[
    CellGroupData[{
      Cell["Style Definitions for NKS Webcode", "Subtitle"], 
      Cell[
      "Modify the definitions below to change the default appearance of all \
cells in a given style.  Make modifications to any definition using commands \
in the Format menu.", "Text"], 
      Cell[
       CellGroupData[{
         Cell["Style Environment Names", "Section"], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{12, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 9], 
         Cell[
          StyleData[All, "Presentation"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{24, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 12], 
         Cell[
          StyleData[All, "Condensed"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{8, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 8], 
         Cell[
          StyleData[All, "Printout"], PageWidth -> PaperWidth, 
          CellLabelMargins -> {{2, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 5, 
          PrivateFontOptions -> {"FontType" -> "Outline"}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Notebook Options", "Section"], 
         Cell[
         "The options defined for the style below will be used at the \
Notebook level.", "Text"], 
         Cell[
          StyleData["Notebook"], PageHeaders -> {{
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"], None, 
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"]}, {
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"], None, 
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"]}}, CellFrameLabelMargins -> 
          6, StyleMenuListing -> None]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headings", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Title"], ShowCellBracket -> False, 
             CellMargins -> {{36, 6}, {20, 3}}, 
             CellGroupingRules -> {"TitleGrouping", 0}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
             "NaturalLanguage", CounterIncrements -> "Title", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}, {"Subtitle", 0}, {"Subsubtitle", 0}}, FontSize -> 
             36], 
            Cell[
             StyleData["Title", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 40}}, LineSpacing -> {1, 0}, 
             FontSize -> 44], 
            Cell[
             StyleData["Title", "Condensed"], 
             CellMargins -> {{8, 10}, {4, 8}}, FontSize -> 20], 
            Cell[
             StyleData["Title", "Printout"], 
             CellMargins -> {{2, 10}, {12, 30}}, FontSize -> 24]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["TitleHeader"], CellFrame -> {{0, 0}, {0.25, 0}}, 
             ShowCellBracket -> False, 
             CellMargins -> {{36, Inherited}, {3, 25}}, 
             CellGroupingRules -> {"TitleGrouping", 20}, PageBreakBelow -> 
             False, CellFrameMargins -> {{8, 8}, {4, 8}}, 
             DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
             "NaturalLanguage", FontSize -> 14], 
            Cell[
             StyleData["TitleHeader", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 20}}, LineSpacing -> {1, 0}, 
             FontSize -> 24], 
            Cell[
             StyleData["TitleHeader", "Condensed"], 
             CellMargins -> {{8, 10}, {8, 8}}, FontSize -> 12], 
            Cell[
             StyleData["TitleHeader", "Printout"], 
             CellMargins -> {{2, 10}, {12, 8}}, FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subtitle"], 
             CellMargins -> {{12, Inherited}, {20, 15}}, 
             CellGroupingRules -> {"TitleGrouping", 10}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subtitle", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}, {"Subsubtitle", 0}}, FontFamily -> "Helvetica", 
             FontSize -> 24], 
            Cell[
             StyleData["Subtitle", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 20}}, LineSpacing -> {1, 0}, 
             FontSize -> 36], 
            Cell[
             StyleData["Subtitle", "Condensed"], 
             CellMargins -> {{8, 10}, {4, 4}}, FontSize -> 14], 
            Cell[
             StyleData["Subtitle", "Printout"], 
             CellMargins -> {{2, 10}, {12, 8}}, FontSize -> 18]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellFrame -> {{0, 0}, {0.25, 0}}, 
             ShowCellBracket -> False, ShowGroupOpener -> True, 
             CellMargins -> {{36, 3}, {8, 20}}, 
             CellGroupingRules -> {"SectionGrouping", 30}, PageBreakBelow -> 
             False, 
             CellFrameMargins -> {{Inherited, Inherited}, {4, Inherited}}, 
             CellFrameColor -> GrayLevel[0.6], DefaultNewInlineCellStyle -> 
             "None", InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Section", 
             CounterAssignments -> {{"Subsection", 0}, {"Subsubsection", 0}}, 
             FontFamily -> "Helvetica", FontSize -> 18], 
            Cell[
             StyleData["Section", "Presentation"], 
             CellMargins -> {{40, 10}, {11, 32}}, LineSpacing -> {1, 0}, 
             FontSize -> 24], 
            Cell[
             StyleData["Section", "Condensed"], 
             CellMargins -> {{18, Inherited}, {6, 12}}, FontSize -> 12], 
            Cell[
             StyleData["Section", "Printout"], 
             CellMargins -> {{13, 0}, {7, 22}}, FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], ShowCellBracket -> False, 
             ShowGroupOpener -> True, CellMargins -> {{50, 6}, {8, 20}}, 
             CellGroupingRules -> {"SectionGrouping", 40}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subsection", CounterAssignments -> {{"Subsubsection", 0}}, 
             FontFamily -> "Helvetica", FontSize -> 14, FontWeight -> "Bold", 
             GridBoxOptions -> {
              GridBoxAlignment -> {
                "Columns" -> {Left, {Right}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Baseline}}, "RowsIndexed" -> {}}, 
               GridBoxItemSize -> {"Columns" -> {
                   Scaled[0.8], {
                    Scaled[0.2]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
                 "RowsIndexed" -> {}}}], 
            Cell[
             StyleData["Subsection", "Presentation"], 
             CellMargins -> {{36, 10}, {11, 32}}, LineSpacing -> {1, 0}, 
             FontSize -> 22], 
            Cell[
             StyleData["Subsection", "Condensed"], 
             CellMargins -> {{16, Inherited}, {6, 12}}, FontSize -> 12], 
            Cell[
             StyleData["Subsection", "Printout"], 
             CellMargins -> {{9, 0}, {7, 22}}, FontSize -> 12]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsection"], CellFrame -> 2, ShowCellBracket -> 
             False, ShowGroupOpener -> True, 
             CellMargins -> {{70, 2}, {8, 18}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             Evaluatable -> False, 
             CellGroupingRules -> {"SectionGrouping", 50}, PageBreakBelow -> 
             False, CellFrameColor -> RGBColor[1, 0.730007, 0.360006], 
             DefaultFormatType -> DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
             FormatType -> InputForm, ShowStringCharacters -> True, 
             NumberMarks -> True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1},
              CounterIncrements -> "Subsubsection", FontWeight -> "Bold", 
             Background -> RGBColor[1, 0.970001, 0.840009]], 
            Cell[
             StyleData["Subsubsection", "Presentation"], 
             CellMargins -> {{34, 10}, {11, 26}}, LineSpacing -> {1, 0}, 
             FontSize -> 18], 
            Cell[
             StyleData["Subsubsection", "Condensed"], 
             CellMargins -> {{17, Inherited}, {6, 12}}, FontSize -> 10], 
            Cell[
             StyleData["Subsubsection", "Printout"], 
             CellMargins -> {{9, 0}, {7, 14}}, FontSize -> 11]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["TitleCell1"], ShowCellBracket -> False, 
             CellMargins -> {{0, 0}, {20, 0}}, 
             CellFrameMargins -> {{-1, 0}, {-1, -1}}, Hyphenation -> True, 
             StyleMenuListing -> None, FontSize -> 2, Magnification -> 1, 
             Background -> GrayLevel[0.2]], 
            Cell[
             StyleData["TitleCell1", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, FontSize -> 16], 
            Cell[
             StyleData["TitleCell1", "Condensed"], 
             CellMargins -> {{8, 10}, {6, 6}}, FontSize -> 11], 
            Cell[
             StyleData["TitleCell1", "Printout"], 
             CellMargins -> {{2, 2}, {6, 6}}, TextJustification -> 0.5, 
             FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["TitleCell2"], ShowCellBracket -> False, 
             CellMargins -> {{12, 10}, {-3, 7}}, Hyphenation -> True, 
             StyleMenuListing -> None, Background -> GrayLevel[0.98999]], 
            Cell[
             StyleData["TitleCell2", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, FontSize -> 16], 
            Cell[
             StyleData["TitleCell2", "Condensed"], 
             CellMargins -> {{8, 10}, {6, 6}}, FontSize -> 11], 
            Cell[
             StyleData["TitleCell2", "Printout"], 
             CellMargins -> {{2, 2}, {6, 6}}, TextJustification -> 0.5, 
             FontSize -> 10]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Body Text", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Text"], CellMargins -> {{80, 10}, {7, 7}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             Hyphenation -> True, LineSpacing -> {1, 3}, CounterIncrements -> 
             "Text"], 
            Cell[
             StyleData["Text", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 16], 
            Cell[
             StyleData["Text", "Condensed"], CellMargins -> {{8, 10}, {6, 6}},
              LineSpacing -> {1, 1}, FontSize -> 11], 
            Cell[
             StyleData["Text", "Printout"], CellMargins -> {{2, 2}, {6, 6}}, 
             TextJustification -> 0.5, FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SmallText"], CellMargins -> {{12, 10}, {6, 6}}, 
             DefaultNewInlineCellStyle -> "None", Hyphenation -> True, 
             LineSpacing -> {1, 3}, LanguageCategory -> "NaturalLanguage", 
             CounterIncrements -> "SmallText", FontFamily -> "Helvetica", 
             FontSize -> 9], 
            Cell[
             StyleData["SmallText", "Presentation"], 
             CellMargins -> {{24, 10}, {8, 8}}, LineSpacing -> {1, 5}, 
             FontSize -> 12], 
            Cell[
             StyleData["SmallText", "Condensed"], 
             CellMargins -> {{8, 10}, {5, 5}}, LineSpacing -> {1, 2}, 
             FontSize -> 9], 
            Cell[
             StyleData["SmallText", "Printout"], 
             CellMargins -> {{2, 2}, {5, 5}}, TextJustification -> 0.5, 
             FontSize -> 7]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Input/Output", "Section"], 
         Cell[
         "The cells in this section define styles used for input and output \
to the kernel.  Be careful when modifying, renaming, or removing these \
styles, because the front end associates special meanings with these style \
names. Some attributes for these styles are actually set in FormatType Styles \
(in the last section of this stylesheet). ", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Input"], CellMargins -> {{80, 10}, {5, 7}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             Evaluatable -> True, CellGroupingRules -> "InputGrouping", 
             CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, DefaultFormatType -> 
             DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
             FormatType -> InputForm, ShowStringCharacters -> True, 
             NumberMarks -> True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1},
              CounterIncrements -> "Input", FontWeight -> "Bold"], 
            Cell[
             StyleData["Input", "Presentation"], 
             CellMargins -> {{72, Inherited}, {8, 10}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["Input", "Condensed"], 
             CellMargins -> {{40, 10}, {2, 3}}, FontSize -> 11], 
            Cell[
             StyleData["Input", "Printout"], CellMargins -> {{39, 0}, {4, 6}},
              LinebreakAdjustments -> {0.85, 2, 10, 1, 1}, FontSize -> 9]}, 
           Closed]], 
         Cell[
          StyleData["InputOnly"], Evaluatable -> True, CellGroupingRules -> 
          "InputGrouping", CellHorizontalScrolling -> True, DefaultFormatType -> 
          DefaultInputFormatType, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
          FormatType -> InputForm, ShowStringCharacters -> True, NumberMarks -> 
          True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, 
          CounterIncrements -> "Input", StyleMenuListing -> None, FontWeight -> 
          "Bold"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Output"], CellMargins -> {{80, 10}, {7, 5}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             CellEditDuplicate -> True, CellGroupingRules -> "OutputGrouping",
              CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, DefaultFormatType -> 
             DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Output"], 
            Cell[
             StyleData["Output", "Presentation"], 
             CellMargins -> {{72, Inherited}, {10, 8}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["Output", "Condensed"], 
             CellMargins -> {{41, Inherited}, {3, 2}}, FontSize -> 11], 
            Cell[
             StyleData["Output", "Printout"], 
             CellMargins -> {{39, 0}, {6, 4}}, FontSize -> 9]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Message"], 
             CellMargins -> {{80, Inherited}, {Inherited, Inherited}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             CellGroupingRules -> "OutputGrouping", PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             DefaultFormatType -> DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Message", StyleMenuListing -> 
             None, FontSize -> 11, FontColor -> RGBColor[0, 0, 1]], 
            Cell[
             StyleData["Message", "Presentation"], 
             CellMargins -> {{72, Inherited}, {Inherited, Inherited}}, 
             LineSpacing -> {1, 0}, FontSize -> 16], 
            Cell[
             StyleData["Message", "Condensed"], 
             CellMargins -> {{41, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 11], 
            Cell[
             StyleData["Message", "Printout"], 
             CellMargins -> {{39, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 7, FontColor -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Print"], 
             CellMargins -> {{80, Inherited}, {Inherited, Inherited}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, ShowCellLabel -> 
             False, DefaultFormatType -> DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Print", StyleMenuListing -> 
             None], 
            Cell[
             StyleData["Print", "Presentation"], 
             CellMargins -> {{72, Inherited}, {Inherited, Inherited}}, 
             LineSpacing -> {1, 0}, FontSize -> 16], 
            Cell[
             StyleData["Print", "Condensed"], 
             CellMargins -> {{41, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 11], 
            Cell[
             StyleData["Print", "Printout"], 
             CellMargins -> {{39, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 8]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Graphics"], 
             CellMargins -> {{80, Inherited}, {Inherited, Inherited}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             CellGroupingRules -> "GraphicsGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             DefaultFormatType -> DefaultOutputFormatType, LanguageCategory -> 
             None, FormatType -> InputForm, CounterIncrements -> "Graphics", 
             ImageMargins -> {{43, Inherited}, {Inherited, 0}}, 
             StyleMenuListing -> None, FontFamily -> "Courier", FontSize -> 
             10], 
            Cell[
             StyleData["Graphics", "Presentation"], 
             ImageMargins -> {{62, Inherited}, {Inherited, 0}}], 
            Cell[
             StyleData["Graphics", "Condensed"], 
             ImageMargins -> {{38, Inherited}, {Inherited, 0}}, Magnification -> 
             0.6], 
            Cell[
             StyleData["Graphics", "Printout"], 
             ImageMargins -> {{30, Inherited}, {Inherited, 0}}, Magnification -> 
             0.8]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["CellLabel"], LanguageCategory -> None, 
             StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 
             9, FontColor -> RGBColor[0, 0, 1]], 
            Cell[
             StyleData["CellLabel", "Presentation"], FontSize -> 12], 
            Cell[
             StyleData["CellLabel", "Condensed"], FontSize -> 9], 
            Cell[
             StyleData["CellLabel", "Printout"], FontFamily -> "Courier", 
             FontSize -> 8, FontSlant -> "Italic", FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["FrameLabel"], LanguageCategory -> None, 
             StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 
             9], 
            Cell[
             StyleData["FrameLabel", "Presentation"], FontSize -> 12], 
            Cell[
             StyleData["FrameLabel", "Condensed"], FontSize -> 9], 
            Cell[
             StyleData["FrameLabel", "Printout"], FontFamily -> "Courier", 
             FontSize -> 8, FontSlant -> "Italic", FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Inline Formatting", "Section"], 
         Cell[
         "These styles are for modifying individual words or letters in a \
cell exclusive of the cell tag.", "Text"], 
         Cell[
          StyleData["RM"], StyleMenuListing -> None, FontWeight -> "Plain", 
          FontSlant -> "Plain"], 
         Cell[
          StyleData["BF"], StyleMenuListing -> None, FontWeight -> "Bold"], 
         Cell[
          StyleData["IT"], StyleMenuListing -> None, FontSlant -> "Italic"], 
         Cell[
          StyleData["TR"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["TI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["TB"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["TBI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["MR"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["MO"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["MB"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["MBO"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["SR"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["SO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["SB"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["SBO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SO10"], StyleMenuListing -> None, FontFamily -> 
             "Helvetica", FontSize -> 10, FontWeight -> "Plain", FontSlant -> 
             "Italic"], 
            Cell[
             StyleData["SO10", "Printout"], StyleMenuListing -> None, 
             FontFamily -> "Helvetica", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"], 
            Cell[
             StyleData["SO10", "EnhancedPrintout"], StyleMenuListing -> None, 
             FontFamily -> "Futura", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Hyperlink Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making hypertext \
ButtonBoxes.  The \"Hyperlink\" style is for links within the same Notebook, \
or between Notebooks.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Hyperlink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonNote -> 
               ButtonData}], 
            Cell[
             StyleData["Hyperlink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["Hyperlink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["Hyperlink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headers and Footers", "Section"], 
         Cell[
          StyleData["Header"], CellMargins -> {{0, 0}, {4, 1}}, 
          DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
          "NaturalLanguage", StyleMenuListing -> None, FontSize -> 10, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["Footer"], CellMargins -> {{0, 0}, {0, 4}}, 
          DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
          "NaturalLanguage", StyleMenuListing -> None, FontSize -> 9, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["PageNumber"], CellMargins -> {{0, 0}, {4, 1}}, 
          StyleMenuListing -> None, FontFamily -> "Times", FontSize -> 10]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Palette Styles", "Section"], 
         Cell[
         "The cells below define styles that define standard ButtonFunctions, \
for use in palette buttons.", "Text"], 
         Cell[
          StyleData["Paste"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, After]}]& )}], 
         Cell[
          StyleData["Evaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["EvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionMove[
                FrontEnd`InputNotebook[], All, Cell, 1], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Placeholder Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making placeholder objects \
in palette templates.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Placeholder"], Placeholder -> True, StyleMenuListing -> 
             None, FontSlant -> "Italic", FontColor -> 
             RGBColor[0.890623, 0.864698, 0.384756], 
             TagBoxOptions -> {
              Editable -> False, Selectable -> False, StripWrapperBoxes -> 
               False}], 
            Cell[
             StyleData["Placeholder", "Presentation"]], 
            Cell[
             StyleData["Placeholder", "Condensed"]], 
            Cell[
             StyleData["Placeholder", "Printout"]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["PrimaryPlaceholder"], StyleMenuListing -> None, 
             DrawHighlighted -> True, FontSlant -> "Italic", Background -> 
             RGBColor[0.912505, 0.891798, 0.507774], 
             TagBoxOptions -> {
              Editable -> False, Selectable -> False, StripWrapperBoxes -> 
               False}], 
            Cell[
             StyleData["PrimaryPlaceholder", "Presentation"]], 
            Cell[
             StyleData["PrimaryPlaceholder", "Condensed"]], 
            Cell[
             StyleData["PrimaryPlaceholder", "Printout"]]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["FormatType Styles", "Section"], 
         Cell[
         "The cells below define styles that are mixed in with the styles of \
most cells.  If a cell's FormatType matches the name of one of the styles \
defined below, then that style is applied between the cell's style and its \
own options. This is particularly true of Input and Output.", "Text"], 
         Cell[
          StyleData["CellExpression"], PageWidth -> Infinity, 
          CellMargins -> {{6, Inherited}, {Inherited, Inherited}}, 
          ShowCellLabel -> False, ShowSpecialCharacters -> False, 
          AllowInlineCells -> False, Hyphenation -> False, 
          AutoItalicWords -> {}, StyleMenuListing -> None, FontFamily -> 
          "Courier", FontSize -> 12, Background -> GrayLevel[1]], 
         Cell[
          StyleData["InputForm"], InputAutoReplacements -> {}, 
          AllowInlineCells -> False, Hyphenation -> False, StyleMenuListing -> 
          None, FontFamily -> "Courier"], 
         Cell[
          StyleData["OutputForm"], PageWidth -> Infinity, TextAlignment -> 
          Left, LineSpacing -> {0.6, 1}, StyleMenuListing -> None, FontFamily -> 
          "Courier"], 
         Cell[
          StyleData["StandardForm"], 
          InputAutoReplacements -> {
           "->" -> "\[Rule]", ":>" -> "\[RuleDelayed]", "<=" -> 
            "\[LessEqual]", ">=" -> "\[GreaterEqual]", "!=" -> "\[NotEqual]", 
            "==" -> "\[Equal]", Inherited}, LineSpacing -> {1.25, 0}, 
          StyleMenuListing -> None, FontFamily -> "Courier"], 
         Cell[
          StyleData["TraditionalForm"], 
          InputAutoReplacements -> {
           "->" -> "\[Rule]", ":>" -> "\[RuleDelayed]", "<=" -> 
            "\[LessEqual]", ">=" -> "\[GreaterEqual]", "!=" -> "\[NotEqual]", 
            "==" -> "\[Equal]", Inherited}, LineSpacing -> {1.25, 0}, 
          SingleLetterItalics -> True, TraditionalFunctionNotation -> True, 
          DelimiterMatching -> None, StyleMenuListing -> None], 
         Cell[
         "The style defined below is mixed in to any cell that is in an \
inline cell within another.", "Text"], 
         Cell[
          StyleData["InlineCell"], LanguageCategory -> "Formula", ScriptLevel -> 
          1, StyleMenuListing -> None], 
         Cell[
          StyleData["InlineCellEditing"], StyleMenuListing -> None, 
          Background -> RGBColor[1, 0.749996, 0.8]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Automatic Styles", "Section"], 
         Cell[
         "The cells below define styles that are used to affect the display \
of certain types of objects in typeset expressions.  For example, \
\"UnmatchedBracket\" style defines how unmatched bracket, curly bracket, and \
parenthesis characters are displayed (typically by coloring them to make them \
stand out).", "Text"], 
         Cell[
          StyleData["UnmatchedBracket"], StyleMenuListing -> None, FontColor -> 
          RGBColor[0.760006, 0.330007, 0.8]]}, Closed]]}, Open]]}, Visible -> 
  False, FrontEndVersion -> 
  "8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 5, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[1235, 30, 1845, 38, 25, "TitleCell1"],
Cell[3083, 70, 234, 7, 24, "Text"],
Cell[3320, 79, 42, 0, 46, "TitleHeader"],
Cell[CellGroupData[{
Cell[3387, 83, 45, 0, 59, "Title"],
Cell[CellGroupData[{
Cell[3457, 87, 41, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[3523, 91, 129, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[3677, 98, 928, 28, 84, "Subsubsection"],
Cell[CellGroupData[{
Cell[4630, 130, 1122, 33, 90, "Input"],
Cell[5755, 165, 194, 4, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6010, 176, 143, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[6178, 183, 422, 11, 64, "Subsubsection"],
Cell[6603, 196, 414, 11, 30, "Input"],
Cell[CellGroupData[{
Cell[7042, 211, 619, 18, 50, "Input"],
Cell[7664, 231, 659, 13, 106, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8384, 251, 170, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[8579, 259, 550, 17, 74, "Subsubsection"],
Cell[9132, 278, 542, 17, 40, "Input"],
Cell[CellGroupData[{
Cell[9699, 299, 944, 27, 70, "Input"],
Cell[10646, 328, 664, 14, 106, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11371, 349, 173, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[11569, 357, 1075, 33, 119, "Subsubsection"],
Cell[12647, 392, 1466, 44, 100, "Input"],
Cell[CellGroupData[{
Cell[14138, 440, 528, 15, 40, "Input"],
Cell[14669, 457, 633, 13, 106, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[15363, 477, 159, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[15547, 485, 591, 20, 89, "Subsubsection"],
Cell[CellGroupData[{
Cell[16163, 509, 1310, 39, 55, "Input"],
Cell[17476, 550, 960, 18, 186, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18509, 576, 34, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[18568, 580, 135, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[18728, 587, 2524, 82, 149, "Subsubsection"],
Cell[21255, 671, 1069, 34, 85, "Input"],
Cell[CellGroupData[{
Cell[22349, 709, 1662, 54, 55, "Input"],
Cell[24014, 765, 1730, 46, 100, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[25793, 817, 3070, 99, 135, "Subsubsection"],
Cell[28866, 918, 1430, 45, 85, "Input"],
Cell[CellGroupData[{
Cell[30321, 967, 2195, 70, 70, "Input"],
Cell[32519, 1039, 1732, 46, 100, "Output"]
}, Open  ]],
Cell[34266, 1088, 26, 0, 24, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[34341, 1094, 172, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[34538, 1102, 1409, 43, 119, "Subsubsection"],
Cell[35950, 1147, 1401, 43, 85, "Input"],
Cell[CellGroupData[{
Cell[37376, 1194, 2267, 69, 85, "Input"],
Cell[39646, 1265, 2653, 64, 115, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[42372, 1337, 34, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[42431, 1341, 135, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[42591, 1348, 2147, 68, 149, "Subsubsection"],
Cell[44741, 1418, 1046, 31, 70, "Input"],
Cell[CellGroupData[{
Cell[45812, 1453, 1301, 42, 55, "Input"],
Cell[47116, 1497, 2820, 58, 160, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[49985, 1561, 952, 27, 75, "Subsubsection"],
Cell[50940, 1590, 1235, 36, 85, "Input"],
Cell[CellGroupData[{
Cell[52200, 1630, 1555, 45, 70, "Input"],
Cell[53758, 1677, 2671, 55, 145, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[56478, 1738, 582, 19, 44, "Subsubsection"],
Cell[CellGroupData[{
Cell[57085, 1761, 2294, 66, 100, "Input"],
Cell[59382, 1829, 350, 8, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[59793, 1844, 137, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[59955, 1851, 1182, 36, 104, "Subsubsection"],
Cell[CellGroupData[{
Cell[61162, 1891, 1657, 50, 85, "Input"],
Cell[62822, 1943, 816, 26, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[63711, 1977, 39, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[63775, 1981, 135, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[63935, 1988, 337, 9, 58, "Subsubsection"],
Cell[64275, 1999, 329, 9, 40, "Input"],
Cell[CellGroupData[{
Cell[64629, 2012, 345, 11, 24, "Input"],
Cell[64977, 2025, 1076, 25, 55, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[66102, 2056, 322, 9, 60, "Subsubsection"],
Cell[66427, 2067, 314, 9, 40, "Input"],
Cell[CellGroupData[{
Cell[66766, 2080, 262, 7, 24, "Input"],
Cell[67031, 2089, 335, 6, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[67415, 2101, 1044, 34, 90, "Subsubsection"],
Cell[68462, 2137, 413, 11, 40, "Input"],
Cell[CellGroupData[{
Cell[68900, 2152, 780, 26, 40, "Input"],
Cell[69683, 2180, 596, 15, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[70340, 2202, 158, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[70523, 2210, 554, 16, 70, "Subsubsection"],
Cell[CellGroupData[{
Cell[71102, 2230, 591, 19, 24, "Input"],
Cell[71696, 2251, 254, 6, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[71999, 2263, 768, 24, 60, "Subsubsection"],
Cell[CellGroupData[{
Cell[72792, 2291, 911, 28, 55, "Input"],
Cell[73706, 2321, 339, 7, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[74094, 2334, 420, 13, 44, "Subsubsection"],
Cell[CellGroupData[{
Cell[74539, 2351, 552, 17, 40, "Input"],
Cell[75094, 2370, 427, 8, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[75582, 2385, 138, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[75745, 2392, 417, 14, 89, "Subsubsection"],
Cell[76165, 2408, 403, 14, 40, "Input"],
Cell[CellGroupData[{
Cell[76593, 2426, 170, 5, 24, "Input"],
Cell[76766, 2433, 276, 6, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[77091, 2445, 1384, 48, 105, "Subsubsection"],
Cell[78478, 2495, 1149, 40, 40, "Input"],
Cell[CellGroupData[{
Cell[79652, 2539, 441, 13, 24, "Input"],
Cell[80096, 2554, 281, 6, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[80426, 2566, 750, 23, 70, "Subsubsection"],
Cell[CellGroupData[{
Cell[81201, 2593, 787, 24, 50, "Input"],
Cell[81991, 2619, 1928, 55, 85, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[83980, 2681, 159, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[84164, 2689, 335, 11, 58, "Subsubsection"],
Cell[CellGroupData[{
Cell[84524, 2704, 1087, 35, 55, "Input"],
Cell[85614, 2741, 253, 6, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[85916, 2753, 375, 12, 44, "Subsubsection"],
Cell[CellGroupData[{
Cell[86316, 2769, 856, 28, 40, "Input"],
Cell[87175, 2799, 254, 6, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[87478, 2811, 260, 7, 44, "Subsubsection"],
Cell[CellGroupData[{
Cell[87763, 2822, 604, 20, 24, "Input"],
Cell[88370, 2844, 252, 6, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[88683, 2857, 162, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[88870, 2865, 315, 9, 58, "Subsubsection"],
Cell[CellGroupData[{
Cell[89210, 2878, 675, 18, 85, "Input"],
Cell[89888, 2898, 250, 6, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[90211, 2912, 50, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[90286, 2916, 135, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[90446, 2923, 941, 29, 149, "Subsubsection"],
Cell[91390, 2954, 383, 11, 40, "Input"],
Cell[CellGroupData[{
Cell[91798, 2969, 328, 10, 24, "Input"],
Cell[92129, 2981, 547, 14, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[92713, 3000, 531, 16, 40, "Input"],
Cell[93247, 3018, 525, 14, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[93845, 3040, 30, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[93900, 3044, 135, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[94060, 3051, 1434, 47, 104, "Subsubsection"],
Cell[95497, 3100, 710, 22, 40, "Input"],
Cell[CellGroupData[{
Cell[96232, 3126, 852, 27, 55, "Input"],
Cell[97087, 3155, 568, 16, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[97704, 3177, 697, 22, 60, "Subsubsection"],
Cell[CellGroupData[{
Cell[98426, 3203, 936, 28, 55, "Input"],
Cell[99365, 3233, 565, 16, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[100003, 3257, 37, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[100065, 3261, 135, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[100225, 3268, 1404, 49, 149, "Subsubsection"],
Cell[101632, 3319, 1306, 46, 85, "Input"],
Cell[CellGroupData[{
Cell[102963, 3369, 277, 9, 24, "Input"],
Cell[103243, 3380, 576, 15, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[103868, 3401, 1044, 30, 120, "Subsubsection"],
Cell[104915, 3433, 1007, 29, 85, "Input"],
Cell[CellGroupData[{
Cell[105947, 3466, 271, 9, 24, "Input"],
Cell[106221, 3477, 495, 9, 40, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[106777, 3493, 163, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[106965, 3501, 1636, 52, 149, "Subsubsection"],
Cell[108604, 3555, 2030, 62, 130, "Input"],
Cell[CellGroupData[{
Cell[110659, 3621, 271, 9, 24, "Input"],
Cell[110933, 3632, 470, 9, 40, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[111464, 3648, 158, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[111647, 3656, 467, 14, 58, "Subsubsection"],
Cell[112117, 3672, 1007, 29, 85, "Input"],
Cell[CellGroupData[{
Cell[113149, 3705, 587, 18, 24, "Input"],
Cell[113739, 3725, 841, 13, 55, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[114641, 3745, 128, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[114794, 3752, 424, 14, 58, "Subsubsection"],
Cell[115221, 3768, 1992, 61, 130, "Input"],
Cell[CellGroupData[{
Cell[117238, 3833, 544, 18, 24, "Input"],
Cell[117785, 3853, 271, 6, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[118129, 3867, 36, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[118190, 3871, 135, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[118350, 3878, 2430, 80, 224, "Subsubsection"],
Cell[120783, 3960, 2032, 67, 115, "Input"],
Cell[CellGroupData[{
Cell[122840, 4031, 515, 16, 24, "Input"],
Cell[123358, 4049, 840, 28, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[124259, 4084, 128, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[124412, 4091, 472, 14, 58, "Subsubsection"],
Cell[124887, 4107, 297, 6, 41, "Text"],
Cell[125187, 4115, 2608, 88, 145, "Input"],
Cell[CellGroupData[{
Cell[127820, 4207, 839, 25, 70, "Input"],
Cell[128662, 4234, 165, 2, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[128888, 4243, 176, 5, 46, "Subsection"],
Cell[CellGroupData[{
Cell[129089, 4252, 2807, 89, 224, "Subsubsection"],
Cell[131899, 4343, 3514, 114, 190, "Input"],
Cell[CellGroupData[{
Cell[135438, 4461, 680, 22, 40, "Input"],
Cell[136121, 4485, 168, 2, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[136362, 4495, 35, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[136422, 4499, 135, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[136582, 4506, 348, 10, 58, "Subsubsection"],
Cell[CellGroupData[{
Cell[136955, 4520, 554, 16, 24, "Input"],
Cell[137512, 4538, 1749, 46, 40, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[139322, 4591, 136, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[139483, 4598, 261, 7, 58, "Subsubsection"],
Cell[CellGroupData[{
Cell[139769, 4609, 459, 12, 24, "Input"],
Cell[140231, 4623, 372, 8, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[140652, 4637, 395, 12, 44, "Subsubsection"],
Cell[CellGroupData[{
Cell[141072, 4653, 553, 16, 24, "Input"],
Cell[141628, 4671, 273, 6, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[141950, 4683, 401, 10, 44, "Subsubsection"],
Cell[CellGroupData[{
Cell[142376, 4697, 625, 17, 24, "Input"],
Cell[143004, 4716, 295, 6, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[143360, 4729, 141, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[143526, 4736, 688, 22, 74, "Subsubsection"],
Cell[144217, 4760, 680, 22, 40, "Input"],
Cell[CellGroupData[{
Cell[144922, 4786, 126, 4, 24, "Input"],
Cell[145051, 4792, 1272, 36, 40, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[146360, 4833, 175, 6, 24, "Input"],
Cell[146538, 4841, 144, 2, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[146743, 4850, 159, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[146927, 4858, 574, 18, 74, "Subsubsection"],
Cell[CellGroupData[{
Cell[147526, 4880, 673, 20, 70, "Input"],
Cell[148202, 4902, 389, 7, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[148652, 4916, 137, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[148814, 4923, 309, 9, 58, "Subsubsection"],
Cell[CellGroupData[{
Cell[149148, 4936, 404, 13, 24, "Input"],
Cell[149555, 4951, 234, 6, 24, "Output"]
}, Open  ]],
Cell[149804, 4960, 92, 1, 24, "Input"]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

(* NotebookSignature Zvp0Be1L2LKEVD1or9rftlDy *)
