(* Content-type: application/vnd.wolfram.cdf.text *)

(*** Wolfram CDF File ***)
(* http://www.wolfram.com/cdf *)

(* CreatedBy='Mathematica 8.0' *)

(*************************************************************************)
(*                                                                       *)
(*  The Mathematica License under which this file was created prohibits  *)
(*  restricting third parties in receipt of this file from republishing  *)
(*  or redistributing it by any means, including but not limited to      *)
(*  rights management or terms of use, without the express consent of    *)
(*  Wolfram Research, Inc.                                               *)
(*                                                                       *)
(*************************************************************************)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       835,         17]
NotebookDataLength[    327135,      10150]
NotebookOptionsPosition[    273871,       8821]
NotebookOutlinePosition[    310997,       9604]
CellTagsIndexPosition[    310954,       9601]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {
    ButtonBox[Cell[GraphicsData["CompressedBitmap", "\<\
eJzVWL1uFDEQduzd2/wgISEkRHco0NGlAN0DAAXcC1CdIqSkQKAkokjDC9Aj
UoBESUt5LW9AR5UHiQ782fPtzXq9l70lKKLwrj3jmfHOfPaM98Xs5ODV69nJ
4f5s/PRo9vbgcP94/OTNkSe5DWPML9/ujA36v31XHlPz6ebuB7O3t2fMuv0t
9M3I/Dh5H3ps3x4/M9+fv6zCoAzsxcVF3TAuA8+Znx+/BBpGhdAwBj2O2rRR
eFYwUctTL8eFzNRyaMJ3YjBh2/BdpTk9PTXn5+dmsViY+XxuptOpnwzeKPRB
Aw8N8zzNBbYzZ2dngYwRRbQ6vEVlISIgQwwjm6EVmVXhDX5PE2CDhcWXPdSl
HynqSmHr1aHJR7vM4scRKpsSR8QMTv/64JH/1jYGSoktaXjruOJd/AV2iDtA
lLixsBCm9ULNTouNL4TH6Cl6Fv3okyrwQaOnMYdzc9hxSeQw12Jkg4oYIvof
TZyei4GTsFE/7WLslV1iqmqZ4rfobXGJbroHYjYwXQ0+rWYossoGQkCJCAMl
oo7BsgkCMN8liAIvpQ1BGWU/330Y59neKOs8m3Qw6HS6B85nYBj0NHgiExxu
dYgmk0mIHN45f+eOJpuENwY2HlqJ4U5bW5062sjTH6htc7cNh1Glkgo9z4OK
fYseMcCsVsfWP9FnJroK/OTm0e6Sti6SdIDUts05p1pxMulUU4RnTEM9DyWb
qAYUqk7VrqE6XVYq2zz4cssfDpHtRkQ1VBAZwse/04D9f0CxAhQmBsldubql
Eyhh2xeyqcFhHFcdJ71w0ql581rQMZKAEAEsivG2UpPiMFGoYaSuOxW1Kxpt
ncmUH2WX0HB1yo+5aVgWUiIIFVXrmpX5QJvTVdcyZ6yXR7rsXX1O2mmtnfU1
9Wlb9zSmqkbgdThAt8l2B/7cwCraJRimHGBga9CIEI87oo5CmZI6FYtT4p7Q
6/J2FLrK2oVSTDagMLSg1oW6ldk6NHJqgVQ2FKelas+Kt8vO9npqVhbOYbmR
W9Wz0dK1C67KJGTLNBQxw22PxlS1xEz/Gz3xpG/pTdyW9biNzT43/Corj/2h
z93kBwXzGiEku463W15+9eV4jRs+g+nPlrQcZSgkNCOBed+LvdJ8o4foykt8
1VoUf3SAFm9+rpECJc/tSGSZy9Bu9UxQ9/GUn0fjfy1zO+4M76F3w6Xj7Qpp
gm44vkxZs4zy22d3zdUUDcz7/m7GBdwaOseThreW6fMvz2z8AbMc9mc=\
\>"], "Graphics",
      Evaluatable->False,
      GeneratedCell->False,
      CellAutoOverwrite->False,
      ImageSize->{218, 23},
      ImageMargins->{{0, 0}, {0, 0}},
      ImageRegion->{{0, 1}, {0, 1}}],
     Active->True,
     Appearance->{Automatic, None},
     BaseStyle->"Hyperlink",
     ButtonData:>{
       URL["http://www.wolframscience.com"], None},
     ButtonNote->"A New Kind of Science"]}
  }]], "TitleCell1",
 CellMargins->{{Inherited, Inherited}, {0, Inherited}}],

Cell[TextData[{
 "From: ",
 StyleBox["A New Kind of Science",
  FontSlant->"Italic"],
 ", by Stephen Wolfram \[Copyright] 2002 Stephen Wolfram, LLC"
}], "Text",
 ShowCellBracket->False,
 CellMargins->{{36, Inherited}, {Inherited, 5}}],

Cell["NOTES FOR CHAPTER 12", "TitleHeader"],

Cell[CellGroupData[{

Cell["The Principle of Computational Equivalence", "Title"],

Cell[CellGroupData[{

Cell["The Validity of the Principle", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 729 \[CenterDot] Continuum and cardinality\
\>", "Subsection"], Cell[" (page 1127)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Rest", "[", 
  RowBox[{"FoldList", "[", 
   RowBox[{"Plus", ",", "1", ",", 
    RowBox[{"ContinuedFraction", "[", "x", "]"}]}], "]"}], 
  "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", "=", 
     RowBox[{"11", "/", "13"}]}], "}"}], ",", 
   RowBox[{"Rest", "[", 
    RowBox[{"FoldList", "[", 
     RowBox[{"Plus", ",", "1", ",", 
      RowBox[{"ContinuedFraction", "[", "x", "]"}]}], "]"}], "]"}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "7", ",", "9"}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", "=", 
     RowBox[{"Sqrt", "[", "2", "]"}]}], "}"}], ",", 
   RowBox[{"Rest", "[", 
    RowBox[{"FoldList", "[", 
     RowBox[{"Plus", ",", "1", ",", 
      RowBox[{"ContinuedFraction", "[", "x", "]"}]}], "]"}], "]"}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", 
   RowBox[{"{", "4", "}"}]}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", "=", 
         RowBox[{"Sqrt", "[", "n", "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Rest", "[", 
        RowBox[{"FoldList", "[", 
         RowBox[{"Plus", ",", "1", ",", 
          RowBox[{"ContinuedFraction", "[", "x", "]"}]}], "]"}], "]"}]}], 
      "]"}], "//", "Last"}], "//", "Length"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "1", ",", "100"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "2", ",", "0", ",", "1", ",", "2", ",", "4", ",", "2", 
   ",", "0", ",", "1", ",", "2", ",", "2", ",", "5", ",", "4", ",", "2", ",", 
   "0", ",", "1", ",", "2", ",", "6", ",", "2", ",", "6", ",", "6", ",", "4", 
   ",", "2", ",", "0", ",", "1", ",", "2", ",", "4", ",", "5", ",", "2", ",", 
   "8", ",", "4", ",", "4", ",", "4", ",", "2", ",", "0", ",", "1", ",", "2", 
   ",", "2", ",", "2", ",", "3", ",", "2", ",", "10", ",", "8", ",", "6", ",",
    "12", ",", "4", ",", "2", ",", "0", ",", "1", ",", "2", ",", "6", ",", 
   "5", ",", "6", ",", "4", ",", "2", ",", "6", ",", "7", ",", "6", ",", "4", 
   ",", "11", ",", "4", ",", "2", ",", "0", ",", "1", ",", "2", ",", "10", 
   ",", "2", ",", "8", ",", "6", ",", "8", ",", "2", ",", "7", ",", "5", ",", 
   "4", ",", "12", ",", "6", ",", "4", ",", "4", ",", "2", ",", "0", ",", "1",
    ",", "2", ",", "2", ",", "5", ",", "10", ",", "2", ",", "6", ",", "5", 
   ",", "2", ",", "8", ",", "8", ",", "10", ",", "16", ",", "4", ",", "4", 
   ",", "11", ",", "4", ",", "2", ",", "0"}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Position", "[", 
  RowBox[{"%", ",", "0"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "1", "}"}], ",", 
   RowBox[{"{", "4", "}"}], ",", 
   RowBox[{"{", "9", "}"}], ",", 
   RowBox[{"{", "16", "}"}], ",", 
   RowBox[{"{", "25", "}"}], ",", 
   RowBox[{"{", "36", "}"}], ",", 
   RowBox[{"{", "49", "}"}], ",", 
   RowBox[{"{", "64", "}"}], ",", 
   RowBox[{"{", "81", "}"}], ",", 
   RowBox[{"{", "100", "}"}]}], "}"}]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Emulating discrete systems", "Subsection"], Cell[
     " (page 1129)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Mod", "[", 
    RowBox[{"x", ",", "3"}], "]"}], "\[LongLeftRightArrow]", "1"}], "+", 
  RowBox[{
   RowBox[{"2", "/", "3"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Cos", "[", 
      RowBox[{
       RowBox[{"2", "/", "3"}], " ", "\[Pi]", " ", 
       RowBox[{"(", 
        RowBox[{"x", "-", "2"}], ")"}]}], "]"}], "-", 
     RowBox[{"Cos", "[", 
      RowBox[{
       RowBox[{"2", " ", "\[Pi]", " ", "x"}], "/", "3"}], "]"}]}], 
    ")"}]}]}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"1", "+", 
    RowBox[{
     RowBox[{
      AdjustmentBox["2",
       BoxMargins->{{0, -0.111111}, {0, 0}}], "/", 
      AdjustmentBox["3",
       BoxMargins->{{-0.222222, 0}, {0, 0}}]}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Cos", "[", 
        RowBox[{
         RowBox[{
          AdjustmentBox["2",
           BoxMargins->{{0, -0.111111}, {0, 0}}], "/", 
          AdjustmentBox["3",
           BoxMargins->{{-0.222222, 0}, {0, 0}}]}], " ", "\[Pi]", " ", 
         RowBox[{"(", 
          RowBox[{"x", "-", "2"}], ")"}]}], "]"}], "-", 
       RowBox[{"Cos", "[", 
        RowBox[{
         AdjustmentBox[
          RowBox[{"2", " ", "\[Pi]", " ", "x"}],
          BoxMargins->{{0, -0.111111}, {0, 0}}], "/", 
         AdjustmentBox["3",
          BoxMargins->{{-0.222222, 0}, {0, 0}}]}], "]"}]}], ")"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "2", ",", "0", ",", "1", ",", "2", ",", "0", ",", "1", 
   ",", "2", ",", "0", ",", "1"}], "}"}]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Mod", "[", 
    RowBox[{"x", ",", "4"}], "]"}], "\[LongLeftRightArrow]", 
   RowBox[{"(", 
    RowBox[{"3", "-", 
     RowBox[{"2", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{
        RowBox[{"\[Pi]", " ", "x"}], "/", "2"}], "]"}]}], "-", 
     RowBox[{"Cos", "[", 
      RowBox[{"\[Pi]", " ", "x"}], "]"}], "-", 
     RowBox[{"2", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{
        RowBox[{"\[Pi]", " ", "x"}], "/", "2"}], "]"}]}]}], ")"}]}], "/", 
  "2"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"3", "-", 
      RowBox[{"2", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"\[Pi]", " ", 
         RowBox[{"x", "/", "2"}]}], "]"}]}], "-", 
      RowBox[{"Cos", "[", 
       RowBox[{"\[Pi]", " ", "x"}], "]"}], "-", 
      RowBox[{"2", " ", 
       RowBox[{"Sin", "[", 
        RowBox[{"\[Pi]", " ", 
         RowBox[{"x", "/", "2"}]}], "]"}]}]}], ")"}], "/", "2"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5347719299459457`*^9, 3.5347719365656843`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "2", ",", "3", ",", "0", ",", "1", ",", "2", ",", "3", 
   ",", "0", ",", "1", ",", "2"}], "}"}]], "Output",
 CellChangeTimes->{3.534771940412587*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Mod", "[", 
   RowBox[{"x", ",", "n"}], "]"}], "\[LongLeftRightArrow]", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{"j", " ", 
     RowBox[{"Product", "[", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Sin", "[", 
           RowBox[{
            RowBox[{"\[Pi]", " ", 
             RowBox[{"(", 
              RowBox[{"x", "-", "i", "-", "j"}], ")"}]}], "/", "n"}], "]"}], 
          "/", 
          RowBox[{"Sin", "[", 
           RowBox[{
            RowBox[{"\[Pi]", " ", "i"}], "/", "n"}], "]"}]}], ")"}], 
        RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "2"}]], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", 
      RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}]}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"n", "=", "7"}], "}"}], ",", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{"j", " ", 
         RowBox[{"Product", "[", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              AdjustmentBox[
               RowBox[{"Sin", "[", 
                RowBox[{
                 AdjustmentBox[
                  RowBox[{"\[Pi]", " ", 
                   RowBox[{"(", 
                    RowBox[{"x", "-", "i", "-", "j"}], ")"}]}],
                  BoxMargins->{{0, -0.111111}, {0, 0}}], "/", 
                 AdjustmentBox["n",
                  BoxMargins->{{-0.222222, 0}, {0, 0}}]}], "]"}],
               BoxMargins->{{0, -0.111111}, {0, 0}}], "/", 
              AdjustmentBox[
               RowBox[{"Sin", "[", 
                RowBox[{
                 AdjustmentBox[
                  RowBox[{"\[Pi]", " ", "i"}],
                  BoxMargins->{{0, -0.111111}, {0, 0}}], "/", 
                 AdjustmentBox["n",
                  BoxMargins->{{-0.222222, 0}, {0, 0}}]}], "]"}],
               BoxMargins->{{-0.222222, 0}, {0, 0}}]}], ")"}], 
            RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "2"}]], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", 
          RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", "12"}], "}"}]}], "]"}]}], "]"}], "//", 
  "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.534771986528458*^9, 3.53477198672677*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "0", 
   ",", "1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}]], "Output",
 CellChangeTimes->{3.53477199022465*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Computational Irreducibility", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 744 \[CenterDot] Reducible systems", "Subsection"], Cell[
     " (page 1134)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Flatten", "[", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"w", "=", 
      RowBox[{"Max", "[", 
       RowBox[{"Ceiling", "[", 
        RowBox[{"Log", "[", 
         RowBox[{"2", ",", 
          RowBox[{"{", 
           RowBox[{"t", ",", "x"}], "}"}]}], "]"}], "]"}], "]"}]}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"2", " ", 
        RowBox[{"Reverse", "[", 
         RowBox[{"IntegerDigits", "[", 
          RowBox[{"t", ",", "2", ",", "w"}], "]"}], "]"}]}], "+", "1"}], ",", 
      "5", ",", 
      RowBox[{
       RowBox[{"2", " ", 
        RowBox[{"IntegerDigits", "[", 
         RowBox[{"x", ",", "2", ",", "w"}], "]"}]}], "+", "2"}]}], "}"}]}], 
   "]"}], "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "=", "49"}], ",", 
     RowBox[{"x", "=", "33"}]}], "}"}], ",", 
   RowBox[{"Flatten", "[", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"w", "=", 
        RowBox[{"Max", "[", 
         RowBox[{"Ceiling", "[", 
          RowBox[{"Log", "[", 
           RowBox[{"2", ",", 
            RowBox[{"{", 
             RowBox[{"t", ",", "x"}], "}"}]}], "]"}], "]"}], "]"}]}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"2", "\[ThinSpace]", 
          RowBox[{"Reverse", "[", 
           RowBox[{"IntegerDigits", "[", 
            RowBox[{"t", ",", "2", ",", "w"}], "]"}], "]"}]}], "+", "1"}], 
        ",", "5", ",", 
        RowBox[{
         RowBox[{"2", "\[ThinSpace]", 
          RowBox[{"IntegerDigits", "[", 
           RowBox[{"x", ",", "2", ",", "w"}], "]"}]}], "+", "2"}]}], "}"}]}], 
     "]"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "3", ",", "1", ",", "1", ",", "1", ",", "3", ",", "3", ",", "5", ",", "4", 
   ",", "2", ",", "2", ",", "2", ",", "2", ",", "4"}], "}"}]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", ":", 
       RowBox[{"(", 
        RowBox[{"1", "|", "3"}], ")"}]}], ",", 
      RowBox[{"1", "|", "3"}], ",", "_"}], "}"}], "\[Rule]", "a"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", 
      RowBox[{"2", "|", "4"}], ",", 
      RowBox[{"a", ":", 
       RowBox[{"(", 
        RowBox[{"2", "|", "4"}], ")"}]}]}], "}"}], "\[Rule]", "a"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", 
      RowBox[{"5", "|", "10"}], ",", "2"}], "}"}], "\[Rule]", "6"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"5", "|", "7"}], ",", "4"}], "}"}], "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "5", ",", "4"}], "}"}], "\[Rule]", "7"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "6", ",", "2"}], "}"}], "\[Rule]", "10"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"6", "|", "11"}], ",", "4"}], "}"}], "\[Rule]", "8"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", 
      RowBox[{"6", "|", "8", "|", "10", "|", "11"}], ",", "4"}], "}"}], 
    "\[Rule]", "9"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", 
      RowBox[{"7", "|", "9"}], ",", "2"}], "}"}], "\[Rule]", "11"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"8", "|", "11"}], ",", "2"}], "}"}], "\[Rule]", "9"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "11", ",", "2"}], "}"}], "\[Rule]", "8"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"9", "|", "10"}], ",", "4"}], "}"}], "\[Rule]", "11"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", 
      RowBox[{"a_", "/;", 
       RowBox[{"a", ">", "4"}]}], ",", "_"}], "}"}], "\[Rule]", "a"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "_", ",", "_"}], "}"}], "\[Rule]", "0"}]}], 
  "}"}]], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CAEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CAStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"GeneralCARule", "[", 
     RowBox[{"rule_", ",", 
      RowBox[{"r_Integer", ":", "1"}]}], "]"}], ",", "a_List"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Partition", "[", 
    RowBox[{"a", ",", 
     RowBox[{
      RowBox[{"2", " ", "r"}], "+", "1"}], ",", "1", ",", 
     RowBox[{"r", "+", "1"}]}], "]"}], "/.", "\[InvisibleSpace]", 
   "rule"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "=", "49"}], ",", 
     RowBox[{"x", "=", "33"}]}], "}"}], ",", 
   RowBox[{"CAEvolveList", "[", 
    RowBox[{
     RowBox[{"GeneralCARule", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"a", ":", 
            RowBox[{"(", 
             RowBox[{"1", "|", "3"}], ")"}]}], ",", 
           RowBox[{"1", "|", "3"}], ",", "_"}], "}"}], "\[Rule]", "a"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", 
           RowBox[{"2", "|", "4"}], ",", 
           RowBox[{"a", ":", 
            RowBox[{"(", 
             RowBox[{"2", "|", "4"}], ")"}]}]}], "}"}], "\[Rule]", "a"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3", ",", 
           RowBox[{"5", "|", "10"}], ",", "2"}], "}"}], "\[Rule]", "6"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"5", "|", "7"}], ",", "4"}], "}"}], "\[Rule]", "0"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3", ",", "5", ",", "4"}], "}"}], "\[Rule]", "7"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "6", ",", "2"}], "}"}], "\[Rule]", "10"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"6", "|", "11"}], ",", "4"}], "}"}], "\[Rule]", "8"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3", ",", 
           RowBox[{"6", "|", "8", "|", "10", "|", "11"}], ",", "4"}], "}"}], 
         "\[Rule]", "9"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3", ",", 
           RowBox[{"7", "|", "9"}], ",", "2"}], "}"}], "\[Rule]", "11"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"8", "|", "11"}], ",", "2"}], "}"}], "\[Rule]", "9"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3", ",", "11", ",", "2"}], "}"}], "\[Rule]", "8"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"9", "|", "10"}], ",", "4"}], "}"}], "\[Rule]", "11"}], 
        ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", 
           RowBox[{"a_", "/;", 
            RowBox[{"a", ">", "4"}]}], ",", "_"}], "}"}], "\[Rule]", "a"}], 
        ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_", ",", "_"}], "}"}], "\[Rule]", "0"}]}], "}"}],
       "]"}], ",", 
     RowBox[{"Flatten", "[", 
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"w", "=", 
          RowBox[{"Max", "[", 
           RowBox[{"Ceiling", "[", 
            RowBox[{"Log", "[", 
             RowBox[{"2", ",", 
              RowBox[{"{", 
               RowBox[{"t", ",", "x"}], "}"}]}], "]"}], "]"}], "]"}]}], "}"}],
         ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"2", "\[ThinSpace]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"IntegerDigits", "[", 
              RowBox[{"t", ",", "2", ",", "w"}], "]"}], "]"}]}], "+", "1"}], 
          ",", "5", ",", 
          RowBox[{
           RowBox[{"2", "\[ThinSpace]", 
            RowBox[{"IntegerDigits", "[", 
             RowBox[{"x", ",", "2", ",", "w"}], "]"}]}], "+", "2"}]}], 
         "}"}]}], "]"}], "]"}], ",", "10"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "3", ",", "1", ",", "1", ",", "1", ",", "3", ",", "3", ",", "5", ",", "4",
      ",", "2", ",", "2", ",", "2", ",", "2", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "3", ",", "1", ",", "1", ",", "1", ",", "3", ",", "7", ",", "2",
      ",", "2", ",", "2", ",", "2", ",", "4", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "3", ",", "1", ",", "1", ",", "1", ",", "11", ",", 
     "2", ",", "2", ",", "2", ",", "4", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "3", ",", "1", ",", "1", ",", "9", ",", "2",
      ",", "2", ",", "4", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "3", ",", "1", ",", "9", ",", "2",
      ",", "4", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "3", ",", "9", ",", "4",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "9", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "9", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "9", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "9", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "9", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
  "}"}]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", ":", 
       RowBox[{"(", 
        RowBox[{"1", "|", "3"}], ")"}]}], ",", 
      RowBox[{"1", "|", "3"}], ",", "_"}], "}"}], "\[Rule]", "a"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", 
      RowBox[{"2", "|", "4"}], ",", 
      RowBox[{"a", ":", 
       RowBox[{"(", 
        RowBox[{"2", "|", "4"}], ")"}]}]}], "}"}], "\[Rule]", "a"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "5", ",", "4"}], "}"}], "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "5", ",", "_"}], "}"}], "\[Rule]", "5"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "_", ",", "_"}], "}"}], "\[Rule]", "0"}]}], 
  "}"}]], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CAEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CAStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"GeneralCARule", "[", 
     RowBox[{"rule_", ",", 
      RowBox[{"r_Integer", ":", "1"}]}], "]"}], ",", "a_List"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Partition", "[", 
    RowBox[{"a", ",", 
     RowBox[{
      RowBox[{"2", " ", "r"}], "+", "1"}], ",", "1", ",", 
     RowBox[{"r", "+", "1"}]}], "]"}], "/.", "\[InvisibleSpace]", 
   "rule"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "=", "49"}], ",", 
     RowBox[{"x", "=", "33"}]}], "}"}], ",", 
   RowBox[{"CAEvolveList", "[", 
    RowBox[{
     RowBox[{"GeneralCARule", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"a", ":", 
            RowBox[{"(", 
             RowBox[{"1", "|", "3"}], ")"}]}], ",", 
           RowBox[{"1", "|", "3"}], ",", "_"}], "}"}], "\[Rule]", "a"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", 
           RowBox[{"2", "|", "4"}], ",", 
           RowBox[{"a", ":", 
            RowBox[{"(", 
             RowBox[{"2", "|", "4"}], ")"}]}]}], "}"}], "\[Rule]", "a"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "5", ",", "4"}], "}"}], "\[Rule]", "0"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "5", ",", "_"}], "}"}], "\[Rule]", "5"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_", ",", "_"}], "}"}], "\[Rule]", "0"}]}], "}"}],
       "]"}], ",", 
     RowBox[{"Flatten", "[", 
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"w", "=", 
          RowBox[{"Max", "[", 
           RowBox[{"Ceiling", "[", 
            RowBox[{"Log", "[", 
             RowBox[{"2", ",", 
              RowBox[{"{", 
               RowBox[{"t", ",", "x"}], "}"}]}], "]"}], "]"}], "]"}]}], "}"}],
         ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"2", "\[ThinSpace]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"IntegerDigits", "[", 
              RowBox[{"t", ",", "2", ",", "w"}], "]"}], "]"}]}], "+", "1"}], 
          ",", "5", ",", 
          RowBox[{
           RowBox[{"2", "\[ThinSpace]", 
            RowBox[{"IntegerDigits", "[", 
             RowBox[{"x", ",", "2", ",", "w"}], "]"}]}], "+", "2"}]}], 
         "}"}]}], "]"}], "]"}], ",", "10"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "3", ",", "1", ",", "1", ",", "1", ",", "3", ",", "3", ",", "5", ",", "4",
      ",", "2", ",", "2", ",", "2", ",", "2", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "3", ",", "1", ",", "1", ",", "1", ",", "3", ",", "5", ",", "2",
      ",", "2", ",", "2", ",", "2", ",", "4", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "3", ",", "1", ",", "1", ",", "1", ",", "5", ",", "2",
      ",", "2", ",", "2", ",", "4", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "3", ",", "1", ",", "1", ",", "5", ",", "2",
      ",", "2", ",", "4", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "3", ",", "1", ",", "5", ",", "2",
      ",", "4", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "3", ",", "5", ",", "4",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "5", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "5", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "5", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "5", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "5", ",", "0",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
  "}"}]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Undecidability and Intractability", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 757 \[CenterDot] Correspondence systems\
\>", "Subsection"], Cell[" (page 1139)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"StringJoin", "[", 
   RowBox[{"u", "\[LeftDoubleBracket]", "s", "\[RightDoubleBracket]"}], "]"}],
   "==", 
  RowBox[{"StringJoin", "[", 
   RowBox[{"v", "\[LeftDoubleBracket]", "s", "\[RightDoubleBracket]"}], 
   "]"}]}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"u", ",", "v", ",", 
     RowBox[{"s", "=", 
      RowBox[{"{", 
       RowBox[{
       "2", ",", "3", ",", "2", ",", "2", ",", "3", ",", "2", ",", "1", ",", 
        "1"}], "}"}]}]}], "}"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"u", ",", "v"}], "}"}], "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\"\<ABB\>\"", ",", "\"\<B\>\""}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<B\>\"", ",", "\"\<BA\>\""}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<A\>\"", ",", "\"\<B\>\""}], "}"}]}], "}"}], "]"}]}], 
    ";", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"StringJoin", "[", 
       RowBox[{"u", "\[LeftDoubleBracket]", "s", "\[RightDoubleBracket]"}], 
       "]"}], ",", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"v", "\[LeftDoubleBracket]", "s", "\[RightDoubleBracket]"}], 
       "]"}]}], "}"}]}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"BABBABABBABB\"\>", ",", "\<\"BABBABABBABB\"\>"}], 
  "}"}]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"TSToPCP", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"n_", ",", "rule_"}], "}"}], ",", "s_"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Flatten", "[", 
      RowBox[{"IntegerDigits", "[", 
       RowBox[{"#", ",", "2", ",", "2"}], "]"}], "]"}], "&"}], ",", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "f", "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"f", "[", "u_", "]"}], ":=", 
        RowBox[{"Flatten", "[", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "#"}], "}"}], "&"}], ",", 
           RowBox[{"3", " ", "u"}]}], "]"}], "]"}]}], ";", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"f", "[", 
               RowBox[{"Last", "[", "#", "]"}], "]"}], ",", 
              RowBox[{"RotateLeft", "[", 
               RowBox[{"f", "[", 
                RowBox[{"First", "[", "#", "]"}], "]"}], "]"}]}], "}"}], 
            "&"}], ",", "rule"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"f", "[", "s", "]"}], ",", 
            RowBox[{"{", "1", "}"}]}], "}"}], "}"}], ",", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], ",", 
               RowBox[{"Append", "[", 
                RowBox[{
                 RowBox[{"RotateLeft", "[", 
                  RowBox[{"f", "[", 
                   RowBox[{"IntegerDigits", "[", 
                    RowBox[{"j", ",", "2", ",", "i"}], "]"}], "]"}], "]"}], 
                 ",", "2"}], "]"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "0", ",", 
               RowBox[{"n", "-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "0", ",", 
               RowBox[{
                SuperscriptBox["2", 
                 RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "i"}]], "-", 
                "1"}]}], "}"}]}], "]"}], ",", "1"}], "]"}]}], "]"}]}]}], 
     "]"}], ",", 
    RowBox[{"{", "2", "}"}]}], "]"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TSToPCP", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"n_", ",", "rule_"}], "}"}], ",", "s_"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Flatten", "[", 
      RowBox[{"IntegerDigits", "[", 
       RowBox[{"#", ",", "2", ",", "2"}], "]"}], "]"}], "&"}], ",", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "f", "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"f", "[", "u_", "]"}], ":=", 
        RowBox[{"Flatten", "[", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "#"}], "}"}], "&"}], ",", 
           RowBox[{"3", " ", "u"}]}], "]"}], "]"}]}], ";", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"f", "[", 
               RowBox[{"Last", "[", "#", "]"}], "]"}], ",", 
              RowBox[{"RotateLeft", "[", 
               RowBox[{"f", "[", 
                RowBox[{"First", "[", "#", "]"}], "]"}], "]"}]}], "}"}], 
            "&"}], ",", "rule"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"f", "[", "s", "]"}], ",", 
            RowBox[{"{", "1", "}"}]}], "}"}], "}"}], ",", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], ",", 
               RowBox[{"Append", "[", 
                RowBox[{
                 RowBox[{"RotateLeft", "[", 
                  RowBox[{"f", "[", 
                   RowBox[{"IntegerDigits", "[", 
                    RowBox[{"j", ",", "2", ",", "i"}], "]"}], "]"}], "]"}], 
                 ",", "2"}], "]"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "0", ",", 
               RowBox[{"n", "-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "0", ",", 
               RowBox[{
                SuperscriptBox["2", 
                 RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "i"}]], "-", 
                "1"}]}], "}"}]}], "]"}], ",", "1"}], "]"}]}], "]"}]}]}], 
     "]"}], ",", 
    RowBox[{"{", "2", "}"}]}], "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TSToPCP", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0"}], "}"}]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
       "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
       "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
       "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
       "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
       "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "1", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
      "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0"}], 
      "}"}]}], "}"}]}], "}"}]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Apply", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Append", "[", 
      RowBox[{"#2", ",", "s___"}], "]"}], "\[Rule]", 
     RowBox[{"Prepend", "[", 
      RowBox[{"#1", ",", "s"}], "]"}]}], "&"}], ",", "p", ",", 
   RowBox[{"{", "1", "}"}]}], "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"p", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", 
           ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
          "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
           ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
           ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", 
           ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
          "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
           ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", 
           ",", "0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
           ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", 
           ",", "1", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0"}], 
          "}"}]}], "}"}]}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Apply", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Append", "[", 
        RowBox[{"#2", ",", "s___"}], "]"}], "\[Rule]", 
       RowBox[{"Prepend", "[", 
        RowBox[{"#1", ",", "s"}], "]"}]}], "&"}], ",", "p", ",", 
     RowBox[{"{", "1", "}"}]}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
      "1", ",", "s___"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "s", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
      "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
      "1", ",", "s___"}], "}"}], "\[Rule]", 
    RowBox[{"{", "s", "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
      "1", ",", "s___"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "s", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
      "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
      "1", ",", "s___"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "s", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "s___"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "s", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
      "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "s___"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"s", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "s___"}], 
     "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"s", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "s___"}], 
     "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"s", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}]}]}], 
  "}"}]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Multiway tag systems", "Subsection"], Cell[" (page 1141)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "s___"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"s", ",", "1", ",", "0"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "s___"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"s", ",", "1", ",", "0", ",", "1"}], "}"}]}]}], "}"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MWTSEvolve", "[", 
   RowBox[{"rule_", ",", "list_", ",", "t_"}], "]"}], ":=", 
  RowBox[{"Nest", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ReplaceList", "[", 
           RowBox[{"#", ",", "rule"}], "]"}], "&"}], ",", "#"}], "]"}], ",", 
       "1"}], "]"}], "&"}], ",", "list", ",", "t"}], 
   "]"}]}]}], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MWTSEvolve", 
   StyleBox["[",
    FontFamily->"NewScienceSans",
    FontSlant->"Italic"], 
   RowBox[{
    StyleBox[
     RowBox[{"rule", 
      StyleBox["_",
       FontFamily->"NewScienceSans",
       FontSlant->"Italic"]}]], ",", 
    StyleBox[
     RowBox[{"list", 
      StyleBox["_",
       FontFamily->"NewScienceSans",
       FontSlant->"Italic"]}]], ",", 
    StyleBox[
     RowBox[{"t", 
      StyleBox["_",
       FontFamily->"NewScienceSans",
       FontSlant->"Italic"]}]]}], 
   StyleBox["]",
    FontFamily->"NewScienceSans",
    FontSlant->"Italic"]}], ":=", 
  RowBox[{"Nest", 
   StyleBox["[",
    FontFamily->"NewScienceSans",
    FontSlant->"Italic"], 
   RowBox[{
    RowBox[{
     RowBox[{"Flatten", 
      StyleBox["[",
       FontFamily->"NewScienceSans",
       FontSlant->"Italic"], 
      RowBox[{
       RowBox[{"Map", 
        StyleBox["[",
         FontFamily->"NewScienceSans",
         FontSlant->"Italic"], 
        RowBox[{
         RowBox[{"ReplaceList", 
          StyleBox["[",
           FontFamily->"NewScienceSans",
           FontSlant->"Italic"], 
          RowBox[{
           StyleBox["#",
            FontFamily->"NewScienceSans",
            FontSlant->"Italic"], ",", "rule"}], 
          StyleBox["]",
           FontFamily->"NewScienceSans",
           FontSlant->"Italic"]}], "&"}], ",", 
        StyleBox["#",
         FontFamily->"NewScienceSans",
         FontSlant->"Italic"], 
        StyleBox["]",
         FontFamily->"NewScienceSans",
         FontSlant->"Italic"]}], ",", "1"}], 
      StyleBox["]",
       FontFamily->"NewScienceSans",
       FontSlant->"Italic"]}], "&"}], ",", "list", ",", "t"}], 
   StyleBox["]",
    FontFamily->"NewScienceSans",
    FontSlant->"Italic"]}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MWTSEvolve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "s___"}], "}"}], "->", 
      RowBox[{"{", 
       RowBox[{"s", ",", "1", ",", "0"}], 
       StyleBox["}",
        FontFamily->"NewScienceSans",
        FontSlant->"Italic"]}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "s___"}], "}"}], "->", 
      RowBox[{"{", 
       RowBox[{"s", ",", "1", ",", "0", ",", "1"}], "}"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], "}"}], ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.534772078649049*^9, 3.534772177825562*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.534772182355257*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Word problems", "Subsection"], Cell[" (page 1141)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\"\<CCBB\>\"", "\[LeftRightArrow]", "\"\<BBCC\>\""}], ",", 
   RowBox[{"\"\<BCCCBB\>\"", "\[LeftRightArrow]", "\"\<CBBBCC\>\""}], ",", 
   RowBox[{"\"\<ACCBB\>\"", "\[LeftRightArrow]", "\"\<BBA\>\""}], ",", 
   RowBox[{"\"\<ABCCCBB\>\"", "\[LeftRightArrow]", "\"\<CBBA\>\""}], ",", 
   RowBox[{
   "\"\<BBCCBBBBCC\>\"", "\[LeftRightArrow]", "\"\<BBCCBBBBCCA\>\""}]}], 
  "}"}]], "Subsubsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Sequence equations", "Subsection"], Cell[" (page 1141)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Flatten", "[", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "x", ",", "0", ",", "y"}], "}"}], "]"}], "==", 
  RowBox[{"Flatten", "[", 
   RowBox[{"{", 
    RowBox[{
    "y", ",", "x", ",", "0", ",", "y", ",", "1", ",", "0", ",", "1", ",", "0",
      ",", "0"}], "}"}], "]"}]}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "=", " ", 
      RowBox[{"{", 
       RowBox[{
       "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
        "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], 
       "}"}]}], ",", 
     RowBox[{"y", "=", " ", 
      RowBox[{"{", 
       RowBox[{
       "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
        "1", ",", "0", ",", "0"}], "}"}]}]}], "}"}], ",", 
   RowBox[{
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "x", ",", "0", ",", "y"}], "}"}], "]"}], "==", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{
      "y", ",", "x", ",", "0", ",", "y", ",", "1", ",", "0", ",", "1", ",", 
       "0", ",", "0"}], "}"}], "]"}]}]}], "]"}]], "Input"],

Cell[BoxData["True"], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Fast algorithms", "Subsection"], Cell[" (page 1141)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"First", "[", 
   RowBox[{"f", "[", 
    RowBox[{
     RowBox[{"IntegerDigits", "[", 
      RowBox[{"x", ",", "2", ",", "n"}], "]"}], ",", 
     RowBox[{"IntegerDigits", "[", 
      RowBox[{"y", ",", "2", ",", "n"}], "]"}], ",", 
     RowBox[{"n", "/", "2"}]}], "]"}], "]"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{"x_", ",", "y_", ",", "n_"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"n", "<", "1"}], ",", 
     RowBox[{"x", " ", "y"}], ",", 
     RowBox[{"g", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{"x", ",", "n"}], "]"}], ",", 
       RowBox[{"Partition", "[", 
        RowBox[{"y", ",", "n"}], "]"}], ",", "n"}], "]"}]}], "]"}]}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"g", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x1_", ",", "x0_"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"y1_", ",", "y0_"}], "}"}], ",", "n_"}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"z1", "=", 
       RowBox[{"f", "[", 
        RowBox[{"x1", ",", "y1", ",", 
         RowBox[{"n", "/", "2"}]}], "]"}]}], ",", 
      RowBox[{"z0", "=", 
       RowBox[{"f", "[", 
        RowBox[{"x0", ",", "y0", ",", 
         RowBox[{"n", "/", "2"}]}], "]"}]}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"z1", " ", 
      SuperscriptBox["2", 
       RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
        RowBox[{"2", " ", "n"}]}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"f", "[", 
         RowBox[{
          RowBox[{"x0", "+", "x1"}], ",", 
          RowBox[{"y0", "+", "y1"}], ",", 
          RowBox[{"n", "/", "2"}]}], "]"}], "-", "z1", "-", "z0"}], ")"}], 
      " ", 
      SuperscriptBox["2", 
       RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "n"}]]}], "+", "z0"}]}], 
   "]"}]}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{"x_", ",", "y_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"n", "<", "1"}], ",", 
    RowBox[{"x", " ", "y"}], ",", 
    RowBox[{"g", "[", 
     RowBox[{
      RowBox[{"Partition", "[", 
       RowBox[{"x", ",", "n"}], "]"}], ",", 
      RowBox[{"Partition", "[", 
       RowBox[{"y", ",", "n"}], "]"}], ",", "n"}], "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"g", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x1_", ",", "x0_"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"y1_", ",", "y0_"}], "}"}], ",", "n_"}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"z1", "=", 
       RowBox[{"f", "[", 
        RowBox[{"x1", ",", "y1", ",", 
         RowBox[{"n", "/", "2"}]}], "]"}]}], ",", 
      RowBox[{"z0", "=", 
       RowBox[{"f", "[", 
        RowBox[{"x0", ",", "y0", ",", 
         RowBox[{"n", "/", "2"}]}], "]"}]}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"z1", " ", 
      SuperscriptBox["2", 
       RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
        RowBox[{"2", " ", "n"}]}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"f", "[", 
         RowBox[{
          RowBox[{"x0", "+", "x1"}], ",", 
          RowBox[{"y0", "+", "y1"}], ",", 
          RowBox[{"n", "/", "2"}]}], "]"}], "-", "z1", "-", "z0"}], ")"}], 
      " ", 
      SuperscriptBox["2", 
       RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "n"}]]}], "+", "z0"}]}], 
   "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "=", "1324"}], ",", 
     RowBox[{"y", "=", "4233"}], ",", 
     RowBox[{"n", "=", 
      RowBox[{"2", "^", "4"}]}]}], "}"}], ",", 
   RowBox[{"First", "[", 
    RowBox[{"f", "[", 
     RowBox[{
      RowBox[{"IntegerDigits", "[", 
       RowBox[{"x", ",", "2", ",", "n"}], "]"}], ",", 
      RowBox[{"IntegerDigits", "[", 
       RowBox[{"y", ",", "2", ",", "n"}], "]"}], ",", 
      RowBox[{"n", "/", "2"}]}], "]"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData["5604492"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"1324", "*", "4233"}]], "Input"],

Cell[BoxData["5604492"], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Sorting networks", "Subsection"], Cell[" (page 1142)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Fold", "[", 
   RowBox[{"PairSort", ",", "list", ",", "pairs"}], "]"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PairSort", "[", 
    RowBox[{"a_", ",", 
     RowBox[{"p", ":", 
      RowBox[{"{", 
       RowBox[{"_", ",", "_"}], "}"}]}]}], "]"}], ":=", 
   RowBox[{"Block", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"t", "=", "a"}], "}"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"t", "\[LeftDoubleBracket]", "p", "\[RightDoubleBracket]"}], 
       "=", 
       RowBox[{"Sort", "[", 
        RowBox[{"t", "\[LeftDoubleBracket]", "p", "\[RightDoubleBracket]"}], 
        "]"}]}], ";", "t"}]}], "]"}]}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{"Flatten", "[", 
  RowBox[{
   RowBox[{"Reverse", "[", 
    RowBox[{"Flatten", "[", 
     RowBox[{
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"m", "=", 
          RowBox[{
           RowBox[{"Ceiling", "[", 
            RowBox[{"Log", "[", 
             RowBox[{"2", ",", "n"}], "]"}], "]"}], "-", "1"}]}], "}"}], ",", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"With", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"d", "=", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"i", "==", "m"}], ",", 
                SuperscriptBox["2", 
                 RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "t"}]], ",", 
                RowBox[{
                 SuperscriptBox["2", 
                  RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
                   RowBox[{"i", "+", "1"}]}]], "-", 
                 SuperscriptBox["2", 
                  RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "t"}]]}]}], 
               "]"}]}], "}"}], ",", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "d"}], "}"}], "+", "#"}], "&"}], ",", 
              RowBox[{"Select", "[", 
               RowBox[{
                RowBox[{"Range", "[", 
                 RowBox[{"n", "-", "d"}], "]"}], ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"BitAnd", "[", 
                   RowBox[{
                    RowBox[{"#", "-", "1"}], ",", 
                    SuperscriptBox["2", 
                    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "t"}]]}], 
                   "]"}], "==", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"i", "==", "m"}], ",", "0", ",", 
                    SuperscriptBox["2", 
                    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "t"}]]}], 
                   "]"}]}], "&"}]}], "]"}]}], "]"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"t", ",", "0", ",", "m"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "t", ",", "m"}], "}"}]}], "]"}]}], "]"}], ",", 
      "1"}], "]"}], "]"}], ",", "1"}], "]"}]}], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PairSort", "[", 
   RowBox[{"a_", ",", 
    RowBox[{"p", ":", 
     RowBox[{"{", 
      RowBox[{"_", ",", "_"}], "}"}]}]}], "]"}], ":=", 
  RowBox[{"Block", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"t", "=", "a"}], "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"t", "\[LeftDoubleBracket]", "p", "\[RightDoubleBracket]"}], 
      "=", 
      RowBox[{"Sort", "[", 
       RowBox[{"t", "\[LeftDoubleBracket]", "p", "\[RightDoubleBracket]"}], 
       "]"}]}], ";", "t"}]}], "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"n", "=", "10"}], "}"}], ",", 
   RowBox[{"Flatten", "[", 
    RowBox[{
     RowBox[{"Reverse", "[", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"m", "=", 
            RowBox[{
             RowBox[{"Ceiling", "[", 
              RowBox[{"Log", "[", 
               RowBox[{"2", ",", "n"}], "]"}], "]"}], "-", "1"}]}], "}"}], 
          ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"With", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"d", "=", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"i", "==", "m"}], ",", 
                  SuperscriptBox["2", 
                   RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "t"}]], ",", 
                  RowBox[{
                   SuperscriptBox["2", 
                    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
                    RowBox[{"i", "+", "1"}]}]], "-", 
                   SuperscriptBox["2", 
                    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "t"}]]}]}], 
                 "]"}]}], "}"}], ",", 
              RowBox[{"Map", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"0", ",", "d"}], "}"}], "+", "#"}], "&"}], ",", 
                RowBox[{"Select", "[", 
                 RowBox[{
                  RowBox[{"Range", "[", 
                   RowBox[{"n", "-", "d"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"BitAnd", "[", 
                    RowBox[{
                    RowBox[{"#", "-", "1"}], ",", 
                    SuperscriptBox["2", 
                    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "t"}]]}], 
                    "]"}], "==", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "==", "m"}], ",", "0", ",", 
                    SuperscriptBox["2", 
                    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "t"}]]}], 
                    "]"}]}], "&"}]}], "]"}]}], "]"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"t", ",", "0", ",", "m"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "t", ",", "m"}], "}"}]}], "]"}]}], "]"}], ",", 
        "1"}], "]"}], "]"}], ",", "1"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", "9"}], "}"}]}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"list", "=", 
      RowBox[{"{", 
       RowBox[{
       "1", ",", "3", ",", "2", ",", "4", ",", "1", ",", "8", ",", "3", ",", 
        "2", ",", "4", ",", "0"}], "}"}]}], ",", "n", ",", "pairs"}], "}"}], 
   ",", 
   RowBox[{
    RowBox[{"n", "=", 
     RowBox[{"Length", "[", "list", "]"}]}], ";", " ", 
    RowBox[{"pairs", "=", 
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{"Reverse", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"With", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"m", "=", 
              RowBox[{
               RowBox[{"Ceiling", "[", 
                RowBox[{"Log", "[", 
                 RowBox[{"2", ",", "n"}], "]"}], "]"}], "-", "1"}]}], "}"}], 
            ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"With", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"d", "=", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"i", "==", "m"}], ",", 
                    SuperscriptBox["2", 
                    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "t"}]], ",", 
                    RowBox[{
                    SuperscriptBox["2", 
                    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
                    RowBox[{"i", "+", "1"}]}]], "-", 
                    SuperscriptBox["2", 
                    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "t"}]]}]}], 
                   "]"}]}], "}"}], ",", 
                RowBox[{"Map", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "d"}], "}"}], "+", "#"}], "&"}], ",", 
                  RowBox[{"Select", "[", 
                   RowBox[{
                    RowBox[{"Range", "[", 
                    RowBox[{"n", "-", "d"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BitAnd", "[", 
                    RowBox[{
                    RowBox[{"#", "-", "1"}], ",", 
                    SuperscriptBox["2", 
                    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "t"}]]}], 
                    "]"}], "==", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "==", "m"}], ",", "0", ",", 
                    SuperscriptBox["2", 
                    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "t"}]]}], 
                    "]"}]}], "&"}]}], "]"}]}], "]"}]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"t", ",", "0", ",", "m"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "t", ",", "m"}], "}"}]}], "]"}]}], "]"}], 
          ",", "1"}], "]"}], "]"}], ",", "1"}], "]"}]}], ";", 
    RowBox[{"Fold", "[", 
     RowBox[{"PairSort", ",", "list", ",", "pairs"}], "]"}]}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "1", ",", "2", ",", "2", ",", "3", ",", "3", ",", "4", 
   ",", "4", ",", "8"}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Sort", "[", 
  RowBox[{"{", 
   RowBox[{
   "1", ",", "3", ",", "2", ",", "4", ",", "1", ",", "8", ",", "3", ",", "2", 
    ",", "4", ",", "0"}], "}"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "1", ",", "2", ",", "2", ",", "3", ",", "3", ",", "4", 
   ",", "4", ",", "8"}], "}"}]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Turing machines", "Subsection"], Cell[" (page 1143)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Module", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"s", "=", "1"}], ",", "a", ",", 
     RowBox[{"i", "=", "1"}], ",", "d"}], "}"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "_", "]"}], "=", "0"}], ";", 
    RowBox[{"MapIndexed", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"#2", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}],
          "]"}], "=", "#1"}], "&"}], ",", 
      RowBox[{"Reverse", "[", 
       RowBox[{"IntegerDigits", "[", 
        RowBox[{"x", ",", "2"}], "]"}], "]"}]}], "]"}], ";", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"s", ",", 
          RowBox[{"a", "[", "i", "]"}], ",", "d"}], "}"}], "=", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"s", ",", 
           RowBox[{"a", "[", "i", "]"}]}], "}"}], "/.", "\[InvisibleSpace]", 
         "rule"}]}], ";", 
       RowBox[{"i", "-=", "d"}], ";", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"i", "==", "0"}], ",", 
         RowBox[{"Return", "[", "t", "]"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "tmax"}], "}"}]}], "]"}]}]}], "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "=", "11"}], ",", 
     RowBox[{"rule", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", 
           RowBox[{"-", "1"}]}], "}"}]}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"2", ",", "0", ",", "1"}], "}"}]}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2", ",", "0"}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]}], "}"}]}], ",", 
     RowBox[{"tmax", "=", "10000"}]}], "}"}], ",", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"s", "=", "1"}], ",", "a", ",", 
       RowBox[{"i", "=", "1"}], ",", "d"}], "}"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", "_", "]"}], "=", "0"}], ";", 
      RowBox[{"MapIndexed", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"a", "[", 
           RowBox[{
           "#2", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
           "]"}], "=", "#1"}], "&"}], ",", 
        RowBox[{"Reverse", "[", 
         RowBox[{"IntegerDigits", "[", 
          RowBox[{"x", ",", "2"}], "]"}], "]"}]}], "]"}], ";", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"s", ",", 
            RowBox[{"a", "[", "i", "]"}], ",", "d"}], "}"}], "=", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"s", ",", 
             RowBox[{"a", "[", "i", "]"}]}], "}"}], "/.", "\[InvisibleSpace]",
            "rule"}]}], ";", 
         RowBox[{"i", "-=", "d"}], ";", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "==", "0"}], ",", 
           RowBox[{"Return", "[", "t", "]"}]}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"t", ",", "tmax"}], "}"}]}], "]"}]}]}], "]"}]}], 
  "]"}]], "Input"],

Cell[BoxData["3"], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Machine 1507", "Subsection"], Cell[" (page 1144)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"u", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Reverse", "[", 
      RowBox[{"IntegerDigits", "[", 
       RowBox[{"x", ",", "2"}], "]"}], "]"}], ",", "0"}], "}"}], "]"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"u", "[", "list_", "]"}], ":=", 
   RowBox[{"v", "[", 
    RowBox[{"Split", "[", 
     RowBox[{"Flatten", "[", "list", "]"}], "]"}], "]"}]}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"v", "[", 
   RowBox[{"{", 
    RowBox[{"a_", ",", 
     RowBox[{"b_", ":", 
      RowBox[{"{", "}"}]}], ",", 
     RowBox[{"c_", ":", 
      RowBox[{"{", "}"}]}], ",", 
     RowBox[{"d_", ":", 
      RowBox[{"{", "}"}]}], ",", 
     RowBox[{"e_", ":", 
      RowBox[{"{", "}"}]}], ",", 
     RowBox[{"f_", ":", 
      RowBox[{"{", "}"}]}], ",", "g___"}], "}"}], "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "==", 
      RowBox[{"{", "1", "}"}]}], "||", 
     RowBox[{
      RowBox[{"First", "[", "a", "]"}], "==", "0"}]}], ",", "True", ",", 
    RowBox[{"c", "==", 
     RowBox[{"{", "}"}]}], ",", "False", ",", 
    RowBox[{"EvenQ", "[", 
     RowBox[{"Length", "[", "b", "]"}], "]"}], ",", 
    RowBox[{"u", "[", 
     RowBox[{"{", 
      RowBox[{"a", ",", 
       RowBox[{"1", "-", "b"}], ",", "c", ",", "d", ",", "e", ",", "f", ",", 
       "g"}], "}"}], "]"}], ",", 
    RowBox[{"EvenQ", "[", 
     RowBox[{"Length", "[", "c", "]"}], "]"}], ",", 
    RowBox[{"u", "[", 
     RowBox[{"{", 
      RowBox[{"a", ",", 
       RowBox[{"1", "-", "b"}], ",", "c", ",", "1", ",", 
       RowBox[{"Rest", "[", "d", "]"}], ",", "e", ",", "f", ",", "g", ",", 
       "0"}], "}"}], "]"}], ",", 
    RowBox[{
     RowBox[{"e", "==", 
      RowBox[{"{", "}"}]}], "||", 
     RowBox[{
      RowBox[{"Length", "[", "d", "]"}], "\[GreaterEqual]", 
      RowBox[{
       RowBox[{"Length", "[", "b", "]"}], "+", 
       RowBox[{"Length", "[", "a", "]"}], "-", "2"}]}]}], ",", "True", ",", 
    RowBox[{"EvenQ", "[", 
     RowBox[{"Length", "[", "e", "]"}], "]"}], ",", 
    RowBox[{"u", "[", 
     RowBox[{"{", 
      RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "f", ",", "g"}], "}"}], 
     "]"}], ",", "True", ",", 
    RowBox[{"u", "[", 
     RowBox[{"{", 
      RowBox[{"a", ",", 
       RowBox[{"1", "-", "b"}], ",", "c", ",", 
       RowBox[{"1", "-", "d"}], ",", "e", ",", "1", ",", 
       RowBox[{"Rest", "[", "f", "]"}], ",", "g", ",", "0"}], "}"}], "]"}]}], 
   "]"}]}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"u", "[", "list_", "]"}], ":=", 
  RowBox[{"v", "[", 
   RowBox[{"Split", "[", 
    RowBox[{"Flatten", "[", "list", "]"}], "]"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"v", "[", 
   RowBox[{"{", 
    RowBox[{"a_", ",", 
     RowBox[{"b_", ":", 
      RowBox[{"{", "}"}]}], ",", 
     RowBox[{"c_", ":", 
      RowBox[{"{", "}"}]}], ",", 
     RowBox[{"d_", ":", 
      RowBox[{"{", "}"}]}], ",", 
     RowBox[{"e_", ":", 
      RowBox[{"{", "}"}]}], ",", 
     RowBox[{"f_", ":", 
      RowBox[{"{", "}"}]}], ",", "g___"}], "}"}], "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "==", 
      RowBox[{"{", "1", "}"}]}], "||", 
     RowBox[{
      RowBox[{"First", "[", "a", "]"}], "==", "0"}]}], ",", "True", ",", 
    RowBox[{"c", "==", 
     RowBox[{"{", "}"}]}], ",", "False", ",", 
    RowBox[{"EvenQ", "[", 
     RowBox[{"Length", "[", "b", "]"}], "]"}], ",", 
    RowBox[{"u", "[", 
     RowBox[{"{", 
      RowBox[{"a", ",", 
       RowBox[{"1", "-", "b"}], ",", "c", ",", "d", ",", "e", ",", "f", ",", 
       "g"}], "}"}], "]"}], ",", 
    RowBox[{"EvenQ", "[", 
     RowBox[{"Length", "[", "c", "]"}], "]"}], ",", 
    RowBox[{"u", "[", 
     RowBox[{"{", 
      RowBox[{"a", ",", 
       RowBox[{"1", "-", "b"}], ",", "c", ",", "1", ",", 
       RowBox[{"Rest", "[", "d", "]"}], ",", "e", ",", "f", ",", "g", ",", 
       "0"}], "}"}], "]"}], ",", 
    RowBox[{
     RowBox[{"e", "==", 
      RowBox[{"{", "}"}]}], "||", 
     RowBox[{
      RowBox[{"Length", "[", "d", "]"}], "\[GreaterEqual]", 
      RowBox[{
       RowBox[{"Length", "[", "b", "]"}], "+", 
       RowBox[{"Length", "[", "a", "]"}], "-", "2"}]}]}], ",", "True", ",", 
    RowBox[{"EvenQ", "[", 
     RowBox[{"Length", "[", "e", "]"}], "]"}], ",", 
    RowBox[{"u", "[", 
     RowBox[{"{", 
      RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "f", ",", "g"}], "}"}], 
     "]"}], ",", "True", ",", 
    RowBox[{"u", "[", 
     RowBox[{"{", 
      RowBox[{"a", ",", 
       RowBox[{"1", "-", "b"}], ",", "c", ",", 
       RowBox[{"1", "-", "d"}], ",", "e", ",", "1", ",", 
       RowBox[{"Rest", "[", "f", "]"}], ",", "g", ",", "0"}], "}"}], "]"}]}], 
   "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", "=", "13"}], "}"}], ",", 
   RowBox[{"u", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Reverse", "[", 
       RowBox[{"IntegerDigits", "[", 
        RowBox[{"x", ",", "2"}], "]"}], "]"}], ",", "0"}], "}"}], "]"}]}], 
  "]"}]], "Input"],

Cell[BoxData["True"], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Machine 600720", "Subsection"], Cell[" (page 1145)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "5", ",", "159", ",", "161", ",", "1021", ",", "5419", ",", "315391", ",", 
   "1978213883", ",", "1978213885", ",", "3018415453261"}], 
  "}"}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", "^", 
   RowBox[{"{", 
    RowBox[{
    "3", ",", "23", ",", "24", ",", "63", ",", "148", ",", "1148", ",", 
     "91148", ",", "91149", ",", "3560523"}], "}"}]}], "-", 
  "1"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"u", "=", 
  RowBox[{"Nest", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"13", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"6", " ", "#"}], "+", "8"}], ")"}], " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"5", "/", "2"}], ")"}], "^", 
          RowBox[{"IntegerExponent", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"6", " ", "#"}], "+", "8"}], ",", "2"}], "]"}]}]}]}], 
       ")"}], "/", "6"}], "&"}], ",", "1", ",", 
    RowBox[{"s", "+", "1"}]}], "]"}]}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"s", "=", "3"}], "}"}], ",", 
   RowBox[{"Nest", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"13", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"6", " ", "#"}], "+", "8"}], ")"}], " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"5", "/", "2"}], ")"}], "^", 
           RowBox[{"IntegerExponent", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"6", " ", "#"}], "+", "8"}], ",", "2"}], "]"}]}]}]}], 
        ")"}], "/", "6"}], "&"}], ",", "1", ",", 
     RowBox[{"s", "+", "1"}]}], "]"}]}], "]"}]], "Input"],

Cell[BoxData["3560523"], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"h", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_"}], "}"}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"e", "=", 
      RowBox[{"IntegerExponent", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"3", " ", "i"}], "+", "4"}], ",", "2"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"13", "/", "6"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"i", "+", 
          RowBox[{"4", "/", "3"}]}], ")"}], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"5", "/", "2"}], ")"}], 
         RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
          RowBox[{"e", "+", "1"}]}]]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"154", "+", 
             RowBox[{"75", " ", 
              RowBox[{"(", 
               RowBox[{"i", "+", 
                RowBox[{"4", "/", "3"}]}], ")"}], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"5", "/", "2"}], ")"}], 
               RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "e"}]]}]}], ")"}], 
           RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "2"}]], "-", "16321", 
          "-", 
          RowBox[{"7860", " ", "i"}], "-", 
          RowBox[{"900", " ", 
           SuperscriptBox["i", 
            RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "2"}]]}], "+", 
          RowBox[{"3360", " ", "e"}]}], ")"}], "/", "3780"}], "+", "j"}]}], 
     "}"}]}], "]"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"h", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_"}], "}"}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"e", "=", 
      RowBox[{"IntegerExponent", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"3", " ", "i"}], "+", "4"}], ",", "2"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"13", "/", "6"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"i", "+", 
          RowBox[{"4", "/", "3"}]}], ")"}], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"5", "/", "2"}], ")"}], 
         RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
          RowBox[{"e", "+", "1"}]}]]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"154", "+", 
             RowBox[{"75", " ", 
              RowBox[{"(", 
               RowBox[{"i", "+", 
                RowBox[{"4", "/", "3"}]}], ")"}], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"5", "/", "2"}], ")"}], 
               RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "e"}]]}]}], ")"}], 
           RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "2"}]], "-", "16321", 
          "-", 
          RowBox[{"7860", " ", "i"}], "-", 
          RowBox[{"900", " ", 
           SuperscriptBox["i", 
            RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "2"}]]}], "+", 
          RowBox[{"3360", " ", "e"}]}], ")"}], "/", "3780"}], "+", "j"}]}], 
     "}"}]}], "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Last", "[", 
     RowBox[{"Nest", "[", 
      RowBox[{"h", ",", 
       RowBox[{"{", 
        RowBox[{"8", ",", 
         RowBox[{
          RowBox[{"4", "s"}], "+", "24"}]}], "}"}], ",", "s"}], "]"}], "]"}], 
    "-", "1"}], ",", 
   RowBox[{"{", 
    RowBox[{"s", ",", "1", ",", "3"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"5419", ",", "1978213883", ",", "3018415453261"}], "}"}]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"2", "^", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", "[", 
        RowBox[{
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}], ",", "#"}], "]"}], ",", 
         RowBox[{"Length", "[", "#", "]"}]}], "]"}], "&"}], ")"}], "[", 
     RowBox[{"IntegerDigits", "[", 
      RowBox[{"x", ",", "2"}], "]"}], "]"}]}], "-", "1"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"l_", ",", "_"}], "}"}], ",", "r_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"l", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"5", " ", "r"}], "-", 
            RowBox[{"3", " ", "#"}]}], ")"}], "/", "2"}]}], ",", "#"}], "}"}],
       "&"}], ")"}], "[", 
    RowBox[{"Mod", "[", 
     RowBox[{"r", ",", "2"}], "]"}], "]"}]}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"l_", ",", "0"}], "}"}], ",", "0"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"l", "+", "1"}], ",", "0"}], "}"}]}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"l_", ",", "1"}], "}"}], ",", "0"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"13", "+", 
           RowBox[{"#", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"5", "/", "2"}], ")"}], "^", 
             RowBox[{"IntegerExponent", "[", 
              RowBox[{"#", ",", "2"}], "]"}]}]}]}], ")"}], "/", "6"}], ",", 
        "0"}], "}"}], "&"}], ")"}], "[", 
    RowBox[{
     RowBox[{"6", " ", "l"}], "+", "2"}], "]"}]}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b", "[", 
   RowBox[{"list_", ",", "i_"}], "]"}], ":=", 
  RowBox[{"First", "[", 
   RowBox[{"Fold", "[", 
    RowBox[{"a", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Apply", "[", 
        RowBox[{"Plus", ",", 
         RowBox[{"Drop", "[", 
          RowBox[{"list", ",", 
           RowBox[{"-", "i"}]}], "]"}]}], "]"}], ",", "0"}], "}"}], ",", 
     RowBox[{"Apply", "[", 
      RowBox[{"Plus", ",", 
       RowBox[{"Split", "[", 
        RowBox[{
         RowBox[{"Take", "[", 
          RowBox[{"list", ",", 
           RowBox[{"-", "i"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"#1", "==", "#2", "\[NotEqual]", "0"}], "&"}]}], "]"}], ",",
        "1"}], "]"}]}], "]"}], "]"}]}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"a", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"l_", ",", "_"}], "}"}], ",", "r_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"l", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"5", " ", "r"}], "-", 
           RowBox[{"3", " ", "#"}]}], ")"}], "/", "2"}]}], ",", "#"}], "}"}], 
     "&"}], ")"}], "[", 
   RowBox[{"Mod", "[", 
    RowBox[{"r", ",", "2"}], "]"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"a", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"l_", ",", "0"}], "}"}], ",", "0"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"l", "+", "1"}], ",", "0"}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"a", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"l_", ",", "1"}], "}"}], ",", "0"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"13", "+", 
          RowBox[{"#", " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"5", "/", "2"}], ")"}], "^", 
            RowBox[{"IntegerExponent", "[", 
             RowBox[{"#", ",", "2"}], "]"}]}]}]}], ")"}], "/", "6"}], ",", 
       "0"}], "}"}], "&"}], ")"}], "[", 
   RowBox[{
    RowBox[{"6", " ", "l"}], "+", "2"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"b", "[", 
   RowBox[{"list_", ",", "i_"}], "]"}], ":=", 
  RowBox[{"First", "[", 
   RowBox[{"Fold", "[", 
    RowBox[{"a", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Apply", "[", 
        RowBox[{"Plus", ",", 
         RowBox[{"Drop", "[", 
          RowBox[{"list", ",", 
           RowBox[{"-", "i"}]}], "]"}]}], "]"}], ",", "0"}], "}"}], ",", 
     RowBox[{"Apply", "[", 
      RowBox[{"Plus", ",", 
       RowBox[{"Split", "[", 
        RowBox[{
         RowBox[{"Take", "[", 
          RowBox[{"list", ",", 
           RowBox[{"-", "i"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"#1", "==", "#2", "\[NotEqual]", "0"}], "&"}]}], "]"}], ",",
        "1"}], "]"}]}], "]"}], "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", "=", 
     RowBox[{"FromDigits", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1"}], 
        "}"}], ",", "2"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{
      RowBox[{"2", "^", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "[", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1"}], "}"}], ",", "#"}], "]"}], ",", 
            RowBox[{"Length", "[", "#", "]"}]}], "]"}], "&"}], ")"}], "[", 
        RowBox[{"IntegerDigits", "[", 
         RowBox[{"x", ",", "2"}], "]"}], "]"}]}], "-", "1"}]}], "}"}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"45", ",", "1073741823"}], "}"}]], "Output"]
}, Open  ]]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{"4", " ", "s"}], "]"}], "=", 
  RowBox[{
   RowBox[{"4", " ", "s"}], "+", "3"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{
    RowBox[{"4", " ", "s"}], "+", "1"}], "]"}], "=", 
  RowBox[{
   RowBox[{"2", " ", 
    RowBox[{"f", "[", 
     RowBox[{"2", " ", "s"}], "]"}]}], "+", "1"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{
    SuperscriptBox["2", 
     RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "s"}]], "-", "1"}], "]"}], 
  "=", 
  RowBox[{
   SuperscriptBox["2", 
    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"10", " ", "s"}], "+", "5", "+", 
        RowBox[{"3", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "s"}]]}]}], ")"}], "/", 
      "4"}]}]], "-", "1"}]}]], "Subsubsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Non-deterministic Turing machines", "Subsection"], Cell[
     " (page 1146)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"NTMEvolve", "[", 
    RowBox[{"rule_", ",", "inits_", ",", "t_Integer"}], "]"}], ":=", 
   RowBox[{"Nest", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Union", "[", 
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"NTMStep", "[", 
             RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "#"}], "]"}], ",",
          "1"}], "]"}], "]"}], "&"}], ",", "inits", ",", "t"}], "]"}]}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"NTMStep", "[", 
    RowBox[{"rule_List", ",", 
     RowBox[{"{", 
      RowBox[{"s_", ",", "a_", ",", "n_"}], "}"}]}], "]"}], "/;", 
   RowBox[{"1", "\[LessEqual]", "n", "\[LessEqual]", 
    RowBox[{"Length", "[", "a", "]"}]}]}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"#1", ",", 
       RowBox[{"ReplacePart", "[", 
        RowBox[{"a", ",", "#2", ",", "n"}], "]"}], ",", 
       RowBox[{"n", "+", "#3"}]}], "}"}], "&"}], ",", 
    RowBox[{"Replace", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"s", ",", 
        RowBox[{"a", "\[LeftDoubleBracket]", "n", "\[RightDoubleBracket]"}]}],
        "}"}], ",", "rule"}], "]"}], ",", 
    RowBox[{"{", "1", "}"}]}], "]"}]}]}], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NTMEvolve", "[", 
   RowBox[{"rule_", ",", "inits_", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"Nest", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Union", "[", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"NTMStep", "[", 
            RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "#"}], "]"}], ",", 
        "1"}], "]"}], "]"}], "&"}], ",", "inits", ",", "t"}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NTMStep", "[", 
    RowBox[{"rule_List", ",", 
     RowBox[{"{", 
      RowBox[{"s_", ",", "a_", ",", "n_"}], "}"}]}], "]"}], "/;", 
   RowBox[{"1", "\[LessEqual]", "n", "\[LessEqual]", 
    RowBox[{"Length", "[", "a", "]"}]}]}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"#1", ",", 
       RowBox[{"ReplacePart", "[", 
        RowBox[{"a", ",", "#2", ",", "n"}], "]"}], ",", 
       RowBox[{"n", "+", "#3"}]}], "}"}], "&"}], ",", 
    RowBox[{"Replace", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"s", ",", 
        RowBox[{"a", "\[LeftDoubleBracket]", "n", "\[RightDoubleBracket]"}]}],
        "}"}], ",", "rule"}], "]"}], ",", 
    RowBox[{"{", "1", "}"}]}], "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NTMEvolve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"2", ",", "1", ",", "1"}], "}"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "0"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", "1", ",", 
          RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"2", ",", "1", ",", "1"}], "}"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"2", ",", "0", ",", 
         RowBox[{"-", "1"}]}], "}"}], "}"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        "0"}], "}"}], ",", "4"}], "}"}], "}"}], ",", "4"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "0"}], "}"}]}], "}"}]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 767 \[CenterDot] Implementation", "Subsection"], Cell[
     " (page 1146)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"NDTMToCA", "[", "tm_", "]"}], ":=", 
  RowBox[{"Flatten", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "h", ",", "_"}], "}"}], "\[Rule]", "h"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"s", ",", "_c", ",", "_"}], "}"}], "\[Rule]", "e"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"s", ",", "_", ",", "_"}], "}"}], "\[Rule]", "s"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "s", ",", 
        RowBox[{"c", "[", "i_", "]"}]}], "}"}], "\[Rule]", 
      RowBox[{"s", "[", "i", "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "s", ",", "x_"}], "}"}], "\[Rule]", "x"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"_", ",", "_"}], "]"}], ",", "_s", ",", "_"}], "}"}], 
      "\[Rule]", "s"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"a", "[", 
         RowBox[{"x_", ",", "y_"}], "]"}], ",", 
        RowBox[{"s", "[", "i_", "]"}]}], "}"}], "\[Rule]", 
      RowBox[{"a", "[", 
       RowBox[{"x", ",", "y", ",", "i"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", ",", "_s", ",", "_"}], "}"}], "\[Rule]", "x"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "_", ",", 
        RowBox[{"s", "[", "i_", "]"}]}], "}"}], "\[Rule]", 
      RowBox[{"s", "[", "i", "]"}]}], ",", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"With", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"b", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"#", "\[LeftDoubleBracket]", 
                  RowBox[{"Min", "[", 
                   RowBox[{
                    RowBox[{"Length", "[", "#", "]"}], ",", "z"}], "]"}], 
                  "\[RightDoubleBracket]"}], "&"}], ")"}], "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"x", ",", "#"}], "}"}], "/.", "\[InvisibleSpace]", 
                "tm"}], "]"}]}], "}"}], ",", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Last", "[", "b", "]"}], "==", 
               RowBox[{"-", "1"}]}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"a", "[", "_", "]"}], ",", 
                   RowBox[{"a", "[", 
                    RowBox[{"x", ",", "#", ",", "z"}], "]"}], ",", "e"}], 
                  "}"}], "\[Rule]", "h"}], ",", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"a", "[", "_", "]"}], ",", 
                   RowBox[{"a", "[", 
                    RowBox[{"x", ",", "#", ",", "z"}], "]"}], ",", "s"}], 
                  "}"}], "\[Rule]", 
                 RowBox[{"a", "[", 
                  RowBox[{"x", ",", "#", ",", "z"}], "]"}]}], ",", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"a", "[", "_", "]"}], ",", 
                   RowBox[{"a", "[", 
                    RowBox[{"x", ",", "#", ",", "z"}], "]"}], ",", "_"}], 
                  "}"}], "\[Rule]", 
                 RowBox[{"a", "[", 
                  RowBox[{
                  "b", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
                   "]"}]}], ",", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"a", "[", 
                    RowBox[{"x", ",", "#", ",", "z"}], "]"}], ",", 
                   RowBox[{"a", "[", "w_", "]"}], ",", "_"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"a", "[", 
                  RowBox[{
                   RowBox[{
                   "b", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], ",", "w"}], "]"}]}], ",", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"_", ",", 
                   RowBox[{"a", "[", "w_", "]"}], ",", 
                   RowBox[{"a", "[", 
                    RowBox[{"x", ",", "#", ",", "z"}], "]"}]}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"a", "[", "w", "]"}]}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"a", "[", "_", "]"}], ",", 
                   RowBox[{"a", "[", 
                    RowBox[{"x", ",", "#", ",", "z"}], "]"}], ",", "_"}], 
                  "}"}], "\[Rule]", 
                 RowBox[{"a", "[", 
                  RowBox[{
                  "b", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
                   "]"}]}], ",", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"a", "[", 
                    RowBox[{"x", ",", "#", ",", "z"}], "]"}], ",", 
                   RowBox[{"a", "[", "w_", "]"}], ",", "_"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"a", "[", "w", "]"}]}], ",", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"_", ",", 
                   RowBox[{"a", "[", "w_", "]"}], ",", 
                   RowBox[{"a", "[", 
                    RowBox[{"x", ",", "#", ",", "z"}], "]"}]}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"a", "[", 
                  RowBox[{
                   RowBox[{
                   "b", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], ",", "w"}], "]"}]}]}], "}"}]}],
              "]"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", 
            RowBox[{"Max", "[", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"#", "\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "&"}], 
               ",", "tm"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"z", ",", 
            RowBox[{"Max", "[", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Length", "[", 
                 RowBox[{
                 "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
                 "]"}], "&"}], ",", "tm"}], "]"}], "]"}]}], "}"}]}], "]"}], 
        "&"}], ",", 
       RowBox[{"Union", "[", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"#", "\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}], "&"}], ",", 
          "tm"}], "]"}], "]"}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "x_", ",", "_"}], "}"}], "\[Rule]", "x"}]}], "}"}], 
   "]"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NDTMToCA", "[", "tm_", "]"}], ":=", 
  RowBox[{"Flatten", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "h", ",", "_"}], "}"}], "\[Rule]", "h"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"s", ",", "_c", ",", "_"}], "}"}], "\[Rule]", "e"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"s", ",", "_", ",", "_"}], "}"}], "\[Rule]", "s"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "s", ",", 
        RowBox[{"c", "[", "i_", "]"}]}], "}"}], "\[Rule]", 
      RowBox[{"s", "[", "i", "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "s", ",", "x_"}], "}"}], "\[Rule]", "x"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"_", ",", "_"}], "]"}], ",", "_s", ",", "_"}], "}"}], 
      "\[Rule]", "s"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"a", "[", 
         RowBox[{"x_", ",", "y_"}], "]"}], ",", 
        RowBox[{"s", "[", "i_", "]"}]}], "}"}], "\[Rule]", 
      RowBox[{"a", "[", 
       RowBox[{"x", ",", "y", ",", "i"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", ",", "_s", ",", "_"}], "}"}], "\[Rule]", "x"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "_", ",", 
        RowBox[{"s", "[", "i_", "]"}]}], "}"}], "\[Rule]", 
      RowBox[{"s", "[", "i", "]"}]}], ",", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"With", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"b", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"#", "\[LeftDoubleBracket]", 
                  RowBox[{"Min", "[", 
                   RowBox[{
                    RowBox[{"Length", "[", "#", "]"}], ",", "z"}], "]"}], 
                  "\[RightDoubleBracket]"}], "&"}], ")"}], "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"x", ",", "#"}], "}"}], "/.", "\[InvisibleSpace]", 
                "tm"}], "]"}]}], "}"}], ",", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Last", "[", "b", "]"}], "==", 
               RowBox[{"-", "1"}]}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"a", "[", "_", "]"}], ",", 
                   RowBox[{"a", "[", 
                    RowBox[{"x", ",", "#", ",", "z"}], "]"}], ",", "e"}], 
                  "}"}], "\[Rule]", "h"}], ",", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"a", "[", "_", "]"}], ",", 
                   RowBox[{"a", "[", 
                    RowBox[{"x", ",", "#", ",", "z"}], "]"}], ",", "s"}], 
                  "}"}], "\[Rule]", 
                 RowBox[{"a", "[", 
                  RowBox[{"x", ",", "#", ",", "z"}], "]"}]}], ",", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"a", "[", "_", "]"}], ",", 
                   RowBox[{"a", "[", 
                    RowBox[{"x", ",", "#", ",", "z"}], "]"}], ",", "_"}], 
                  "}"}], "\[Rule]", 
                 RowBox[{"a", "[", 
                  RowBox[{
                  "b", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
                   "]"}]}], ",", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"a", "[", 
                    RowBox[{"x", ",", "#", ",", "z"}], "]"}], ",", 
                   RowBox[{"a", "[", "w_", "]"}], ",", "_"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"a", "[", 
                  RowBox[{
                   RowBox[{
                   "b", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], ",", "w"}], "]"}]}], ",", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"_", ",", 
                   RowBox[{"a", "[", "w_", "]"}], ",", 
                   RowBox[{"a", "[", 
                    RowBox[{"x", ",", "#", ",", "z"}], "]"}]}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"a", "[", "w", "]"}]}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"a", "[", "_", "]"}], ",", 
                   RowBox[{"a", "[", 
                    RowBox[{"x", ",", "#", ",", "z"}], "]"}], ",", "_"}], 
                  "}"}], "\[Rule]", 
                 RowBox[{"a", "[", 
                  RowBox[{
                  "b", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
                   "]"}]}], ",", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"a", "[", 
                    RowBox[{"x", ",", "#", ",", "z"}], "]"}], ",", 
                   RowBox[{"a", "[", "w_", "]"}], ",", "_"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"a", "[", "w", "]"}]}], ",", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"_", ",", 
                   RowBox[{"a", "[", "w_", "]"}], ",", 
                   RowBox[{"a", "[", 
                    RowBox[{"x", ",", "#", ",", "z"}], "]"}]}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"a", "[", 
                  RowBox[{
                   RowBox[{
                   "b", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], ",", "w"}], "]"}]}]}], "}"}]}],
              "]"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", 
            RowBox[{"Max", "[", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"#", "\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "&"}], 
               ",", "tm"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"z", ",", 
            RowBox[{"Max", "[", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Length", "[", 
                 RowBox[{
                 "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
                 "]"}], "&"}], ",", "tm"}], "]"}], "]"}]}], "}"}]}], "]"}], 
        "&"}], ",", 
       RowBox[{"Union", "[", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"#", "\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}], "&"}], ",", 
          "tm"}], "]"}], "]"}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "x_", ",", "_"}], "}"}], "\[Rule]", "x"}]}], "}"}], 
   "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NDTMToCA", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1", ",", "1"}], "}"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "1", ",", 
         RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1", ",", "1"}], "}"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"2", ",", "0", ",", 
        RowBox[{"-", "1"}]}], "}"}], "}"}]}]}], "}"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "h", ",", "_"}], "}"}], "\[Rule]", "h"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"s", ",", "_c", ",", "_"}], "}"}], "\[Rule]", "e"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"s", ",", "_", ",", "_"}], "}"}], "\[Rule]", "s"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "s", ",", 
      RowBox[{"c", "[", "i_", "]"}]}], "}"}], "\[Rule]", 
    RowBox[{"s", "[", "i", "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "s", ",", "x_"}], "}"}], "\[Rule]", "x"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"_", ",", "_"}], "]"}], ",", "_s", ",", "_"}], "}"}], 
    "\[Rule]", "s"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", 
      RowBox[{"a", "[", 
       RowBox[{"x_", ",", "y_"}], "]"}], ",", 
      RowBox[{"s", "[", "i_", "]"}]}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", 
     RowBox[{"x", ",", "y", ",", "i"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x_", ",", "_s", ",", "_"}], "}"}], "\[Rule]", "x"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "_", ",", 
      RowBox[{"s", "[", "i_", "]"}]}], "}"}], "\[Rule]", 
    RowBox[{"s", "[", "i", "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", "_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "0", ",", "1"}], "]"}], ",", "e"}], "}"}], "\[Rule]",
     "h"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", "_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "0", ",", "1"}], "]"}], ",", "s"}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", 
     RowBox[{"1", ",", "0", ",", "1"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", "_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "0", ",", "1"}], "]"}], ",", "_"}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", "0", "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "0", ",", "1"}], "]"}], ",", 
      RowBox[{"a", "[", "w$_", "]"}], ",", "_"}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", 
     RowBox[{"2", ",", "w$"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", 
      RowBox[{"a", "[", "w_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "0", ",", "1"}], "]"}]}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", "w", "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", "_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "0", ",", "2"}], "]"}], ",", "e"}], "}"}], "\[Rule]",
     "h"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", "_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "0", ",", "2"}], "]"}], ",", "s"}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", 
     RowBox[{"1", ",", "0", ",", "2"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", "_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "0", ",", "2"}], "]"}], ",", "_"}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", "0", "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "0", ",", "2"}], "]"}], ",", 
      RowBox[{"a", "[", "w$_", "]"}], ",", "_"}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", 
     RowBox[{"2", ",", "w$"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", 
      RowBox[{"a", "[", "w_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "0", ",", "2"}], "]"}]}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", "w", "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", "_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "0", ",", "1"}], "]"}], ",", "_"}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", "0", "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "0", ",", "1"}], "]"}], ",", 
      RowBox[{"a", "[", "w_", "]"}], ",", "_"}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", "w", "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", 
      RowBox[{"a", "[", "w$_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "0", ",", "1"}], "]"}]}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", 
     RowBox[{"1", ",", "w$"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", "_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "0", ",", "2"}], "]"}], ",", "e"}], "}"}], "\[Rule]",
     "h"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", "_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "0", ",", "2"}], "]"}], ",", "s"}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", 
     RowBox[{"2", ",", "0", ",", "2"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", "_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "0", ",", "2"}], "]"}], ",", "_"}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", "1", "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "0", ",", "2"}], "]"}], ",", 
      RowBox[{"a", "[", "w$_", "]"}], ",", "_"}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", 
     RowBox[{"2", ",", "w$"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", 
      RowBox[{"a", "[", "w_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "0", ",", "2"}], "]"}]}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", "w", "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", "_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "1", ",", "1"}], "]"}], ",", "_"}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", "1", "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "1", ",", "1"}], "]"}], ",", 
      RowBox[{"a", "[", "w_", "]"}], ",", "_"}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", "w", "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", 
      RowBox[{"a", "[", "w$_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "1", ",", "1"}], "]"}]}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", 
     RowBox[{"2", ",", "w$"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", "_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "1", ",", "2"}], "]"}], ",", "_"}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", "1", "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "1", ",", "2"}], "]"}], ",", 
      RowBox[{"a", "[", "w_", "]"}], ",", "_"}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", "w", "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", 
      RowBox[{"a", "[", "w$_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "1", ",", "2"}], "]"}]}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", 
     RowBox[{"2", ",", "w$"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", "_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "1", ",", "1"}], "]"}], ",", "_"}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", "1", "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "1", ",", "1"}], "]"}], ",", 
      RowBox[{"a", "[", "w_", "]"}], ",", "_"}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", "w", "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", 
      RowBox[{"a", "[", "w$_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "1", ",", "1"}], "]"}]}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", 
     RowBox[{"2", ",", "w$"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", "_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "1", ",", "2"}], "]"}], ",", "_"}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", "1", "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "1", ",", "2"}], "]"}], ",", 
      RowBox[{"a", "[", "w_", "]"}], ",", "_"}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", "w", "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", 
      RowBox[{"a", "[", "w$_", "]"}], ",", 
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "1", ",", "2"}], "]"}]}], "}"}], "\[Rule]", 
    RowBox[{"a", "[", 
     RowBox[{"2", ",", "w$"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "x_", ",", "_"}], "}"}], "\[Rule]", "x"}]}], 
  "}"}]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 768 \[CenterDot] Satisfiability", "Subsection"], Cell[
     " (page 1146)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"NDTMToCNF", "[", 
   RowBox[{"rules_", ",", 
    RowBox[{"{", 
     RowBox[{"s_", ",", "a_", ",", "n_"}], "}"}], ",", "t_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Apply", "[", 
        RowBox[{"Or", ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"\[DoubleStruckS]", "[", 
            RowBox[{"i", ",", "j"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "stot"}], "}"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"t", "-", "1"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"!", 
         RowBox[{"\[DoubleStruckS]", "[", 
          RowBox[{"i", ",", "j"}], "]"}]}], "||", 
        RowBox[{"!", 
         RowBox[{"\[DoubleStruckS]", "[", 
          RowBox[{"i", ",", "k"}], "]"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", 
         RowBox[{"t", "-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "stot"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", 
         RowBox[{"j", "+", "1"}], ",", "stot"}], "}"}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Apply", "[", 
        RowBox[{"Or", ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"\[DoubleStruckN]", "[", 
            RowBox[{"i", ",", "j"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", 
             RowBox[{"n", "+", "i"}], ",", 
             RowBox[{"Max", "[", 
              RowBox[{"0", ",", 
               RowBox[{"n", "-", "i"}]}], "]"}], ",", 
             RowBox[{"-", "2"}]}], "}"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "t"}], "}"}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"!", 
         RowBox[{"\[DoubleStruckN]", "[", 
          RowBox[{"i", ",", "j"}], "]"}]}], "||", 
        RowBox[{"!", 
         RowBox[{"\[DoubleStruckN]", "[", 
          RowBox[{"i", ",", "k"}], "]"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "t"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", 
         RowBox[{"n", "+", "i"}], ",", 
         RowBox[{"Max", "[", 
          RowBox[{"0", ",", 
           RowBox[{"n", "-", "i"}]}], "]"}], ",", 
         RowBox[{"-", "2"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", 
         RowBox[{"j", "+", "2"}], ",", 
         RowBox[{"n", "+", "i"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Apply", "[", 
        RowBox[{"Or", ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"\[DoubleStruckA]", "[", 
            RowBox[{"i", ",", "j", ",", "k"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"k", ",", "0", ",", 
             RowBox[{"ktot", "-", "1"}]}], "}"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", 
         RowBox[{"t", "-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", 
         RowBox[{"Max", "[", 
          RowBox[{"1", ",", 
           RowBox[{"n", "-", "i"}]}], "]"}], ",", 
         RowBox[{"n", "+", "i"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"!", 
         RowBox[{"\[DoubleStruckA]", "[", 
          RowBox[{"i", ",", "j", ",", "k"}], "]"}]}], "||", 
        RowBox[{"!", 
         RowBox[{"\[DoubleStruckA]", "[", 
          RowBox[{"i", ",", "j", ",", "m"}], "]"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", 
         RowBox[{"t", "-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", 
         RowBox[{"Max", "[", 
          RowBox[{"1", ",", 
           RowBox[{"n", "-", "i"}]}], "]"}], ",", 
         RowBox[{"n", "+", "i"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", "0", ",", 
         RowBox[{"ktot", "-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", 
         RowBox[{"k", "+", "1"}], ",", 
         RowBox[{"ktot", "-", "1"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"\[DoubleStruckS]", "[", 
      RowBox[{"0", ",", "s"}], "]"}], ",", 
     RowBox[{"Cases", "[", 
      RowBox[{
       RowBox[{"MapIndexed", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"\[DoubleStruckA]", "[", 
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{"n", "-", 
              RowBox[{"First", "[", "#2", "]"}]}], "]"}], ",", 
            RowBox[{"First", "[", "#2", "]"}], ",", "#1"}], "]"}], "&"}], ",",
          "a"}], "]"}], ",", 
       RowBox[{
        RowBox[{"\[DoubleStruckA]", "[", 
         RowBox[{"x_", ",", "_", ",", "_"}], "]"}], "/;", 
        RowBox[{"x", "<", "t"}]}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"\[DoubleStruckA]", "[", 
        RowBox[{
         RowBox[{"Abs", "[", 
          RowBox[{"n", "-", "i"}], "]"}], ",", "i", ",", "0"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{
          RowBox[{"Length", "[", "a", "]"}], "+", "1"}], ",", 
         RowBox[{"n", "+", "t", "-", "1"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"!", 
         RowBox[{"\[DoubleStruckA]", "[", 
          RowBox[{"i", ",", "j", ",", "k"}], "]"}]}], "||", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"EvenQ", "[", 
           RowBox[{"n", "+", "i", "-", "j"}], "]"}], ",", 
          RowBox[{"\[DoubleStruckN]", "[", 
           RowBox[{"i", ",", "j"}], "]"}], ",", "False"}], "]"}], "||", 
        RowBox[{"\[DoubleStruckA]", "[", 
         RowBox[{
          RowBox[{"i", "+", "1"}], ",", "j", ",", "k"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", 
         RowBox[{"t", "-", "2"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", 
         RowBox[{"Max", "[", 
          RowBox[{"1", ",", 
           RowBox[{"n", "-", "i"}]}], "]"}], ",", 
         RowBox[{"n", "+", "i"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", "0", ",", 
         RowBox[{"ktot", "-", "1"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{"Function", "[", 
          RowBox[{"z", ",", 
           RowBox[{"Outer", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"!", 
                RowBox[{"\[DoubleStruckN]", "[", 
                 RowBox[{"i", ",", "j"}], "]"}]}], "||", 
               RowBox[{"!", 
                RowBox[{"\[DoubleStruckS]", "[", 
                 RowBox[{"i", ",", 
                  RowBox[{"z", "\[LeftDoubleBracket]", 
                   RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], 
                 "]"}]}], "||", 
               RowBox[{"!", 
                RowBox[{"\[DoubleStruckA]", "[", 
                 RowBox[{"i", ",", "j", ",", 
                  RowBox[{"z", "\[LeftDoubleBracket]", 
                   RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]}], 
                 "]"}]}], "||", "##"}], "&"}], ",", 
             RowBox[{"Apply", "[", 
              RowBox[{"Sequence", ",", 
               RowBox[{"Map", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"i", "<", 
                    RowBox[{"t", "-", "1"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[DoubleStruckS]", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", 
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}]}], "]"}], ",", 
                    RowBox[{"\[DoubleStruckN]", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", 
                    RowBox[{"j", "-", 
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "3", 
                    "\[RightDoubleBracket]"}]}]}], "]"}], ",", 
                    RowBox[{"\[DoubleStruckA]", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "j", ",", 
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"\[DoubleStruckN]", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", 
                    RowBox[{"j", "-", 
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "3", 
                    "\[RightDoubleBracket]"}]}]}], "]"}], "}"}]}], "]"}], 
                  "&"}], ",", 
                 RowBox[{
                 "z", "\[LeftDoubleBracket]", "2", 
                  "\[RightDoubleBracket]"}]}], "]"}]}], "]"}]}], "]"}]}], 
          "]"}], ",", "rules"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", 
         RowBox[{"t", "-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", 
         RowBox[{"n", "+", "i"}], ",", 
         RowBox[{"Max", "[", 
          RowBox[{"1", ",", 
           RowBox[{"n", "-", "i"}]}], "]"}], ",", 
         RowBox[{"-", "2"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"Apply", "[", 
      RowBox[{"Or", ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"\[DoubleStruckN]", "[", 
          RowBox[{"i", ",", "0"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "n", ",", "t", ",", "2"}], "}"}]}], "]"}]}], 
      "]"}]}], "}"}], "/.", "\[InvisibleSpace]", 
   RowBox[{"List", "\[Rule]", "And"}]}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NDTMToCNF", "[", 
   RowBox[{"rules_", ",", 
    RowBox[{"{", 
     RowBox[{"s_", ",", "a_", ",", "n_"}], "}"}], ",", "t_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Apply", "[", 
        RowBox[{"Or", ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"\[DoubleStruckS]", "[", 
            RowBox[{"i", ",", "j"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "stot"}], "}"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"t", "-", "1"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"!", 
         RowBox[{"\[DoubleStruckS]", "[", 
          RowBox[{"i", ",", "j"}], "]"}]}], "||", 
        RowBox[{"!", 
         RowBox[{"\[DoubleStruckS]", "[", 
          RowBox[{"i", ",", "k"}], "]"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", 
         RowBox[{"t", "-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "stot"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", 
         RowBox[{"j", "+", "1"}], ",", "stot"}], "}"}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Apply", "[", 
        RowBox[{"Or", ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"\[DoubleStruckN]", "[", 
            RowBox[{"i", ",", "j"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", 
             RowBox[{"n", "+", "i"}], ",", 
             RowBox[{"Max", "[", 
              RowBox[{"0", ",", 
               RowBox[{"n", "-", "i"}]}], "]"}], ",", 
             RowBox[{"-", "2"}]}], "}"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "t"}], "}"}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"!", 
         RowBox[{"\[DoubleStruckN]", "[", 
          RowBox[{"i", ",", "j"}], "]"}]}], "||", 
        RowBox[{"!", 
         RowBox[{"\[DoubleStruckN]", "[", 
          RowBox[{"i", ",", "k"}], "]"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "t"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", 
         RowBox[{"n", "+", "i"}], ",", 
         RowBox[{"Max", "[", 
          RowBox[{"0", ",", 
           RowBox[{"n", "-", "i"}]}], "]"}], ",", 
         RowBox[{"-", "2"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", 
         RowBox[{"j", "+", "2"}], ",", 
         RowBox[{"n", "+", "i"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Apply", "[", 
        RowBox[{"Or", ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"\[DoubleStruckA]", "[", 
            RowBox[{"i", ",", "j", ",", "k"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"k", ",", "0", ",", 
             RowBox[{"ktot", "-", "1"}]}], "}"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", 
         RowBox[{"t", "-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", 
         RowBox[{"Max", "[", 
          RowBox[{"1", ",", 
           RowBox[{"n", "-", "i"}]}], "]"}], ",", 
         RowBox[{"n", "+", "i"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"!", 
         RowBox[{"\[DoubleStruckA]", "[", 
          RowBox[{"i", ",", "j", ",", "k"}], "]"}]}], "||", 
        RowBox[{"!", 
         RowBox[{"\[DoubleStruckA]", "[", 
          RowBox[{"i", ",", "j", ",", "m"}], "]"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", 
         RowBox[{"t", "-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", 
         RowBox[{"Max", "[", 
          RowBox[{"1", ",", 
           RowBox[{"n", "-", "i"}]}], "]"}], ",", 
         RowBox[{"n", "+", "i"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", "0", ",", 
         RowBox[{"ktot", "-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", 
         RowBox[{"k", "+", "1"}], ",", 
         RowBox[{"ktot", "-", "1"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"\[DoubleStruckS]", "[", 
      RowBox[{"0", ",", "s"}], "]"}], ",", 
     RowBox[{"Cases", "[", 
      RowBox[{
       RowBox[{"MapIndexed", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"\[DoubleStruckA]", "[", 
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{"n", "-", 
              RowBox[{"First", "[", "#2", "]"}]}], "]"}], ",", 
            RowBox[{"First", "[", "#2", "]"}], ",", "#1"}], "]"}], "&"}], ",",
          "a"}], "]"}], ",", 
       RowBox[{
        RowBox[{"\[DoubleStruckA]", "[", 
         RowBox[{"x_", ",", "_", ",", "_"}], "]"}], "/;", 
        RowBox[{"x", "<", "t"}]}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"\[DoubleStruckA]", "[", 
        RowBox[{
         RowBox[{"Abs", "[", 
          RowBox[{"n", "-", "i"}], "]"}], ",", "i", ",", "0"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{
          RowBox[{"Length", "[", "a", "]"}], "+", "1"}], ",", 
         RowBox[{"n", "+", "t", "-", "1"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"!", 
         RowBox[{"\[DoubleStruckA]", "[", 
          RowBox[{"i", ",", "j", ",", "k"}], "]"}]}], "||", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"EvenQ", "[", 
           RowBox[{"n", "+", "i", "-", "j"}], "]"}], ",", 
          RowBox[{"\[DoubleStruckN]", "[", 
           RowBox[{"i", ",", "j"}], "]"}], ",", "False"}], "]"}], "||", 
        RowBox[{"\[DoubleStruckA]", "[", 
         RowBox[{
          RowBox[{"i", "+", "1"}], ",", "j", ",", "k"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", 
         RowBox[{"t", "-", "2"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", 
         RowBox[{"Max", "[", 
          RowBox[{"1", ",", 
           RowBox[{"n", "-", "i"}]}], "]"}], ",", 
         RowBox[{"n", "+", "i"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", "0", ",", 
         RowBox[{"ktot", "-", "1"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{"Function", "[", 
          RowBox[{"z", ",", 
           RowBox[{"Outer", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"!", 
                RowBox[{"\[DoubleStruckN]", "[", 
                 RowBox[{"i", ",", "j"}], "]"}]}], "||", 
               RowBox[{"!", 
                RowBox[{"\[DoubleStruckS]", "[", 
                 RowBox[{"i", ",", 
                  RowBox[{"z", "\[LeftDoubleBracket]", 
                   RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], 
                 "]"}]}], "||", 
               RowBox[{"!", 
                RowBox[{"\[DoubleStruckA]", "[", 
                 RowBox[{"i", ",", "j", ",", 
                  RowBox[{"z", "\[LeftDoubleBracket]", 
                   RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]}], 
                 "]"}]}], "||", "##"}], "&"}], ",", 
             RowBox[{"Apply", "[", 
              RowBox[{"Sequence", ",", 
               RowBox[{"Map", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"i", "<", 
                    RowBox[{"t", "-", "1"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[DoubleStruckS]", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", 
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}]}], "]"}], ",", 
                    RowBox[{"\[DoubleStruckN]", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", 
                    RowBox[{"j", "-", 
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "3", 
                    "\[RightDoubleBracket]"}]}]}], "]"}], ",", 
                    RowBox[{"\[DoubleStruckA]", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "j", ",", 
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"\[DoubleStruckN]", "[", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", 
                    RowBox[{"j", "-", 
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "3", 
                    "\[RightDoubleBracket]"}]}]}], "]"}], "}"}]}], "]"}], 
                  "&"}], ",", 
                 RowBox[{
                 "z", "\[LeftDoubleBracket]", "2", 
                  "\[RightDoubleBracket]"}]}], "]"}]}], "]"}]}], "]"}]}], 
          "]"}], ",", "rules"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", 
         RowBox[{"t", "-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", 
         RowBox[{"n", "+", "i"}], ",", 
         RowBox[{"Max", "[", 
          RowBox[{"1", ",", 
           RowBox[{"n", "-", "i"}]}], "]"}], ",", 
         RowBox[{"-", "2"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"Apply", "[", 
      RowBox[{"Or", ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"\[DoubleStruckN]", "[", 
          RowBox[{"i", ",", "0"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "n", ",", "t", ",", "2"}], "}"}]}], "]"}]}], 
      "]"}]}], "}"}], "/.", "\[InvisibleSpace]", 
   RowBox[{"List", "\[Rule]", "And"}]}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"stot", "=", "2"}], ",", " ", 
     RowBox[{"ktot", "=", "2"}]}], "}"}], ",", 
   RowBox[{"NDTMToCNF", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"2", ",", "0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", 
            RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "0"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", 
           RowBox[{"-", "1"}]}], "}"}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"2", ",", "0", ",", 
           RowBox[{"-", "1"}]}], "}"}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "1"}], "}"}], "}"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"{", "1", "}"}], ",", "1"}], "}"}], ",", "1"}], "]"}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"!", 
     RowBox[{"\[DoubleStruckS]", "[", 
      RowBox[{"0", ",", "1"}], "]"}]}], "||", 
    RowBox[{"!", 
     RowBox[{"\[DoubleStruckS]", "[", 
      RowBox[{"0", ",", "2"}], "]"}]}]}], ")"}], "&&", 
  RowBox[{"\[DoubleStruckN]", "[", 
   RowBox[{"0", ",", "1"}], "]"}], "&&", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"\[DoubleStruckN]", "[", 
     RowBox[{"1", ",", "2"}], "]"}], "||", 
    RowBox[{"\[DoubleStruckN]", "[", 
     RowBox[{"1", ",", "0"}], "]"}]}], ")"}], "&&", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"!", 
     RowBox[{"\[DoubleStruckN]", "[", 
      RowBox[{"1", ",", "0"}], "]"}]}], "||", 
    RowBox[{"!", 
     RowBox[{"\[DoubleStruckN]", "[", 
      RowBox[{"1", ",", "2"}], "]"}]}]}], ")"}], "&&", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"\[DoubleStruckA]", "[", 
     RowBox[{"0", ",", "1", ",", "0"}], "]"}], "||", 
    RowBox[{"\[DoubleStruckA]", "[", 
     RowBox[{"0", ",", "1", ",", "1"}], "]"}]}], ")"}], "&&", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"!", 
     RowBox[{"\[DoubleStruckA]", "[", 
      RowBox[{"0", ",", "1", ",", "0"}], "]"}]}], "||", 
    RowBox[{"!", 
     RowBox[{"\[DoubleStruckA]", "[", 
      RowBox[{"0", ",", "1", ",", "1"}], "]"}]}]}], ")"}], "&&", 
  RowBox[{"\[DoubleStruckS]", "[", 
   RowBox[{"0", ",", "1"}], "]"}], "&&", 
  RowBox[{"\[DoubleStruckA]", "[", 
   RowBox[{"0", ",", "1", ",", "1"}], "]"}], "&&", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"!", 
     RowBox[{"\[DoubleStruckN]", "[", 
      RowBox[{"0", ",", "1"}], "]"}]}], "||", 
    RowBox[{"!", 
     RowBox[{"\[DoubleStruckS]", "[", 
      RowBox[{"0", ",", "1"}], "]"}]}], "||", 
    RowBox[{"!", 
     RowBox[{"\[DoubleStruckA]", "[", 
      RowBox[{"0", ",", "1", ",", "0"}], "]"}]}], "||", 
    RowBox[{"\[DoubleStruckN]", "[", 
     RowBox[{"1", ",", "0"}], "]"}], "||", 
    RowBox[{"\[DoubleStruckN]", "[", 
     RowBox[{"1", ",", "2"}], "]"}]}], ")"}], "&&", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"!", 
     RowBox[{"\[DoubleStruckN]", "[", 
      RowBox[{"0", ",", "1"}], "]"}]}], "||", 
    RowBox[{"!", 
     RowBox[{"\[DoubleStruckS]", "[", 
      RowBox[{"0", ",", "2"}], "]"}]}], "||", 
    RowBox[{"!", 
     RowBox[{"\[DoubleStruckA]", "[", 
      RowBox[{"0", ",", "1", ",", "0"}], "]"}]}], "||", 
    RowBox[{"\[DoubleStruckN]", "[", 
     RowBox[{"1", ",", "2"}], "]"}]}], ")"}], "&&", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"!", 
     RowBox[{"\[DoubleStruckN]", "[", 
      RowBox[{"0", ",", "1"}], "]"}]}], "||", 
    RowBox[{"!", 
     RowBox[{"\[DoubleStruckS]", "[", 
      RowBox[{"0", ",", "1"}], "]"}]}], "||", 
    RowBox[{"!", 
     RowBox[{"\[DoubleStruckA]", "[", 
      RowBox[{"0", ",", "1", ",", "1"}], "]"}]}], "||", 
    RowBox[{"\[DoubleStruckN]", "[", 
     RowBox[{"1", ",", "2"}], "]"}]}], ")"}], "&&", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"!", 
     RowBox[{"\[DoubleStruckN]", "[", 
      RowBox[{"0", ",", "1"}], "]"}]}], "||", 
    RowBox[{"!", 
     RowBox[{"\[DoubleStruckS]", "[", 
      RowBox[{"0", ",", "2"}], "]"}]}], "||", 
    RowBox[{"!", 
     RowBox[{"\[DoubleStruckA]", "[", 
      RowBox[{"0", ",", "1", ",", "1"}], "]"}]}], "||", 
    RowBox[{"\[DoubleStruckN]", "[", 
     RowBox[{"1", ",", "0"}], "]"}]}], ")"}], "&&", 
  RowBox[{"\[DoubleStruckN]", "[", 
   RowBox[{"1", ",", "0"}], "]"}]}]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 770 \[CenterDot] Rule 30 inversion", "Subsection"], Cell[
     " (page 1147)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "2", ",", "2", ",", "3", ",", "3", ",", "6", ",", "6", ",", "10", 
   ",", "16", ",", "31", ",", "52", ",", "99", ",", "165", ",", "260"}], 
  "}"}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2", ",", "5", ",", "8", ",", "14", ",", "23", ",", "40", ",", "66", ",", 
   "111", ",", "182", ",", "316", ",", "540", ",", "921", ",", "1530", ",", 
   "2543", ",", "4122"}], "}"}]], "Subsubsection"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Implications for Mathematics and Its Foundations", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Basic logic", "Subsection"], Cell[" (page 1151)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"\[Not]", 
      RowBox[{"\[Not]", "a"}]}], ")"}], "\[LongEqual]", "a"}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "\[Or]", 
      RowBox[{"\[Not]", 
       RowBox[{"(", 
        RowBox[{"b", "\[Or]", 
         RowBox[{"\[Not]", "b"}]}], ")"}]}]}], ")"}], "\[LongEqual]", "a"}], 
   ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"\[Not]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Not]", 
         RowBox[{"(", 
          RowBox[{"a", "\[Or]", 
           RowBox[{"\[Not]", "b"}]}], ")"}]}], "\[Or]", 
        RowBox[{"\[Not]", 
         RowBox[{"(", 
          RowBox[{"a", "\[Or]", 
           RowBox[{"\[Not]", "c"}]}], ")"}]}]}], ")"}]}], ")"}], 
    "\[LongEqual]", 
    RowBox[{"(", 
     RowBox[{"a", "\[Or]", 
      RowBox[{"\[Not]", 
       RowBox[{"(", 
        RowBox[{"b", "\[Or]", "c"}], ")"}]}]}], ")"}]}]}], 
  "}"}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"a", "\[Implies]", 
    RowBox[{"(", 
     RowBox[{"b", "\[Implies]", "a"}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "\[Implies]", 
      RowBox[{"(", 
       RowBox[{"b", "\[Implies]", "c"}], ")"}]}], ")"}], "\[Implies]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "\[Implies]", "b"}], ")"}], "\[Implies]", 
      RowBox[{"(", 
       RowBox[{"a", "\[Implies]", "c"}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "\[Implies]", 
      RowBox[{"(", 
       RowBox[{"b", "\[Implies]", "c"}], ")"}]}], ")"}], "\[Implies]", 
    RowBox[{"(", 
     RowBox[{"b", "\[Implies]", 
      RowBox[{"(", 
       RowBox[{"a", "\[Implies]", "c"}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "\[Implies]", "b"}], ")"}], "\[Implies]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"\[Not]", "b"}], ")"}], "\[Implies]", 
      RowBox[{"(", 
       RowBox[{"\[Not]", "a"}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"\[Not]", 
      RowBox[{"\[Not]", "a"}]}], ")"}], "\[Implies]", "a"}], ",", 
   RowBox[{"a", "\[Implies]", 
    RowBox[{"(", 
     RowBox[{"\[Not]", 
      RowBox[{"\[Not]", "a"}]}], ")"}]}]}], "}"}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"a", "\[Implies]", 
       RowBox[{"(", 
        RowBox[{"b", "\[Implies]", "a"}], ")"}]}], ")"}], "\[Implies]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"\[Not]", "c"}], ")"}], "\[Implies]", 
           RowBox[{"(", 
            RowBox[{"d", "\[Implies]", 
             RowBox[{"(", 
              RowBox[{"\[Not]", "e"}], ")"}]}], ")"}]}], ")"}], "\[Implies]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"c", "\[Implies]", 
             RowBox[{"(", 
              RowBox[{"d", "\[Implies]", "f"}], ")"}]}], ")"}], "\[Implies]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"e", "\[Implies]", "d"}], ")"}], "\[Implies]", 
             RowBox[{"(", 
              RowBox[{"e", "\[Implies]", "f"}], ")"}]}], ")"}]}], ")"}]}], 
        ")"}], "\[Implies]", "g"}], ")"}]}], ")"}], "\[Implies]", 
   RowBox[{"(", 
    RowBox[{"h", "\[Implies]", "g"}], ")"}]}], "}"}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"\[Not]", "a"}], ")"}], "\[Implies]", 
      RowBox[{"(", 
       RowBox[{"b", "\[Implies]", 
        RowBox[{"(", 
         RowBox[{"\[Not]", "c"}], ")"}]}], ")"}]}], ")"}], "\[Implies]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "\[Implies]", 
        RowBox[{"(", 
         RowBox[{"b", "\[Implies]", "d"}], ")"}]}], ")"}], "\[Implies]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"c", "\[Implies]", "b"}], ")"}], "\[Implies]", 
        RowBox[{"(", 
         RowBox[{"c", "\[Implies]", "d"}], ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{"a", "\[Implies]", 
    RowBox[{"(", 
     RowBox[{"b", "\[Implies]", "a"}], ")"}]}]}], "}"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Module", "[", 
  RowBox[{
   RowBox[{"{", "a", "}"}], ",", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"Thread", "[", 
      RowBox[{"axioms", "==", 
       RowBox[{"a", "\[Implies]", "a"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "\[Implies]", "a"}], ")"}], "\[Implies]", "b"}], 
         ")"}], "==", "b"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "\[Implies]", "b"}], ")"}], "\[Implies]", "b"}], 
         ")"}], "==", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"b", "\[Implies]", "a"}], ")"}], "\[Implies]", "a"}]}]}], 
      "}"}]}], "]"}]}], "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"axioms", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"\[Not]", "a"}], ")"}], "\[Implies]", 
           RowBox[{"(", 
            RowBox[{"b", "\[Implies]", 
             RowBox[{"(", 
              RowBox[{"\[Not]", "c"}], ")"}]}], ")"}]}], ")"}], "\[Implies]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"a", "\[Implies]", 
             RowBox[{"(", 
              RowBox[{"b", "\[Implies]", "d"}], ")"}]}], ")"}], "\[Implies]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"c", "\[Implies]", "b"}], ")"}], "\[Implies]", 
             RowBox[{"(", 
              RowBox[{"c", "\[Implies]", "d"}], ")"}]}], ")"}]}], ")"}]}], 
        ",", 
        RowBox[{"a", "\[Implies]", 
         RowBox[{"(", 
          RowBox[{"b", "\[Implies]", "a"}], ")"}]}]}], "}"}]}], "}"}], ",", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "a", "}"}], ",", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"Thread", "[", 
         RowBox[{"axioms", "==", 
          RowBox[{"a", "\[Implies]", "a"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"a", "\[Implies]", "a"}], ")"}], "\[Implies]", "b"}], 
            ")"}], "==", "b"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"a", "\[Implies]", "b"}], ")"}], "\[Implies]", "b"}], 
            ")"}], "==", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"b", "\[Implies]", "a"}], ")"}], "\[Implies]", "a"}]}]}],
          "}"}]}], "]"}]}], "]"}]}], "]"}], "//", 
  "TraditionalForm"}]], "Input"],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\[Not]", "a"}], ")"}], "\[Implies]", 
         RowBox[{"(", 
          RowBox[{"b", "\[Implies]", 
           RowBox[{"(", 
            RowBox[{"\[Not]", "c"}], ")"}]}], ")"}]}], ")"}], "\[Implies]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "\[Implies]", 
           RowBox[{"(", 
            RowBox[{"b", "\[Implies]", "d"}], ")"}]}], ")"}], "\[Implies]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"c", "\[Implies]", "b"}], ")"}], "\[Implies]", 
           RowBox[{"(", 
            RowBox[{"c", "\[Implies]", "d"}], ")"}]}], ")"}]}], ")"}]}], 
      ")"}], "==", 
     RowBox[{"a$63", "\[Implies]", "a$63"}]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"a", "\[Implies]", 
       RowBox[{"(", 
        RowBox[{"b", "\[Implies]", "a"}], ")"}]}], ")"}], "==", 
     RowBox[{"a$63", "\[Implies]", "a$63"}]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a$63", "\[Implies]", "a$63"}], ")"}], "\[Implies]", "b"}], 
      ")"}], "==", "b"}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a$63", "\[Implies]", "b"}], ")"}], "\[Implies]", "b"}], 
      ")"}], "==", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[Implies]", "a$63"}], ")"}], "\[Implies]", "a$63"}]}]}],
    "}"}], TraditionalForm]], "Output"]
}, Open  ]]
}, Closed]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"a", "\[Nand]", 
     RowBox[{"(", 
      RowBox[{"b", "\[Nand]", "c"}], ")"}]}], ")"}], "\[Nand]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"e", "\[Nand]", 
       RowBox[{"(", 
        RowBox[{"e", "\[Nand]", "e"}], ")"}]}], ")"}], "\[Nand]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"d", "\[Nand]", "b"}], ")"}], "\[Nand]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "\[Nand]", "d"}], ")"}], "\[Nand]", 
         RowBox[{"(", 
          RowBox[{"a", "\[Nand]", "d"}], ")"}]}], ")"}]}], ")"}]}], ")"}]}], 
  "}"}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"a", "\[Nand]", 
     RowBox[{"(", 
      RowBox[{"b", "\[Nand]", "c"}], ")"}]}], ")"}], "\[Nand]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"d", "\[Nand]", "c"}], ")"}], "\[Nand]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "\[Nand]", "d"}], ")"}], "\[Nand]", 
         RowBox[{"(", 
          RowBox[{"a", "\[Nand]", "d"}], ")"}]}], ")"}]}], ")"}], "\[Nand]", 
     RowBox[{"(", 
      RowBox[{"a", "\[Nand]", 
       RowBox[{"(", 
        RowBox[{"a", "\[Nand]", "b"}], ")"}]}], ")"}]}], ")"}]}], 
  "}"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Module", "[", 
  RowBox[{
   RowBox[{"{", "a", "}"}], ",", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"t", "=", 
        RowBox[{"a", "\[Nand]", 
         RowBox[{"(", 
          RowBox[{"a", "\[Nand]", "a"}], ")"}]}]}], ",", 
       RowBox[{"i", "=", 
        RowBox[{
         RowBox[{"#1", "\[Nand]", 
          RowBox[{"(", 
           RowBox[{"#2", "\[Nand]", "#2"}], ")"}]}], "&"}]}]}], "}"}], ",", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"Thread", "[", 
        RowBox[{"axioms", "==", "t"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"i", "[", 
           RowBox[{
            RowBox[{"t", "\[Nand]", 
             RowBox[{"(", 
              RowBox[{"b", "\[Nand]", "c"}], ")"}]}], ",", "c"}], "]"}], "==",
           "t"}], ",", 
         RowBox[{
          RowBox[{"i", "[", 
           RowBox[{"t", ",", "b"}], "]"}], "==", "b"}], ",", 
         RowBox[{
          RowBox[{"i", "[", 
           RowBox[{
            RowBox[{"i", "[", 
             RowBox[{"a", ",", "b"}], "]"}], ",", "b"}], "]"}], "==", 
          RowBox[{"i", "[", 
           RowBox[{
            RowBox[{"i", "[", 
             RowBox[{"b", ",", "a"}], "]"}], ",", "a"}], "]"}]}]}], "}"}]}], 
      "]"}]}], "]"}]}], "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"axioms", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "\[Nand]", 
          RowBox[{"(", 
           RowBox[{"b", "\[Nand]", "c"}], ")"}]}], ")"}], "\[Nand]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"d", "\[Nand]", "c"}], ")"}], "\[Nand]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"a", "\[Nand]", "d"}], ")"}], "\[Nand]", 
              RowBox[{"(", 
               RowBox[{"a", "\[Nand]", "d"}], ")"}]}], ")"}]}], ")"}], 
          "\[Nand]", 
          RowBox[{"(", 
           RowBox[{"a", "\[Nand]", 
            RowBox[{"(", 
             RowBox[{"a", "\[Nand]", "b"}], ")"}]}], ")"}]}], ")"}]}], 
       "}"}]}], "}"}], ",", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "a", "}"}], ",", 
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"t", "=", 
           RowBox[{"a", "\[Nand]", 
            RowBox[{"(", 
             RowBox[{"a", "\[Nand]", "a"}], ")"}]}]}], ",", 
          RowBox[{"i", "=", 
           RowBox[{
            RowBox[{"#1", "\[Nand]", 
             RowBox[{"(", 
              RowBox[{"#2", "\[Nand]", "#2"}], ")"}]}], "&"}]}]}], "}"}], ",", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"Thread", "[", 
           RowBox[{"axioms", "==", "t"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"i", "[", 
              RowBox[{
               RowBox[{"t", "\[Nand]", 
                RowBox[{"(", 
                 RowBox[{"b", "\[Nand]", "c"}], ")"}]}], ",", "c"}], "]"}], "==",
              "t"}], ",", 
            RowBox[{
             RowBox[{"i", "[", 
              RowBox[{"t", ",", "b"}], "]"}], "==", "b"}], ",", 
            RowBox[{
             RowBox[{"i", "[", 
              RowBox[{
               RowBox[{"i", "[", 
                RowBox[{"a", ",", "b"}], "]"}], ",", "b"}], "]"}], "==", 
             RowBox[{"i", "[", 
              RowBox[{
               RowBox[{"i", "[", 
                RowBox[{"b", ",", "a"}], "]"}], ",", "a"}], "]"}]}]}], 
           "}"}]}], "]"}]}], "]"}]}], "]"}]}], "]"}], "//", 
  "TraditionalForm"}]], "Input"],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "\[Nand]", 
         RowBox[{"(", 
          RowBox[{"b", "\[Nand]", "c"}], ")"}]}], ")"}], "\[Nand]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"d", "\[Nand]", "c"}], ")"}], "\[Nand]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"a", "\[Nand]", "d"}], ")"}], "\[Nand]", 
             RowBox[{"(", 
              RowBox[{"a", "\[Nand]", "d"}], ")"}]}], ")"}]}], ")"}], 
         "\[Nand]", 
         RowBox[{"(", 
          RowBox[{"a", "\[Nand]", 
           RowBox[{"(", 
            RowBox[{"a", "\[Nand]", "b"}], ")"}]}], ")"}]}], ")"}]}], ")"}], "==", 
     RowBox[{"(", 
      RowBox[{"a$66", "\[Nand]", 
       RowBox[{"(", 
        RowBox[{"a$66", "\[Nand]", "a$66"}], ")"}]}], ")"}]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a$66", "\[Nand]", 
           RowBox[{"(", 
            RowBox[{"a$66", "\[Nand]", "a$66"}], ")"}]}], ")"}], "\[Nand]", 
         RowBox[{"(", 
          RowBox[{"b", "\[Nand]", "c"}], ")"}]}], ")"}], "\[Nand]", 
       RowBox[{"(", 
        RowBox[{"c", "\[Nand]", "c"}], ")"}]}], ")"}], "==", 
     RowBox[{"(", 
      RowBox[{"a$66", "\[Nand]", 
       RowBox[{"(", 
        RowBox[{"a$66", "\[Nand]", "a$66"}], ")"}]}], ")"}]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a$66", "\[Nand]", 
         RowBox[{"(", 
          RowBox[{"a$66", "\[Nand]", "a$66"}], ")"}]}], ")"}], "\[Nand]", 
       RowBox[{"(", 
        RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}], "==", "b"}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a$66", "\[Nand]", 
         RowBox[{"(", 
          RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}], "\[Nand]", 
       RowBox[{"(", 
        RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}], "==", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "\[Nand]", 
         RowBox[{"(", 
          RowBox[{"a$66", "\[Nand]", "a$66"}], ")"}]}], ")"}], "\[Nand]", 
       RowBox[{"(", 
        RowBox[{"a$66", "\[Nand]", "a$66"}], ")"}]}], ")"}]}]}], "}"}], 
  TraditionalForm]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Other algebraic systems", "Subsection"], Cell[" (page 1153)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "\[Wedge]", "b"}], "==", 
    RowBox[{"b", "\[Wedge]", "a"}]}], ",", 
   RowBox[{
    RowBox[{"a", "\[Vee]", "b"}], "==", 
    RowBox[{"b", "\[Vee]", "a"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"a", "\[Wedge]", "b"}], ")"}], "\[Wedge]", "c"}], "==", 
    RowBox[{"a", "\[Wedge]", 
     RowBox[{"(", 
      RowBox[{"b", "\[Wedge]", "c"}], ")"}]}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"a", "\[Vee]", "b"}], ")"}], "\[Vee]", "c"}], "==", 
    RowBox[{"a", "\[Vee]", 
     RowBox[{"(", 
      RowBox[{"b", "\[Vee]", "c"}], ")"}]}]}], ",", 
   RowBox[{
    RowBox[{"a", "\[Wedge]", 
     RowBox[{"(", 
      RowBox[{"a", "\[Vee]", "b"}], ")"}]}], "==", "a"}], ",", 
   RowBox[{
    RowBox[{"a", "\[Vee]", 
     RowBox[{"a", "\[Wedge]", "b"}]}], "==", "a"}]}], "}"}]], "Subsubsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 775 \[CenterDot] Implementation", "Subsection"], Cell[
     " (page 1155)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"s", "[", "1", "]"}], "=", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_", "\[Nand]", "a_"}], ")"}], "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"a_", "\[Nand]", "b_"}], ")"}]}], "\[Rule]", "a"}]}], ";", 
   RowBox[{
    RowBox[{"s", "[", 
     RowBox[{"2", ",", "x_"}], "]"}], ":=", 
    RowBox[{"b_", "\[Rule]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"b", "\[Nand]", "x"}], ")"}]}]}]}], ";"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"s", "[", "3", "]"}], "=", 
    RowBox[{
     RowBox[{"a_", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"a_", "\[Nand]", "b_"}], ")"}]}], "\[Rule]", 
     RowBox[{"a", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"b", "\[Nand]", "b"}], ")"}]}]}]}], ";", 
   RowBox[{
    RowBox[{"s", "[", "4", "]"}], "=", 
    RowBox[{
     RowBox[{"a_", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"b_", "\[Nand]", "b_"}], ")"}]}], "\[Rule]", 
     RowBox[{"a", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"a", "\[Nand]", "b"}], ")"}]}]}]}], ";"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"s", "[", "5", "]"}], "=", 
    RowBox[{
     RowBox[{"a_", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"a_", "\[Nand]", 
        RowBox[{"(", 
         RowBox[{"b_", "\[Nand]", "c_"}], ")"}]}], ")"}]}], "\[Rule]", 
     RowBox[{"b", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"b", "\[Nand]", 
        RowBox[{"(", 
         RowBox[{"a", "\[Nand]", "c"}], ")"}]}], ")"}]}]}]}], ";"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"s", "[", 
       RowBox[{"2", ",", "b"}], "]"}], ",", 
      RowBox[{"{", "2", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"s", "[", "4", "]"}], ",", 
      RowBox[{"{", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"s", "[", 
       RowBox[{"2", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", 
           RowBox[{"(", 
            RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}]}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"s", "[", "1", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2", ",", "1"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"s", "[", 
       RowBox[{"2", ",", 
        RowBox[{"b", "\[Nand]", "b"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2", ",", "2", ",", "2", ",", "2", ",", "2"}], 
       "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"s", "[", "5", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"s", "[", 
       RowBox[{"2", ",", 
        RowBox[{"b", "\[Nand]", "b"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2", ",", "2", ",", "2", ",", "2", ",", "1"}], 
       "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"s", "[", "1", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2", ",", "2", ",", "2", ",", "2"}], "}"}]}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"s", "[", "3", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"s", "[", "1", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"s", "[", "4", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"s", "[", "5", "]"}], ",", 
      RowBox[{"{", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"s", "[", 
       RowBox[{"2", ",", "a"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2", ",", "1"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"s", "[", "1", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"s", "[", "3", "]"}], ",", 
      RowBox[{"{", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"s", "[", "1", "]"}], ",", 
      RowBox[{"{", "2", "}"}]}], "}"}]}], "}"}], "\n"}], "\n", 
 RowBox[{"FoldList", "[", 
  RowBox[{
   RowBox[{"Function", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"u", ",", "v"}], "}"}], ",", 
     RowBox[{"MapAt", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Replace", "[", 
         RowBox[{"#", ",", 
          RowBox[{
          "v", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
         "]"}], "&"}], ",", "u", ",", 
       RowBox[{"{", 
        RowBox[{"v", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
        "}"}]}], "]"}]}], "]"}], ",", 
   RowBox[{"a", "\[Nand]", "b"}], ",", "proof"}], "]"}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"s", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"a_", "\[Nand]", "a_"}], ")"}], "\[Nand]", 
     RowBox[{"(", 
      RowBox[{"a_", "\[Nand]", "b_"}], ")"}]}], "\[Rule]", "a"}]}], ";", 
  RowBox[{
   RowBox[{"s", "[", 
    RowBox[{"2", ",", "x_"}], "]"}], ":=", 
   RowBox[{"b_", "\[Rule]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
     RowBox[{"(", 
      RowBox[{"b", "\[Nand]", "x"}], ")"}]}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"s", "[", "3", "]"}], "=", 
   RowBox[{
    RowBox[{"a_", "\[Nand]", 
     RowBox[{"(", 
      RowBox[{"a_", "\[Nand]", "b_"}], ")"}]}], "\[Rule]", 
    RowBox[{"a", "\[Nand]", 
     RowBox[{"(", 
      RowBox[{"b", "\[Nand]", "b"}], ")"}]}]}]}], ";", 
  RowBox[{
   RowBox[{"s", "[", "4", "]"}], "=", 
   RowBox[{
    RowBox[{"a_", "\[Nand]", 
     RowBox[{"(", 
      RowBox[{"b_", "\[Nand]", "b_"}], ")"}]}], "\[Rule]", 
    RowBox[{"a", "\[Nand]", 
     RowBox[{"(", 
      RowBox[{"a", "\[Nand]", "b"}], ")"}]}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"s", "[", "5", "]"}], "=", 
   RowBox[{
    RowBox[{"a_", "\[Nand]", 
     RowBox[{"(", 
      RowBox[{"a_", "\[Nand]", 
       RowBox[{"(", 
        RowBox[{"b_", "\[Nand]", "c_"}], ")"}]}], ")"}]}], "\[Rule]", 
    RowBox[{"b", "\[Nand]", 
     RowBox[{"(", 
      RowBox[{"b", "\[Nand]", 
       RowBox[{"(", 
        RowBox[{"a", "\[Nand]", "c"}], ")"}]}], ")"}]}]}]}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"proof", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", 
          RowBox[{"2", ",", "b"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", "4", "]"}], ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", 
          RowBox[{"2", ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", 
              RowBox[{"(", 
               RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}]}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", "1", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", 
          RowBox[{"2", ",", 
           RowBox[{"b", "\[Nand]", "b"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "2", ",", "2", ",", "2", ",", "2"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", "5", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", 
          RowBox[{"2", ",", 
           RowBox[{"b", "\[Nand]", "b"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "2", ",", "2", ",", "2", ",", "1"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", "1", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "2", ",", "2", ",", "2"}], "}"}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", "3", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", "1", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", "4", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", "5", "]"}], ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", 
          RowBox[{"2", ",", "a"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", "1", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", "3", "]"}], ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", "1", "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "}"}]}], "}"}]}], "}"}], ",", "\n", 
   RowBox[{"FoldList", "[", 
    RowBox[{
     RowBox[{"Function", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"u", ",", "v"}], "}"}], ",", 
       RowBox[{"MapAt", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Replace", "[", 
           RowBox[{"#", ",", 
            RowBox[{
            "v", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
           "]"}], "&"}], ",", "u", ",", 
         RowBox[{"{", 
          RowBox[{"v", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
           "}"}]}], "]"}]}], "]"}], ",", 
     RowBox[{"a", "\[Nand]", "b"}], ",", "proof"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"a", "\[Nand]", "b"}], ",", 
   RowBox[{"a", "\[Nand]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}]}], ",", 
   RowBox[{"a", "\[Nand]", 
    RowBox[{"(", 
     RowBox[{"a", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}]}], ",", 
   RowBox[{"a", "\[Nand]", 
    RowBox[{"(", 
     RowBox[{"a", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
          RowBox[{"(", 
           RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}], "\[Nand]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", 
              RowBox[{"(", 
               RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}]}], ")"}]}], 
         ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{"a", "\[Nand]", 
    RowBox[{"(", 
     RowBox[{"a", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"b", "\[Nand]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", 
              RowBox[{"(", 
               RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}]}], ")"}]}], 
         ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{"a", "\[Nand]", 
    RowBox[{"(", 
     RowBox[{"a", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"b", "\[Nand]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
                  RowBox[{"(", 
                   RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}], "\[Nand]", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
                  RowBox[{"(", 
                   RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}]}], ")"}]}], 
             ")"}]}], ")"}]}], ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{"a", "\[Nand]", 
    RowBox[{"(", 
     RowBox[{"a", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"b", "\[Nand]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
                  RowBox[{"(", 
                   RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}], "\[Nand]", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
                  RowBox[{"(", 
                   RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}]}], ")"}]}], 
             ")"}]}], ")"}]}], ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{"a", "\[Nand]", 
    RowBox[{"(", 
     RowBox[{"a", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"b", "\[Nand]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
                  RowBox[{"(", 
                   RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}], "\[Nand]", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
                  RowBox[{"(", 
                   RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}]}], ")"}], 
              "\[Nand]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
                  RowBox[{"(", 
                   RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}], "\[Nand]", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
                  RowBox[{"(", 
                   RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}]}], ")"}]}], 
             ")"}]}], ")"}]}], ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{"a", "\[Nand]", 
    RowBox[{"(", 
     RowBox[{"a", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"b", "\[Nand]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
              RowBox[{"(", 
               RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}]}], ")"}]}], 
         ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{"a", "\[Nand]", 
    RowBox[{"(", 
     RowBox[{"a", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"b", "\[Nand]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
              RowBox[{"(", 
               RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}], "\[Nand]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", 
              RowBox[{"(", 
               RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}]}], ")"}]}], ")"}]
         }], ")"}]}], ")"}]}], ",", 
   RowBox[{"a", "\[Nand]", 
    RowBox[{"(", 
     RowBox[{"a", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"b", "\[Nand]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", 
          RowBox[{"(", 
           RowBox[{"b", "\[Nand]", "b"}], ")"}]}], ")"}]}], ")"}]}], ")"}]}], 
   ",", 
   RowBox[{"a", "\[Nand]", 
    RowBox[{"(", 
     RowBox[{"a", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"b", "\[Nand]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", "b"}], ")"}]}], 
         ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{"b", "\[Nand]", 
    RowBox[{"(", 
     RowBox[{"b", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"a", "\[Nand]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", "b"}], ")"}]}], 
         ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{"b", "\[Nand]", 
    RowBox[{"(", 
     RowBox[{"b", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", 
          RowBox[{"(", 
           RowBox[{"a", "\[Nand]", "a"}], ")"}]}], ")"}], "\[Nand]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", "b"}], ")"}]}], 
         ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{"b", "\[Nand]", 
    RowBox[{"(", 
     RowBox[{"b", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"a", "\[Nand]", "a"}], ")"}]}], ")"}]}], ",", 
   RowBox[{"b", "\[Nand]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"a", "\[Nand]", "a"}], ")"}]}], ")"}]}], ",", 
   RowBox[{"b", "\[Nand]", "a"}]}], "}"}]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 776 \[CenterDot] Proof structures", "Subsection"], Cell[
     " (page 1155)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"a", "\[Nand]", 
    RowBox[{"(", 
     RowBox[{"a", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"b", "\[Nand]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", "c"}], ")"}]}], 
       ")"}]}], ")"}]}], ")"}], "\[LongEqual]", 
  RowBox[{"(", 
   RowBox[{"b", "\[Nand]", "a"}], ")"}]}]], "Subsubsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 781 \[CenterDot] Nand tautologies", "Subsection"], Cell[
     " (page 1157)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Nest", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"#", "\[Nand]", "#"}], ")"}], "\[Nand]", 
     RowBox[{"(", 
      RowBox[{"#", "\[Nand]", 
       SubscriptBox["p", "t"]}], ")"}]}], "&"}], ",", 
   RowBox[{"p", "\[Nand]", 
    RowBox[{"(", 
     RowBox[{"p", "\[Nand]", "p"}], ")"}]}], ",", 
   RowBox[{"t", "-", "1"}]}], "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"t", "=", "3"}], "}"}], ",", 
   RowBox[{"Nest", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"#", "\[Nand]", "#"}], ")"}], "\[Nand]", 
       RowBox[{"(", 
        RowBox[{"#", "\[Nand]", 
         SubscriptBox["p", "t"]}], ")"}]}], "&"}], ",", 
     RowBox[{"p", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"p", "\[Nand]", "p"}], ")"}]}], ",", 
     RowBox[{"t", "-", "1"}]}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"p", "\[Nand]", 
          RowBox[{"(", 
           RowBox[{"p", "\[Nand]", "p"}], ")"}]}], ")"}], "\[Nand]", 
        RowBox[{"(", 
         RowBox[{"p", "\[Nand]", 
          RowBox[{"(", 
           RowBox[{"p", "\[Nand]", "p"}], ")"}]}], ")"}]}], ")"}], "\[Nand]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"p", "\[Nand]", 
          RowBox[{"(", 
           RowBox[{"p", "\[Nand]", "p"}], ")"}]}], ")"}], "\[Nand]", 
        SubscriptBox["p", "3"]}], ")"}]}], ")"}], "\[Nand]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"p", "\[Nand]", 
          RowBox[{"(", 
           RowBox[{"p", "\[Nand]", "p"}], ")"}]}], ")"}], "\[Nand]", 
        RowBox[{"(", 
         RowBox[{"p", "\[Nand]", 
          RowBox[{"(", 
           RowBox[{"p", "\[Nand]", "p"}], ")"}]}], ")"}]}], ")"}], "\[Nand]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"p", "\[Nand]", 
          RowBox[{"(", 
           RowBox[{"p", "\[Nand]", "p"}], ")"}]}], ")"}], "\[Nand]", 
        SubscriptBox["p", "3"]}], ")"}]}], ")"}]}], ")"}], "\[Nand]", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"p", "\[Nand]", 
          RowBox[{"(", 
           RowBox[{"p", "\[Nand]", "p"}], ")"}]}], ")"}], "\[Nand]", 
        RowBox[{"(", 
         RowBox[{"p", "\[Nand]", 
          RowBox[{"(", 
           RowBox[{"p", "\[Nand]", "p"}], ")"}]}], ")"}]}], ")"}], "\[Nand]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"p", "\[Nand]", 
          RowBox[{"(", 
           RowBox[{"p", "\[Nand]", "p"}], ")"}]}], ")"}], "\[Nand]", 
        SubscriptBox["p", "3"]}], ")"}]}], ")"}], "\[Nand]", 
    SubscriptBox["p", "3"]}], ")"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"LeafCount", "[", 
    RowBox[{"Nest", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"#", "\[Nand]", "#"}], ")"}], "\[Nand]", 
        RowBox[{"(", 
         RowBox[{"#", "\[Nand]", 
          SubscriptBox["p", "t"]}], ")"}]}], "&"}], ",", 
      RowBox[{"p", "\[Nand]", 
       RowBox[{"(", 
        RowBox[{"p", "\[Nand]", "p"}], ")"}]}], ",", 
      RowBox[{"t", "-", "1"}]}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "13"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "5", ",", "21", ",", "69", ",", "213", ",", "645", ",", "1941", ",", "5829",
    ",", "17493", ",", "52485", ",", "157461", ",", "472389", ",", "1417173", 
   ",", "4251525"}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"8", "*", 
     SuperscriptBox["3", 
      RowBox[{"t", "-", "1"}]]}], "-", "3"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "13"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "5", ",", "21", ",", "69", ",", "213", ",", "645", ",", "1941", ",", "5829",
    ",", "17493", ",", "52485", ",", "157461", ",", "472389", ",", "1417173", 
   ",", "4251525"}], "}"}]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 784 \[CenterDot] Algebraic axioms", "Subsection"], Cell[
     " (page 1159)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"a", "\[CenterDot]", "x"}], "==", 
   RowBox[{"a", "\[CenterDot]", "y"}]}], "\[Implies]", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"x", "==", "y"}], "\[And]", 
     RowBox[{
      SubscriptBox["\[Exists]", "z"], 
      RowBox[{
       RowBox[{"a", "\[CenterDot]", "z"}], "==", "x"}]}]}], ")"}], "\[And]", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "\[CenterDot]", "x"}], "==", 
     RowBox[{"b", "\[CenterDot]", "x"}]}], "\[Implies]", 
    RowBox[{"a", "==", "b"}]}], "\[And]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"a", "\[CenterDot]", "b"}], ")"}], "\[CenterDot]", "x"}], "==", 
    RowBox[{"a", "\[CenterDot]", 
     RowBox[{"(", 
      RowBox[{"b", "\[CenterDot]", "x"}], ")"}]}]}]}]}]], "Subsubsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 784 \[CenterDot] Set theory", "Subsection"], Cell[
     " (page 1160)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Nest", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Union", "[", 
      RowBox[{"#", ",", 
       RowBox[{"{", "#", "}"}]}], "]"}], "&"}], ",", 
    RowBox[{"{", "}"}], ",", "n"}], "]"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{"Replace", "[", 
  RowBox[{"s", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       SubscriptBox["\[ForAll]", "a_"], "b_"}], "\[Rule]", 
      RowBox[{
       SubscriptBox["\[ForAll]", "a"], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"a", "\[Element]", "\[DoubleStruckCapitalN]"}], "\[Implies]",
          "b"}], ")"}]}]}], ",", 
     RowBox[{
      RowBox[{
       SubscriptBox["\[Exists]", "a_"], "b_"}], "\[Rule]", 
      RowBox[{
       SubscriptBox["\[Exists]", "a"], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"a", "\[Element]", "\[DoubleStruckCapitalN]"}], "\[And]", 
         "b"}], ")"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "\[Infinity]"}], "}"}]}], "]"}]}], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"n", "=", "4"}], "}"}], ",", 
   RowBox[{"Nest", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Union", "[", 
       RowBox[{"#", ",", 
        RowBox[{"{", "#", "}"}]}], "]"}], "&"}], ",", 
     RowBox[{"{", "}"}], ",", "n"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"{", "}"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", "}"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"{", "}"}], "}"}]}], "}"}]}], "}"}]}], "}"}]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 786 \[CenterDot] Universal Diophantine equation\
\>", "Subsection"], Cell[" (page 1160)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"a", "==", "0"}], "\[Or]", 
      RowBox[{"b", "==", "0"}]}], ")"}], "\[LongLeftRightArrow]", "a"}], " ", 
   "b"}], "==", "0"}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"a", "==", "0"}], "\[And]", 
      RowBox[{"b", "==", "0"}]}], ")"}], "\[LongLeftRightArrow]", "a"}], "+", 
   "b"}], "==", "0"}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"a", "<", 
  RowBox[{"b", "\[LongLeftRightArrow]", "b"}], "==", 
  RowBox[{"a", "+", "c", "+", "1"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"a", "==", 
  RowBox[{
   RowBox[{"Mod", "[", 
    RowBox[{"b", ",", "c"}], "]"}], "\[LongLeftRightArrow]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"b", "==", 
      RowBox[{"a", "+", 
       RowBox[{"c", " ", "d"}]}]}], "\[And]", 
     RowBox[{"a", "<", "c"}]}], ")"}]}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"a", "==", 
  RowBox[{
   RowBox[{"Quotient", "[", 
    RowBox[{"b", ",", "c"}], "]"}], "\[LongLeftRightArrow]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"b", "==", 
      RowBox[{
       RowBox[{"a", " ", "c"}], "+", "d"}]}], "\[And]", 
     RowBox[{"d", "<", "c"}]}], ")"}]}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"a", "==", 
  RowBox[{
   RowBox[{"Binomial", "[", 
    RowBox[{"b", ",", "c"}], "]"}], "\[LongLeftRightArrow]", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", "=", 
       RowBox[{
        SuperscriptBox["2", 
         RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "b"}]], "+", "1"}]}], 
      "}"}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"n", "+", "1"}], ")"}], 
        RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "b"}]], "==", 
       RowBox[{
        RowBox[{
         SuperscriptBox["n", 
          RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "c"}]], " ", 
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"d", " ", "n"}]}], ")"}]}], "+", "e"}]}], "\[And]", 
      RowBox[{"e", "<", 
       SuperscriptBox["n", 
        RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "c"}]]}], "\[And]", 
      RowBox[{"a", "<", "n"}]}]}], "]"}]}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"a", "==", 
  RowBox[{
   RowBox[{"b", "!"}], "\[LongLeftRightArrow]", "a"}], "==", 
  RowBox[{"Quotient", "[", 
   RowBox[{
    SuperscriptBox["c", 
     RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "b"}]], ",", 
    RowBox[{"Binomial", "[", 
     RowBox[{"c", ",", "b"}], "]"}]}], "]"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"a", "==", 
  RowBox[{
   RowBox[{"GCD", "[", 
    RowBox[{"b", ",", "c"}], "]"}], "\[LongLeftRightArrow]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"b", " ", "c"}], ">", "0"}], "\[And]", 
     RowBox[{
      RowBox[{"a", " ", "d"}], "==", "b"}], "\[And]", 
     RowBox[{
      RowBox[{"a", " ", "e"}], "==", "c"}], "\[And]", 
     RowBox[{
      RowBox[{"a", "+", 
       RowBox[{"c", " ", "f"}]}], "==", 
      RowBox[{"b", " ", "g"}]}]}], ")"}]}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"a", "==", 
  RowBox[{
   RowBox[{"Floor", "[", 
    RowBox[{"b", "/", "c"}], "]"}], "\[LongLeftRightArrow]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"a", " ", "c"}], "+", "d"}], "==", "b"}], "\[And]", 
     RowBox[{"d", "<", "c"}]}], ")"}]}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PrimeQ", "[", "a", "]"}], "\[LongLeftRightArrow]", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"GCD", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "-", "1"}], ")"}], "!"}], ",", "a"}], "]"}], "==", 
     "1"}], "\[And]", 
    RowBox[{"a", ">", "1"}]}], ")"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"a", "==", 
    RowBox[{"BitAnd", "[", 
     RowBox[{"c", ",", "d"}], "]"}]}], "\[And]", 
   RowBox[{"b", "==", 
    RowBox[{
     RowBox[{"BitOr", "[", 
      RowBox[{"c", ",", "d"}], "]"}], "\[LongLeftRightArrow]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"\[Sigma]", "[", 
        RowBox[{"c", ",", "a"}], "]"}], "\[And]", 
       RowBox[{"\[Sigma]", "[", 
        RowBox[{"d", ",", "a"}], "]"}], "\[And]", 
       RowBox[{"\[Sigma]", "[", 
        RowBox[{"b", ",", "c"}], "]"}], "\[And]", 
       RowBox[{"\[Sigma]", "[", 
        RowBox[{"b", ",", "d"}], "]"}], "\[And]", 
       RowBox[{
        RowBox[{"a", "+", "b"}], "==", 
        RowBox[{"c", "+", "d"}]}]}], ")"}]}]}]}], "/.", "\[InvisibleSpace]", 
  RowBox[{
   RowBox[{"\[Sigma]", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], "\[Rule]", 
   RowBox[{
    RowBox[{"Mod", "[", 
     RowBox[{
      RowBox[{"Binomial", "[", 
       RowBox[{"x", ",", "y"}], "]"}], ",", "2"}], "]"}], "==", 
    "1"}]}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"BitXor", "[", 
  RowBox[{"a", ",", 
   RowBox[{"2", " ", 
    RowBox[{"BitOr", "[", 
     RowBox[{"a", ",", 
      RowBox[{"2", " ", "a"}]}], "]"}]}]}], "]"}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BitXor", "[", 
   RowBox[{"x", ",", "y"}], "]"}], "==", 
  RowBox[{
   RowBox[{"BitOr", "[", 
    RowBox[{"x", ",", "y"}], "]"}], "-", 
   RowBox[{"BitAnd", "[", 
    RowBox[{"x", ",", "y"}], "]"}]}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"BitXor", "[", 
  RowBox[{
   RowBox[{"BitAnd", "[", 
    RowBox[{"a", ",", 
     RowBox[{"2", " ", "a"}], ",", 
     RowBox[{"4", " ", "a"}]}], "]"}], ",", 
   RowBox[{"BitOr", "[", 
    RowBox[{
     RowBox[{"2", " ", "a"}], ",", 
     RowBox[{"4", " ", "a"}]}], "]"}]}], "]"}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"1", "+", 
     SubscriptBox["x", "4"], "+", 
     SubscriptBox["x", "12"]}], "==", 
    SuperscriptBox["2", 
     RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SubscriptBox["x", "3"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["x", "1"], "+", 
         RowBox[{"2", " ", 
          SubscriptBox["x", "3"]}]}], ")"}]}]}]]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["x", "2"], "+", 
     SubscriptBox["x", "13"]}], "==", 
    SuperscriptBox["2", 
     RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
      SubscriptBox["x", "1"]}]]}], ",", 
   RowBox[{
    RowBox[{"1", "+", 
     SubscriptBox["x", "5"], "+", 
     SubscriptBox["x", "14"]}], "==", 
    SuperscriptBox["2", 
     RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
      SubscriptBox["x", "1"]}]]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      SuperscriptBox["2", 
       RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
        SubscriptBox["x", "3"]}]], " ", 
      SubscriptBox["x", "5"]}], "+", 
     RowBox[{
      SuperscriptBox["2", 
       RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
        RowBox[{
         SubscriptBox["x", "1"], "+", 
         RowBox[{"2", " ", 
          SubscriptBox["x", "3"]}]}]}]], " ", 
      SubscriptBox["x", "6"]}], "+", 
     RowBox[{
      SuperscriptBox["2", 
       RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
        RowBox[{
         SubscriptBox["x", "1"], "+", 
         SubscriptBox["x", "3"]}]}]], " ", 
      SubscriptBox["x", "15"]}], "+", 
     SubscriptBox["x", "16"]}], "==", 
    SubscriptBox["x", "4"]}], ",", 
   RowBox[{
    RowBox[{"1", "+", 
     SubscriptBox["x", "15"], "+", 
     SubscriptBox["x", "17"]}], "==", 
    SuperscriptBox["2", 
     RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
      SubscriptBox["x", "3"]}]]}], ",", 
   RowBox[{
    RowBox[{"1", "+", 
     SubscriptBox["x", "16"], "+", 
     SubscriptBox["x", "18"]}], "==", 
    SuperscriptBox["2", 
     RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
      SubscriptBox["x", "3"]}]]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      SuperscriptBox["2", 
       RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
        RowBox[{"1", "+", 
         RowBox[{
          SubscriptBox["x", "3"], " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SubscriptBox["x", "1"], "+", 
            RowBox[{"2", " ", 
             SubscriptBox["x", "3"]}]}], ")"}]}]}]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SubscriptBox["x", "2"]}], ")"}]}], "-", 
     SubscriptBox["x", "10"], "+", 
     SubscriptBox["x", "11"]}], "==", 
    RowBox[{"2", " ", 
     SubscriptBox["x", "4"]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["x", "7"], "==", 
     RowBox[{"BitAnd", "[", 
      RowBox[{
       SubscriptBox["x", "6"], ",", 
       RowBox[{"2", " ", 
        SubscriptBox["x", "6"]}]}], "]"}]}], "\[And]", 
    RowBox[{
     SubscriptBox["x", "8"], "==", 
     RowBox[{"BitOr", "[", 
      RowBox[{
       SubscriptBox["x", "6"], ",", 
       RowBox[{"2", " ", 
        SubscriptBox["x", "6"]}]}], "]"}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["x", "9"], "==", 
     RowBox[{"BitAnd", "[", 
      RowBox[{
       SubscriptBox["x", "6"], ",", 
       RowBox[{"2", " ", 
        SubscriptBox["x", "7"]}]}], "]"}]}], "\[And]", 
    RowBox[{
     SubscriptBox["x", "19"], "==", 
     RowBox[{"BitOr", "[", 
      RowBox[{
       SubscriptBox["x", "6"], ",", 
       RowBox[{"2", " ", 
        SubscriptBox["x", "7"]}]}], "]"}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["x", "10"], "==", 
     RowBox[{"BitAnd", "[", 
      RowBox[{
       SubscriptBox["x", "9"], ",", 
       RowBox[{"2", " ", 
        SubscriptBox["x", "8"]}]}], "]"}]}], "\[And]", 
    RowBox[{
     SubscriptBox["x", "11"], "==", 
     RowBox[{"BitOr", "[", 
      RowBox[{
       SubscriptBox["x", "9"], ",", 
       RowBox[{"2", " ", 
        SubscriptBox["x", "8"]}]}], "]"}]}]}]}], "}"}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "==", 
   RowBox[{
    SuperscriptBox["b", 
     RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "c"}]], 
    "\[LongLeftRightArrow]", 
    RowBox[{"\[Alpha]", "[", 
     RowBox[{"d", ",", 
      RowBox[{"4", "+", 
       RowBox[{"b", " ", "e"}]}], ",", 
      RowBox[{"1", "+", "z"}]}], "]"}]}]}], "\[And]", 
  RowBox[{"\[Alpha]", "[", 
   RowBox[{"f", ",", "e", ",", 
    RowBox[{"1", "+", "z"}]}], "]"}], "\[And]", 
  RowBox[{"a", "==", 
   RowBox[{"Quotient", "[", 
    RowBox[{"d", ",", "f"}], "]"}]}], "\[And]", 
  RowBox[{"\[Alpha]", "[", 
   RowBox[{"g", ",", 
    RowBox[{"4", "+", "b"}], ",", 
    RowBox[{"1", "+", "z"}]}], "]"}], "\[And]", 
  RowBox[{"e", "==", 
   RowBox[{"16", " ", "g", " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "z"}], ")"}]}]}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Lambda]", "[", 
   RowBox[{"a_", ",", "b_", ",", "c_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "x", "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"2", " ", "a"}], "+", 
       SubscriptBox["x", "1"]}], "==", "c"}], "\[And]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"Mod", "[", 
         RowBox[{
          RowBox[{"b", "-", "a"}], ",", "c"}], "]"}], "==", "0"}], "\[Or]", 
       RowBox[{
        RowBox[{"Mod", "[", 
         RowBox[{
          RowBox[{"b", "+", "a"}], ",", "c"}], "]"}], "==", "0"}]}], 
      ")"}]}]}], "]"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Alpha]", "[", 
   RowBox[{"a_", ",", "b_", ",", "c_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "x", "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox[
        SubscriptBox["x", "1"], 
        RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "2"}]], "-", 
       RowBox[{"b", " ", 
        SubscriptBox["x", "1"], " ", 
        SubscriptBox["x", "2"]}], "+", 
       SuperscriptBox[
        SubscriptBox["x", "2"], 
        RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "2"}]]}], "==", "1"}], 
     "\[And]", 
     RowBox[{
      RowBox[{
       SuperscriptBox[
        SubscriptBox["x", "3"], 
        RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "2"}]], "-", 
       RowBox[{"b", " ", 
        SubscriptBox["x", "3"], " ", 
        SubscriptBox["x", "4"]}], "+", 
       SuperscriptBox[
        SubscriptBox["x", "4"], 
        RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "2"}]]}], "==", "1"}], 
     "\[And]", 
     RowBox[{
      RowBox[{"1", "+", 
       SubscriptBox["x", "4"], "+", 
       SubscriptBox["x", "5"]}], "==", 
      SubscriptBox["x", "3"]}], "\[And]", 
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{
        SubscriptBox["x", "3"], ",", 
        SuperscriptBox[
         SubscriptBox["x", "1"], 
         RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "2"}]]}], "]"}], "==", 
      "0"}], "\[And]", 
     RowBox[{
      RowBox[{
       RowBox[{"2", " ", 
        SubscriptBox["x", "4"]}], "+", 
       SubscriptBox["x", "7"]}], "==", 
      RowBox[{"b", " ", 
       SubscriptBox["x", "3"]}]}], "\[And]", 
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "b"}], "+", 
         SubscriptBox["x", "8"]}], ",", 
        SubscriptBox["x", "7"]}], "]"}], "==", "0"}], "\[And]", 
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], "+", 
         SubscriptBox["x", "8"]}], ",", 
        SubscriptBox["x", "1"]}], "]"}], "==", "0"}], "\[And]", 
     RowBox[{
      RowBox[{
       SubscriptBox["x", "8"], "-", 
       SubscriptBox["x", "11"]}], "==", "3"}], "\[And]", 
     RowBox[{
      RowBox[{
       SuperscriptBox[
        SubscriptBox["x", "12"], 
        RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "2"}]], "-", 
       RowBox[{
        SubscriptBox["x", "8"], " ", 
        SubscriptBox["x", "12"], " ", 
        SubscriptBox["x", "13"]}], "+", 
       SuperscriptBox[
        SubscriptBox["x", "13"], 
        RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "2"}]]}], "==", "1"}], 
     "\[And]", 
     RowBox[{
      RowBox[{"1", "+", 
       RowBox[{"2", " ", "a"}], "+", 
       SubscriptBox["x", "14"]}], "==", 
      SubscriptBox["x", "1"]}], "\[And]", 
     RowBox[{"\[Lambda]", "[", 
      RowBox[{"a", ",", 
       SubscriptBox["x", "12"], ",", 
       SubscriptBox["x", "7"]}], "]"}], "\[And]", 
     RowBox[{"\[Lambda]", "[", 
      RowBox[{"c", ",", 
       SubscriptBox["x", "12"], ",", 
       SubscriptBox["x", "1"]}], "]"}]}]}], "]"}]}]], "Subsubsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Statements in Peano arithmetic", "Subsection"], Cell[
     " (page 1162)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[BoxData[
 RowBox[{"\[Not]", 
  RowBox[{
   SubscriptBox["\[Exists]", "a"], 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["\[Exists]", "b"], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", "\[NotEqual]", "0"}], "\[And]", 
       RowBox[{
        RowBox[{"a", "\[Times]", "a"}], "==", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\[FilledUpTriangle]", "\[NegativeVeryThinSpace]\[NegativeVeryThinSpace]", 
           RowBox[{
           "\[FilledUpTriangle]", "\[NegativeVeryThinSpace]\[NegativeVeryThinSpace]",
             "0"}]}], ")"}], "\[Times]", 
         RowBox[{"(", 
          RowBox[{"b", "\[Times]", "b"}], ")"}]}]}]}], ")"}]}], 
    ")"}]}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"\[Not]", 
  RowBox[{
   SubscriptBox["\[Exists]", "n"], 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["\[ForAll]", "c"], 
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["\[Exists]", "a"], 
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["\[Exists]", "b"], 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"n", "+", "c"}], ")"}], "\[Times]", 
            RowBox[{"(", 
             RowBox[{"n", "+", "c"}], ")"}]}], "+", 
           RowBox[{
           "\[FilledUpTriangle]", "\[NegativeVeryThinSpace]\[NegativeVeryThinSpace]",
             "0"}]}], "==", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"\[FilledUpTriangle]", "\[NegativeVeryThinSpace]\[NegativeVeryThinSpace]", 
             RowBox[{
             "\[FilledUpTriangle]", "\[NegativeVeryThinSpace]\[NegativeVeryThinSpace]",
               "a"}]}], ")"}], "\[Times]", 
           RowBox[{"(", 
            RowBox[{"\[FilledUpTriangle]", "\[NegativeVeryThinSpace]\[NegativeVeryThinSpace]", 
             RowBox[{
             "\[FilledUpTriangle]", "\[NegativeVeryThinSpace]\[NegativeVeryThinSpace]",
               "b"}]}], ")"}]}]}]}], ")"}]}], ")"}]}], 
    ")"}]}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[ForAll]", "a"], 
  RowBox[{"(", 
   RowBox[{
    SubscriptBox["\[Exists]", "b"], 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["\[Exists]", "c"], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[FilledUpTriangle]", "\[NegativeVeryThinSpace]\[NegativeVeryThinSpace]", 
            RowBox[{
            "\[FilledUpTriangle]", "\[NegativeVeryThinSpace]\[NegativeVeryThinSpace]",
              "0"}]}], ")"}], "\[Times]", 
          RowBox[{"(", 
           RowBox[{"\[FilledUpTriangle]", "\[NegativeVeryThinSpace]\[NegativeVeryThinSpace]", 
            RowBox[{
            "\[FilledUpTriangle]", "\[NegativeVeryThinSpace]\[NegativeVeryThinSpace]",
              "a"}]}], ")"}]}], "==", 
         RowBox[{"b", "+", "c"}]}], "\[And]", 
        RowBox[{
         SubscriptBox["\[ForAll]", "d"], 
         RowBox[{"(", 
          RowBox[{
           SubscriptBox["\[ForAll]", "e"], 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox["\[ForAll]", "f"], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", "==", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"\[FilledUpTriangle]", "\[NegativeVeryThinSpace]\[NegativeVeryThinSpace]", 
                    RowBox[{
                    "\[FilledUpTriangle]", "\[NegativeVeryThinSpace]\[NegativeVeryThinSpace]",
                     "d"}]}], ")"}], "\[Times]", 
                   RowBox[{"(", 
                    RowBox[{"\[FilledUpTriangle]", "\[NegativeVeryThinSpace]\[NegativeVeryThinSpace]", 
                    RowBox[{
                    "\[FilledUpTriangle]", "\[NegativeVeryThinSpace]\[NegativeVeryThinSpace]",
                     "e"}]}], ")"}]}]}], "\[Or]", 
                 RowBox[{"f", "==", 
                  RowBox[{
                  "\[FilledUpTriangle]", "\[NegativeVeryThinSpace]\[NegativeVeryThinSpace]",
                    "0"}]}]}], ")"}], "\[Implies]", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", "\[NotEqual]", "b"}], "\[And]", 
                 RowBox[{"f", "\[NotEqual]", "c"}]}], ")"}]}], ")"}]}], 
            ")"}]}], ")"}]}]}], ")"}]}], ")"}]}], ")"}]}]], "Subsubsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Growth rates", "Subsection"], Cell[" (page 1162)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"\[ScriptF]", "[", "1", "]"}], "[", "n_", "]"}], "=", 
    RowBox[{"2", " ", "n"}]}], ";", 
   RowBox[{
    RowBox[{
     RowBox[{"\[ScriptF]", "[", "s_", "]"}], "[", "n_", "]"}], ":=", 
    RowBox[{"Nest", "[", 
     RowBox[{
      RowBox[{"\[ScriptF]", "[", 
       RowBox[{"s", "-", "1"}], "]"}], ",", "1", ",", "n"}], "]"}]}]}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"\[ScriptF]", "[", "\[Omega]", "]"}], "[", "n_", "]"}], ":=", 
   RowBox[{
    RowBox[{"\[ScriptF]", "[", "n", "]"}], "[", "n", "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"\[ScriptF]", "[", 
    RowBox[{"\[Omega]", "+", "s"}], "]"}], "[", "n_", "]"}], ":=", 
  RowBox[{"Nest", "[", 
   RowBox[{
    RowBox[{"\[ScriptF]", "[", 
     RowBox[{"\[Omega]", "+", "s", "-", "1"}], "]"}], ",", "1", ",", "n"}], 
   "]"}]}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"\[ScriptF]", "[", "1", "]"}], "[", "n_", "]"}], "=", 
   RowBox[{"2", " ", "n"}]}], ";", 
  RowBox[{
   RowBox[{
    RowBox[{"\[ScriptF]", "[", "s_", "]"}], "[", "n_", "]"}], ":=", 
   RowBox[{"Nest", "[", 
    RowBox[{
     RowBox[{"\[ScriptF]", "[", 
      RowBox[{"s", "-", "1"}], "]"}], ",", "1", ",", "n"}], "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"\[ScriptF]", "[", "\[Omega]", "]"}], "[", "n_", "]"}], ":=", 
  RowBox[{
   RowBox[{"\[ScriptF]", "[", "n", "]"}], "[", "n", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"\[ScriptF]", "[", 
    RowBox[{"\[Omega]", "+", "s"}], "]"}], "[", "n_", "]"}], ":=", 
  RowBox[{"Nest", "[", 
   RowBox[{
    RowBox[{"\[ScriptF]", "[", 
     RowBox[{"\[Omega]", "+", "s", "-", "1"}], "]"}], ",", "1", ",", "n"}], 
   "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"\[ScriptF]", "[", "1", "]"}], "[", "4", "]"}]], "Input"],

Cell[BoxData["8"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"\[ScriptF]", "[", "2", "]"}], "[", "4", "]"}]], "Input"],

Cell[BoxData["16"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"\[ScriptF]", "[", "3", "]"}], "[", "4", "]"}]], "Input"],

Cell[BoxData["65536"], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 787 \[CenterDot] Unprovable statements\
\>", "Subsection"], Cell[" (page 1163)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", "n_", "]"}], ":=", 
   RowBox[{"Map", "[", 
    RowBox[{"First", ",", 
     RowBox[{"NestWhileList", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"f", "[", "#", "]"}], "-", "1"}], ",", 
          RowBox[{
           RowBox[{"Last", "[", "#", "]"}], "+", "1"}]}], "}"}], "&"}], ",", 
       RowBox[{"{", 
        RowBox[{"n", ",", "3"}], "}"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"First", "[", "#", "]"}], ">", "0"}], "&"}]}], "]"}]}], 
    "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"f", "[", 
     RowBox[{"{", 
      RowBox[{"0", ",", "_"}], "}"}], "]"}], "=", "0"}], ";"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{"{", 
    RowBox[{"n_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{"Plus", ",", 
    RowBox[{"MapIndexed", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"#1", " ", 
        RowBox[{"k", "^", 
         RowBox[{"f", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{
             "#2", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
             "-", "1"}], ",", "k"}], "}"}], "]"}]}]}], "&"}], ",", 
      RowBox[{"Reverse", "[", 
       RowBox[{"IntegerDigits", "[", 
        RowBox[{"n", ",", 
         RowBox[{"k", "-", "1"}]}], "]"}], "]"}]}], "]"}]}], 
   "]"}]}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"g", "[", "n_", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"First", ",", 
    RowBox[{"NestWhileList", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"f", "[", "#", "]"}], "-", "1"}], ",", 
         RowBox[{
          RowBox[{"Last", "[", "#", "]"}], "+", "1"}]}], "}"}], "&"}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "3"}], "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"First", "[", "#", "]"}], ">", "0"}], "&"}]}], "]"}]}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "_"}], "}"}], "]"}], "=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{"{", 
    RowBox[{"n_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{"Plus", ",", 
    RowBox[{"MapIndexed", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"#1", " ", 
        RowBox[{"k", "^", 
         RowBox[{"f", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{
             "#2", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
             "-", "1"}], ",", "k"}], "}"}], "]"}]}]}], "&"}], ",", 
      RowBox[{"Reverse", "[", 
       RowBox[{"IntegerDigits", "[", 
        RowBox[{"n", ",", 
         RowBox[{"k", "-", "1"}]}], "]"}], "]"}]}], "]"}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.534772417620061*^9, 3.534772418102397*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"g", "[", "1", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "0"}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"g", "[", "2", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", "2", ",", "1", ",", "0"}], "}"}]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Practical programs", "Subsection"], Cell[" (page 1168)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"First", "[", 
   RowBox[{"Prepend", "[", 
    RowBox[{"p", ",", "q"}], "]"}], "]"}], "===", "q"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"First", "[", 
   RowBox[{"Prepend", "[", 
    RowBox[{"p", ",", "q"}], "]"}], "]"}], "===", "q"}]], "Input"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.534772444595931*^9, 3.534772482154007*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"Join", "[", 
     RowBox[{"p", ",", "q"}], "]"}], ",", "r"}], "]"}], "===", 
  RowBox[{"Join", "[", 
   RowBox[{"p", ",", 
    RowBox[{"Join", "[", 
     RowBox[{"q", ",", "r"}], "]"}]}], "]"}]}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"Join", "[", 
     RowBox[{"p", ",", "q"}], "]"}], ",", "r"}], "]"}], "===", 
  RowBox[{"Join", "[", 
   RowBox[{"p", ",", 
    RowBox[{"Join", "[", 
     RowBox[{"q", ",", "r"}], "]"}]}], "]"}]}]], "Input"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.534772464325492*^9, 3.53477248342272*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Partition", "[", 
   RowBox[{
    RowBox[{"Union", "[", "p", "]"}], ",", "1"}], "]"}], "===", 
  RowBox[{"Split", "[", 
   RowBox[{"Union", "[", "p", "]"}], "]"}]}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Partition", "[", 
   RowBox[{
    RowBox[{"Union", "[", "p", "]"}], ",", "1"}], "]"}], "===", 
  RowBox[{"Split", "[", 
   RowBox[{"Union", "[", "p", "]"}], "]"}]}]], "Input"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.534772474459271*^9, 3.534772484752282*^9}}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 801 \[CenterDot] Comparison to multiway systems\
\>", "Subsection"], Cell[" (page 1169)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Apply", "[", 
  RowBox[{"Equal", ",", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Fold", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#2", "[", "#1", "]"}], "&"}], ",", "x", ",", 
        RowBox[{"Characters", "[", "#", "]"}]}], "]"}], "&"}], ",", "rules", 
     ",", 
     RowBox[{"{", "2", "}"}]}], "]"}], ",", 
   RowBox[{"{", "1", "}"}]}], "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"rules", "=", 
     RowBox[{"{", 
      RowBox[{"\"\<AAB\>\"", "\[LeftRightArrow]", "\"\<BBAA\>\""}], "}"}]}], 
    "}"}], ",", 
   RowBox[{"Apply", "[", 
    RowBox[{"Equal", ",", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Fold", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"#2", "[", "#1", "]"}], "&"}], ",", "x", ",", 
          RowBox[{"Characters", "[", "#", "]"}]}], "]"}], "&"}], ",", "rules",
        ",", 
       RowBox[{"{", "2", "}"}]}], "]"}], ",", 
     RowBox[{"{", "1", "}"}]}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\"B\"\>", "[", 
    RowBox[{"\<\"A\"\>", "[", 
     RowBox[{"\<\"A\"\>", "[", "x", "]"}], "]"}], "]"}], "==", 
   RowBox[{"\<\"A\"\>", "[", 
    RowBox[{"\<\"A\"\>", "[", 
     RowBox[{"\<\"B\"\>", "[", 
      RowBox[{"\<\"B\"\>", "[", "x", "]"}], "]"}], "]"}], "]"}]}], 
  "}"}]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Append", "[", 
  RowBox[{
   RowBox[{"Apply", "[", 
    RowBox[{"Equal", ",", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Fold", "[", 
            RowBox[{"f", ",", 
             RowBox[{"First", "[", "#", "]"}], ",", 
             RowBox[{"Rest", "[", "#", "]"}]}], "]"}], "&"}], ")"}], "[", 
         RowBox[{"Characters", "[", "#", "]"}], "]"}], "&"}], ",", "rules", 
       ",", 
       RowBox[{"{", "2", "}"}]}], "]"}], ",", 
     RowBox[{"{", "1", "}"}]}], "]"}], ",", 
   RowBox[{
    RowBox[{"f", "[", 
     RowBox[{
      RowBox[{"f", "[", 
       RowBox[{"a", ",", "b"}], "]"}], ",", "c"}], "]"}], "==", 
    RowBox[{"f", "[", 
     RowBox[{"a", ",", 
      RowBox[{"f", "[", 
       RowBox[{"b", ",", "c"}], "]"}]}], "]"}]}]}], "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"rules", "=", 
     RowBox[{"{", 
      RowBox[{"\"\<AAB\>\"", "\[LeftRightArrow]", "\"\<BBAA\>\""}], "}"}]}], 
    "}"}], ",", 
   RowBox[{"Append", "[", 
    RowBox[{
     RowBox[{"Apply", "[", 
      RowBox[{"Equal", ",", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Fold", "[", 
              RowBox[{"f", ",", 
               RowBox[{"First", "[", "#", "]"}], ",", 
               RowBox[{"Rest", "[", "#", "]"}]}], "]"}], "&"}], ")"}], "[", 
           RowBox[{"Characters", "[", "#", "]"}], "]"}], "&"}], ",", "rules", 
         ",", 
         RowBox[{"{", "2", "}"}]}], "]"}], ",", 
       RowBox[{"{", "1", "}"}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"f", "[", 
       RowBox[{
        RowBox[{"f", "[", 
         RowBox[{"a", ",", "b"}], "]"}], ",", "c"}], "]"}], "==", 
      RowBox[{"f", "[", 
       RowBox[{"a", ",", 
        RowBox[{"f", "[", 
         RowBox[{"b", ",", "c"}], "]"}]}], "]"}]}]}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"f", "[", 
     RowBox[{
      RowBox[{"f", "[", 
       RowBox[{"\<\"A\"\>", ",", "\<\"A\"\>"}], "]"}], ",", "\<\"B\"\>"}], 
     "]"}], "==", 
    RowBox[{"f", "[", 
     RowBox[{
      RowBox[{"f", "[", 
       RowBox[{
        RowBox[{"f", "[", 
         RowBox[{"\<\"B\"\>", ",", "\<\"B\"\>"}], "]"}], ",", "\<\"A\"\>"}], 
       "]"}], ",", "\<\"A\"\>"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"f", "[", 
     RowBox[{
      RowBox[{"f", "[", 
       RowBox[{"a", ",", "b"}], "]"}], ",", "c"}], "]"}], "==", 
    RowBox[{"f", "[", 
     RowBox[{"a", ",", 
      RowBox[{"f", "[", 
       RowBox[{"b", ",", "c"}], "]"}]}], "]"}]}]}], "}"}]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 802 \[CenterDot] Operator systems", "Subsection"], Cell[
     " (page 1170)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"m", "=", 
     RowBox[{"Length", "[", "vars", "]"}]}], "}"}], ",", 
   RowBox[{"FromDigits", "[", 
    RowBox[{
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"f", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Reverse", "[", 
            RowBox[{"IntegerDigits", "[", 
             RowBox[{"u", ",", "k", ",", 
              SuperscriptBox["k", 
               RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "n"}]]}], "]"}], 
            "]"}], "\[LeftDoubleBracket]", 
           RowBox[{
            RowBox[{"FromDigits", "[", 
             RowBox[{
              RowBox[{"{", "##", "}"}], ",", "k"}], "]"}], "+", "1"}], 
           "\[RightDoubleBracket]"}], "&"}]}], "}"}], ",", 
       RowBox[{"Apply", "[", 
        RowBox[{
         RowBox[{"Function", "[", 
          RowBox[{
           RowBox[{"Evaluate", "[", "vars", "]"}], ",", "expr"}], "]"}], ",", 
         RowBox[{"Reverse", "[", 
          RowBox[{"Array", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"IntegerDigits", "[", 
              RowBox[{
               RowBox[{"#", "-", "1"}], ",", "k", ",", "m"}], "]"}], "&"}], 
            ",", 
            SuperscriptBox["k", 
             RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "m"}]]}], "]"}], 
          "]"}], ",", 
         RowBox[{"{", "1", "}"}]}], "]"}]}], "]"}], ",", "k"}], "]"}]}], 
  "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"vars", "=", 
      RowBox[{"{", 
       RowBox[{"p", ",", "q", ",", "r"}], "}"}]}], ",", 
     RowBox[{"k", "=", "2"}], ",", 
     RowBox[{"n", "=", "2"}], ",", 
     RowBox[{"expr", "=", 
      RowBox[{"f", "[", 
       RowBox[{"p", ",", 
        RowBox[{"f", "[", 
         RowBox[{"q", ",", "r"}], "]"}]}], "]"}]}], ",", 
     RowBox[{"u", "=", "7"}]}], "}"}], ",", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"m", "=", 
       RowBox[{"Length", "[", "vars", "]"}]}], "}"}], ",", 
     RowBox[{"FromDigits", "[", 
      RowBox[{
       RowBox[{"Block", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"f", "=", 
           RowBox[{
            RowBox[{
             RowBox[{"Reverse", "[", 
              RowBox[{"IntegerDigits", "[", 
               RowBox[{"u", ",", "k", ",", 
                SuperscriptBox["k", 
                 RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "n"}]]}], "]"}], 
              "]"}], "\[LeftDoubleBracket]", 
             RowBox[{
              RowBox[{"FromDigits", "[", 
               RowBox[{
                RowBox[{"{", "##", "}"}], ",", "k"}], "]"}], "+", "1"}], 
             "\[RightDoubleBracket]"}], "&"}]}], "}"}], ",", 
         RowBox[{"Apply", "[", 
          RowBox[{
           RowBox[{"Function", "[", 
            RowBox[{
             RowBox[{"Evaluate", "[", "vars", "]"}], ",", "expr"}], "]"}], 
           ",", 
           RowBox[{"Reverse", "[", 
            RowBox[{"Array", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"IntegerDigits", "[", 
                RowBox[{
                 RowBox[{"#", "-", "1"}], ",", "k", ",", "m"}], "]"}], "&"}], 
              ",", 
              SuperscriptBox["k", 
               RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "m"}]]}], "]"}], 
            "]"}], ",", 
           RowBox[{"{", "1", "}"}]}], "]"}]}], "]"}], ",", "k"}], "]"}]}], 
    "]"}]}], "]"}]], "Input"],

Cell[BoxData["143"], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Junctional calculus", "Subsection"], Cell[" (page 1170)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Union", "[", 
   RowBox[{"Level", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"{", 
      RowBox[{"-", "1"}], "}"}]}], "]"}], "]"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
  "13203", ",", "15633", ",", "15663", ",", "16401", ",", "17139", ",", 
   "18063", ",", "19539", ",", "19569", ",", "19599"}], 
  "}"}]}], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"expr", "=", 
     RowBox[{"f", "[", 
      RowBox[{
       RowBox[{"f", "[", 
        RowBox[{"a", ",", "b"}], "]"}], ",", "a"}], "]"}]}], "}"}], ",", 
   RowBox[{"Union", "[", 
    RowBox[{"Level", "[", 
     RowBox[{"expr", ",", 
      RowBox[{"{", 
       RowBox[{"-", "1"}], "}"}]}], "]"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"a", ",", "b"}], "}"}]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Equivalential calculus", "Subsection"], Cell[" (page 1170)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Mod", "[", 
  RowBox[{
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Count", "[", 
       RowBox[{"expr", ",", "#", ",", 
        RowBox[{"{", 
         RowBox[{"-", "1"}], "}"}]}], "]"}], "&"}], ",", "vars"}], "]"}], ",",
    "2"}], "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"expr", "=", 
      RowBox[{"f", "[", 
       RowBox[{
        RowBox[{"f", "[", 
         RowBox[{"a", ",", "b"}], "]"}], ",", "a"}], "]"}]}], ",", 
     RowBox[{"vars", "=", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b"}], "}"}]}]}], "}"}], ",", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Count", "[", 
         RowBox[{"expr", ",", "#", ",", 
          RowBox[{"{", 
           RowBox[{"-", "1"}], "}"}]}], "]"}], "&"}], ",", "vars"}], "]"}], 
     ",", "2"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "1"}], "}"}]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Implicational calculus", "Subsection"], Cell[" (page 1170)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "\[SmallCircle]", "b"}], ")"}], "\[SmallCircle]", "c"}], 
      ")"}], "\[SmallCircle]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"c", "\[SmallCircle]", "a"}], ")"}], "\[SmallCircle]", 
       RowBox[{"(", 
        RowBox[{"d", "\[SmallCircle]", "a"}], ")"}]}], ")"}]}], 
    "\[LongEqual]", 
    RowBox[{"d", "\[SmallCircle]", "d"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"a", "\[SmallCircle]", "a"}], ")"}], "\[SmallCircle]", "b"}], 
    "\[LongEqual]", "b"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"a", "\[SmallCircle]", "b"}], ")"}], "\[SmallCircle]", "b"}], 
    "\[LongEqual]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"b", "\[SmallCircle]", "a"}], ")"}], "\[SmallCircle]", 
     "a"}]}]}], "}"}]], "Subsubsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 803 \[CenterDot] Operators on sets", "Subsection"], Cell[
     " (page 1171)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1116699", ",", "169585339", ",", "290790239", ",", "459258879", ",", 
   "1090522958", ",", "1309671358", ",", "1430343258", ",", "1515110058", ",",
    "2184380593", ",", "2575151445", ",", "2863760025", ",", "2986292093"}], 
  "}"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Distribute", "[", 
  RowBox[{
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", "}"}], ",", 
        RowBox[{"{", "#", "}"}]}], "}"}], "&"}], ",", "s"}], "]"}], ",", 
   "List", ",", "List", ",", "List", ",", "Join"}], "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"s", "=", 
     RowBox[{"Range", "[", "4", "]"}]}], "}"}], ",", 
   RowBox[{"Distribute", "[", 
    RowBox[{
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "#", "}"}]}], "}"}], "&"}], ",", "s"}], "]"}], ",", 
     "List", ",", "List", ",", "List", ",", "Join"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "4", "}"}], ",", 
   RowBox[{"{", "3", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", "2", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", "1", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}], "}"}]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 805 \[CenterDot] Implementation", "Subsection"], Cell[
     " (page 1171)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"f", "[", 
      RowBox[{"a", ",", 
       RowBox[{"f", "[", 
        RowBox[{"a", ",", "a"}], "]"}]}], "]"}], "\[Equal]", "a"}], ",", " ", 
    RowBox[{
     RowBox[{"f", "[", 
      RowBox[{"a", ",", "b"}], "]"}], "\[Equal]", 
     RowBox[{"f", "[", 
      RowBox[{"b", ",", "a"}], "]"}]}]}], "}"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{"Module", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"c", ",", "v"}], "}"}], ",", 
   RowBox[{
    RowBox[{"c", "=", 
     RowBox[{"Apply", "[", 
      RowBox[{"Function", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"v", "=", 
          RowBox[{"Union", "[", 
           RowBox[{"Level", "[", 
            RowBox[{"axioms", ",", 
             RowBox[{"{", 
              RowBox[{"-", "1"}], "}"}]}], "]"}], "]"}]}], ",", 
         RowBox[{"Apply", "[", 
          RowBox[{"And", ",", "axioms"}], "]"}]}], "}"}]}], "]"}]}], ";", 
    RowBox[{"Select", "[", 
     RowBox[{
      RowBox[{"Range", "[", 
       RowBox[{"0", ",", 
        RowBox[{
         SuperscriptBox["k", 
          RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
           SuperscriptBox["k", 
            RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "2"}]]}]], "-", 
         "1"}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"u", "=", 
           RowBox[{"IntegerDigits", "[", 
            RowBox[{"#", ",", "k", ",", 
             SuperscriptBox["k", 
              RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "2"}]]}], "]"}]}], 
          "}"}], ",", 
         RowBox[{"Block", "[", 
          RowBox[{
           RowBox[{"{", "f", "}"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"f", "[", 
              RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
             RowBox[{"u", "\[LeftDoubleBracket]", 
              RowBox[{
               RowBox[{"-", "1"}], "-", 
               RowBox[{"k", " ", "x"}], "-", "y"}], 
              "\[RightDoubleBracket]"}]}], ";", 
            RowBox[{"Array", "[", 
             RowBox[{"c", ",", 
              RowBox[{"Table", "[", 
               RowBox[{"k", ",", 
                RowBox[{"{", 
                 RowBox[{"Length", "[", "v", "]"}], "}"}]}], "]"}], ",", "0", 
              ",", "And"}], "]"}]}]}], "]"}]}], "]"}], "&"}]}], "]"}]}]}], 
  "]"}]}], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BitOp", "[", 
   RowBox[{"a_", ",", "b_", ",", "n_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"IntegerDigits", "[", 
      RowBox[{"n", ",", "2", ",", "4"}], "]"}], ",", "2"}], "]"}], "[", 
   RowBox[{"[", 
    RowBox[{
     RowBox[{"2", "-", "a"}], ",", 
     RowBox[{"2", "-", "b"}]}], "]"}], "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"k", "=", "2"}], ",", 
     RowBox[{"axioms", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"f", "[", 
          RowBox[{"a", ",", 
           RowBox[{"f", "[", 
            RowBox[{"a", ",", "a"}], "]"}]}], "]"}], "\[Equal]", "a"}], ",", 
        " ", 
        RowBox[{
         RowBox[{"f", "[", 
          RowBox[{"a", ",", "b"}], "]"}], "\[Equal]", 
         RowBox[{"f", "[", 
          RowBox[{"b", ",", "a"}], "]"}]}]}], "}"}]}]}], "}"}], ",", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"c", ",", "v"}], "}"}], ",", 
     RowBox[{
      RowBox[{"c", "=", 
       RowBox[{"Apply", "[", 
        RowBox[{"Function", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"v", "=", 
            RowBox[{"Union", "[", 
             RowBox[{"Level", "[", 
              RowBox[{"axioms", ",", 
               RowBox[{"{", 
                RowBox[{"-", "1"}], "}"}]}], "]"}], "]"}]}], ",", 
           RowBox[{"Apply", "[", 
            RowBox[{"And", ",", "axioms"}], "]"}]}], "}"}]}], "]"}]}], ";", 
      RowBox[{"Select", "[", 
       RowBox[{
        RowBox[{"Range", "[", 
         RowBox[{"0", ",", 
          RowBox[{
           SuperscriptBox["k", 
            RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
             SuperscriptBox["k", 
              RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "2"}]]}]], "-", 
           "1"}]}], "]"}], ",", 
        RowBox[{
         RowBox[{"With", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"u", "=", 
             RowBox[{"IntegerDigits", "[", 
              RowBox[{"#", ",", "k", ",", 
               SuperscriptBox["k", 
                RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "2"}]]}], "]"}]}],
             "}"}], ",", 
           RowBox[{"Block", "[", 
            RowBox[{
             RowBox[{"{", "f", "}"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"f", "[", 
                RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
               RowBox[{"u", "\[LeftDoubleBracket]", 
                RowBox[{
                 RowBox[{"-", "1"}], "-", 
                 RowBox[{"k", " ", "x"}], "-", "y"}], 
                "\[RightDoubleBracket]"}]}], ";", 
              RowBox[{"Array", "[", 
               RowBox[{"c", ",", 
                RowBox[{"Table", "[", 
                 RowBox[{"k", ",", 
                  RowBox[{"{", 
                   RowBox[{"Length", "[", "v", "]"}], "}"}]}], "]"}], ",", 
                "0", ",", "And"}], "]"}]}]}], "]"}]}], "]"}], "&"}]}], 
       "]"}]}]}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6", ",", "8", ",", "9", ",", "14"}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"f", "=", 
     RowBox[{
      RowBox[{"BitOp", "[", 
       RowBox[{"#1", ",", "#2", ",", "6"}], "]"}], "&"}]}], "}"}], ",", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"f", "[", 
         RowBox[{"a", ",", 
          RowBox[{"f", "[", 
           RowBox[{"a", ",", "a"}], "]"}]}], "]"}], "\[Equal]", "a"}], ",", 
       " ", 
       RowBox[{
        RowBox[{"f", "[", 
         RowBox[{"a", ",", "b"}], "]"}], "\[Equal]", 
        RowBox[{"f", "[", 
         RowBox[{"b", ",", "a"}], "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"b", ",", "0", ",", "1"}], "}"}]}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"True", ",", "True"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "True"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"True", ",", "True"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "True"}], "}"}]}], "}"}]}], "}"}]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 806 \[CenterDot] Algebraic systems", "Subsection"], Cell[
     " (page 1171)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{
    RowBox[{"f", "[", 
     RowBox[{"a", ",", "b", ",", "c"}], "]"}], ",", "d", ",", "e"}], "]"}], 
  "\[LongEqual]", 
  RowBox[{"f", "[", 
   RowBox[{"a", ",", 
    RowBox[{"f", "[", 
     RowBox[{"b", ",", "c", ",", "d"}], "]"}], ",", "e"}], "]"}], 
  "\[LongEqual]", 
  RowBox[{"f", "[", 
   RowBox[{"a", ",", "b", ",", 
    RowBox[{"f", "[", 
     RowBox[{"c", ",", "d", ",", "e"}], "]"}]}], "]"}]}]], "Subsubsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 806 \[CenterDot] Groups and semigroups\
\>", "Subsection"], Cell[" (page 1172)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Apply", "[", 
  RowBox[{"Times", ",", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"PartitionsP", "[", 
       RowBox[{"Last", "[", "#", "]"}], "]"}], "&"}], ",", 
     RowBox[{"FactorInteger", "[", "k", "]"}]}], "]"}]}], 
  "]"}]], "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"k", ",", 
     RowBox[{"Apply", "[", 
      RowBox[{"Times", ",", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"PartitionsP", "[", 
           RowBox[{"Last", "[", "#", "]"}], "]"}], "&"}], ",", 
         RowBox[{"FactorInteger", "[", "k", "]"}]}], "]"}]}], "]"}]}], 
    "\[IndentingNewLine]", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "1", ",", "20"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"11", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"12", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"13", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"14", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"15", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"16", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"17", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"18", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"19", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"20", ",", "2"}], "}"}]}], "}"}]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 808 \[CenterDot] Searching for logic", "Subsection"], Cell[
     " (page 1174)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"b", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "a"}], ")"}]}], ")"}]}], ")"}], 
    "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "c"}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"b", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "a"}], ")"}]}], ")"}]}], ")"}], 
    "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"c", "\[SmallCircle]", "b"}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"b", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "b"}], ")"}]}], ")"}]}], ")"}], 
    "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "c"}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"b", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "b"}], ")"}]}], ")"}]}], ")"}], 
    "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"c", "\[SmallCircle]", "b"}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"b", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "c"}], ")"}]}], ")"}]}], ")"}], 
    "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"c", "\[SmallCircle]", "b"}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"b", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"b", "\[SmallCircle]", "a"}], ")"}]}], ")"}]}], ")"}], 
    "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "c"}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"b", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"b", "\[SmallCircle]", "a"}], ")"}]}], ")"}]}], ")"}], 
    "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"c", "\[SmallCircle]", "b"}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"b", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"c", "\[SmallCircle]", "a"}], ")"}]}], ")"}]}], ")"}], 
    "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "c"}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"b", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "b"}], ")"}], "\[SmallCircle]", "b"}],
        ")"}]}], ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "c"}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"b", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "b"}], ")"}], "\[SmallCircle]", "b"}],
        ")"}]}], ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"c", "\[SmallCircle]", "b"}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"b", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "c"}], ")"}], "\[SmallCircle]", "b"}],
        ")"}]}], ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"c", "\[SmallCircle]", "b"}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "c"}], ")"}], "\[SmallCircle]", "a"}], 
     ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"b", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "b"}], ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "c"}], ")"}], "\[SmallCircle]", "a"}], 
     ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"b", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "c"}], ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "c"}], ")"}], "\[SmallCircle]", "a"}], 
     ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"b", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "a"}], ")"}], "\[SmallCircle]", "b"}],
        ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "c"}], ")"}], "\[SmallCircle]", "a"}], 
     ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"b", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "b"}], ")"}], "\[SmallCircle]", "b"}],
        ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "c"}], ")"}], "\[SmallCircle]", "a"}], 
     ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"b", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "c"}], ")"}], "\[SmallCircle]", "b"}],
        ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "c"}], ")"}], "\[SmallCircle]", "a"}], 
     ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"b", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"b", "\[SmallCircle]", "a"}], ")"}], "\[SmallCircle]", "b"}],
        ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "c"}], ")"}], "\[SmallCircle]", "a"}], 
     ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"b", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"c", "\[SmallCircle]", "a"}], ")"}], "\[SmallCircle]", "b"}],
        ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "c"}], ")"}], "\[SmallCircle]", "a"}], 
     ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"c", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"c", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "b"}], ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "c"}], ")"}], "\[SmallCircle]", "a"}], 
     ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"c", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"c", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "c"}], ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "c"}], ")"}], "\[SmallCircle]", "a"}], 
     ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"c", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "a"}], ")"}], "\[SmallCircle]", "c"}],
        ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "c"}], ")"}], "\[SmallCircle]", "a"}], 
     ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"c", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "b"}], ")"}], "\[SmallCircle]", "c"}],
        ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "c"}], ")"}], "\[SmallCircle]", "a"}], 
     ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"c", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "c"}], ")"}], "\[SmallCircle]", "c"}],
        ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "c"}], ")"}], "\[SmallCircle]", "a"}], 
     ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"c", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"b", "\[SmallCircle]", "a"}], ")"}], "\[SmallCircle]", "c"}],
        ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "c"}], ")"}], "\[SmallCircle]", "a"}], 
     ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"c", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"c", "\[SmallCircle]", "a"}], ")"}], "\[SmallCircle]", "c"}],
        ")"}]}], ")"}]}]}], "}"}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", "b"}], ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "b"}], ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", "b"}], ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"b", "\[SmallCircle]", "b"}], ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", "b"}], ")"}]}], ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"b", "\[SmallCircle]", "b"}], ")"}]}], ")"}]}], ")"}]}]}], 
  "}"}]], "Subsubsection"],

Cell[BoxData["1885760537655125429738480884"], "Subsubsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", "a"}], ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"b", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "c"}], ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", "b"}], ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "b"}], ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", "b"}], ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "c"}], ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", "b"}], ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"b", "\[SmallCircle]", "b"}], ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", "b"}], ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"b", "\[SmallCircle]", "c"}], ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", "b"}], ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"b", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"c", "\[SmallCircle]", "c"}], ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", "b"}], ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"c", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"a", "\[SmallCircle]", "c"}], ")"}]}], ")"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", "b"}], ")"}], "\[SmallCircle]", 
    RowBox[{"(", 
     RowBox[{"a", "\[SmallCircle]", 
      RowBox[{"(", 
       RowBox[{"c", "\[SmallCircle]", 
        RowBox[{"(", 
         RowBox[{"c", "\[SmallCircle]", "c"}], ")"}]}], ")"}]}], ")"}]}]}], 
  "}"}]], "Subsubsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 808 \[CenterDot] History", "Subsection"], Cell[
     " (page 1175)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"a", "\[SmallCircle]", 
       RowBox[{"(", 
        RowBox[{"b", "\[SmallCircle]", "c"}], ")"}]}], ")"}], 
     "\[SmallCircle]", 
     RowBox[{"(", 
      RowBox[{"a", "\[SmallCircle]", 
       RowBox[{"(", 
        RowBox[{"b", "\[SmallCircle]", "c"}], ")"}]}], ")"}]}], 
    "\[LongEqual]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"c", "\[SmallCircle]", "a"}], ")"}], "\[SmallCircle]", "a"}], 
      ")"}], "\[SmallCircle]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "\[SmallCircle]", "a"}], ")"}], "\[SmallCircle]", "a"}], 
      ")"}]}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"a", "\[SmallCircle]", "a"}], ")"}], "\[SmallCircle]", 
     RowBox[{"(", 
      RowBox[{"b", "\[SmallCircle]", "a"}], ")"}]}], "\[LongEqual]", "a"}]}], 
  "}"}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"a", "\[SmallCircle]", "a"}], ")"}], "\[SmallCircle]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "\[SmallCircle]", "b"}], ")"}], "\[SmallCircle]", "b"}], 
      ")"}]}], "\[LongEqual]", "a"}], ",", 
   RowBox[{
    RowBox[{"a", "\[SmallCircle]", 
     RowBox[{"(", 
      RowBox[{"b", "\[SmallCircle]", "c"}], ")"}]}], "\[LongEqual]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "\[SmallCircle]", "c"}], ")"}], "\[SmallCircle]", 
         "a"}], ")"}], "\[SmallCircle]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"b", "\[SmallCircle]", "b"}], ")"}], "\[SmallCircle]", 
         "a"}], ")"}]}], ")"}], "\[SmallCircle]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "\[SmallCircle]", "c"}], ")"}], "\[SmallCircle]", 
         "a"}], ")"}], "\[SmallCircle]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"b", "\[SmallCircle]", "b"}], ")"}], "\[SmallCircle]", 
         "a"}], ")"}]}], ")"}]}]}]}], "}"}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "\[SmallCircle]", 
     RowBox[{"(", 
      RowBox[{"b", "\[SmallCircle]", 
       RowBox[{"(", 
        RowBox[{"a", "\[SmallCircle]", "c"}], ")"}]}], ")"}]}], 
    "\[LongEqual]", 
    RowBox[{"a", "\[SmallCircle]", 
     RowBox[{"(", 
      RowBox[{"b", "\[SmallCircle]", 
       RowBox[{"(", 
        RowBox[{"b", "\[SmallCircle]", "c"}], ")"}]}], ")"}]}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"a", "\[SmallCircle]", "a"}], ")"}], "\[SmallCircle]", 
     RowBox[{"(", 
      RowBox[{"b", "\[SmallCircle]", "a"}], ")"}]}], "\[LongEqual]", "a"}], 
   ",", 
   RowBox[{
    RowBox[{"a", "\[SmallCircle]", "b"}], "\[LongEqual]", 
    RowBox[{"b", "\[SmallCircle]", "a"}]}]}], "}"}]], "Subsubsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 814 \[CenterDot] Proof lengths in logic\
\>", "Subsection"], Cell[" (page 1175)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", "b"}], ")"}], 
      "\[Nand]", "b"}], ")"}], "\[LongEqual]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "\[Nand]", "b"}], ")"}], "\[Nand]", "a"}], ")"}], 
      "\[Nand]", "a"}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{"a", "\[Nand]", 
        RowBox[{"(", 
         RowBox[{"a", "\[Nand]", "a"}], ")"}]}], ")"}]}], ")"}], 
    "\[LongEqual]", 
    RowBox[{"(", 
     RowBox[{"a", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "\[Nand]", "b"}], ")"}], "\[Nand]", "b"}], ")"}]}], 
     ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", "a"}], ")"}], 
      "\[Nand]", "a"}], ")"}], "\[LongEqual]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", "b"}], ")"}], 
      "\[Nand]", "a"}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", "b"}], ")"}], 
      "\[Nand]", "b"}], ")"}], "\[LongEqual]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "\[Nand]", "b"}], ")"}], "\[Nand]", "a"}], ")"}], 
      "\[Nand]", "a"}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", "a"}], ")"}]}], 
     ")"}], "\[LongEqual]", 
    RowBox[{"(", 
     RowBox[{"b", "\[Nand]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", "b"}], ")"}]}], 
     ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", "a"}], ")"}], 
    "\[LongEqual]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", "b"}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", "a"}], ")"}], 
    "\[LongEqual]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", "b"}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "\[Nand]", "a"}], ")"}], "\[Nand]", "a"}], ")"}], 
    "\[LongEqual]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"b", "\[Nand]", "b"}], ")"}], "\[Nand]", "b"}], ")"}]}]}], 
  "}"}]], "Subsubsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 818 \[CenterDot] Nand theorems", "Subsection"], Cell[
     " (page 1175)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"p", "\[Nand]", "p"}], ")"}], "\[Nand]", "p"}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"p", "\[Nand]", "p"}], ")"}], "\[Nand]", "p"}], ")"}], 
      "\[Nand]", "p"}], ")"}], "\[Nand]", "p"}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"p", "\[Nand]", "p"}], ")"}], "\[Nand]", "p"}], ")"}], 
      "\[Nand]", "q"}], ")"}], "\[Nand]", "q"}]}], "}"}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"p", ",", 
   RowBox[{"p", "\[Nand]", "p"}], ",", 
   RowBox[{"p", "\[Nand]", "q"}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"p", "\[Nand]", "p"}], ")"}], "\[Nand]", "p"}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"p", "\[Nand]", "q"}], ")"}], "\[Nand]", "p"}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"p", "\[Nand]", "p"}], ")"}], "\[Nand]", "q"}]}], 
  "}"}]], "Subsubsection"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Intelligence in the Universe", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 832 \[CenterDot] Doubling rules", "Subsection"], Cell[
     " (page 1185)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "_"}], "}"}], "\[Rule]", "5"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"5", ",", "3", ",", "_"}], "}"}], "\[Rule]", "5"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"5", ",", "_", ",", "_"}], "}"}], "\[Rule]", "1"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "5", ",", "_"}], "}"}], "\[Rule]", "1"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "2", ",", "_"}], "}"}], "\[Rule]", "3"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "3", ",", "2"}], "}"}], "\[Rule]", "2"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "1", ",", "2"}], "}"}], "\[Rule]", "4"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "4", ",", "_"}], "}"}], "\[Rule]", "3"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"4", ",", "3", ",", "_"}], "}"}], "\[Rule]", "4"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"4", ",", "0", ",", "_"}], "}"}], "\[Rule]", "2"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "x_", ",", "_"}], "}"}], "\[Rule]", "x"}]}], "}"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{"Append", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"n", "-", "1"}], "}"}]}], "]"}], ",", "2"}], 
  "]"}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CAEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CAStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"GeneralCARule", "[", 
     RowBox[{"rule_", ",", 
      RowBox[{"r_Integer", ":", "1"}]}], "]"}], ",", "a_List"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Partition", "[", 
    RowBox[{"a", ",", 
     RowBox[{
      RowBox[{"2", " ", "r"}], "+", "1"}], ",", "1", ",", 
     RowBox[{"r", "+", "1"}]}], "]"}], "/.", "\[InvisibleSpace]", 
   "rule"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"n", "=", "3"}], "}"}], ",", 
    RowBox[{"CAEvolveList", "[", 
     RowBox[{
      RowBox[{"GeneralCARule", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "2", ",", "_"}], "}"}], "\[Rule]", "5"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"5", ",", "3", ",", "_"}], "}"}], "\[Rule]", "5"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"5", ",", "_", ",", "_"}], "}"}], "\[Rule]", "1"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "5", ",", "_"}], "}"}], "\[Rule]", "1"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "2", ",", "_"}], "}"}], "\[Rule]", "3"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "3", ",", "2"}], "}"}], "\[Rule]", "2"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "1", ",", "2"}], "}"}], "\[Rule]", "4"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "4", ",", "_"}], "}"}], "\[Rule]", "3"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"4", ",", "3", ",", "_"}], "}"}], "\[Rule]", "4"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"4", ",", "0", ",", "_"}], "}"}], "\[Rule]", "2"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "x_", ",", "_"}], "}"}], "\[Rule]", "x"}]}], 
        "}"}], "]"}], ",", 
      RowBox[{"Flatten", "[", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"Append", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{"1", ",", 
             RowBox[{"{", 
              RowBox[{"n", "-", "1"}], "}"}]}], "]"}], ",", "2"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{"0", ",", 
           RowBox[{"{", 
            RowBox[{"n", "+", "1"}], "}"}]}], "]"}]}], "}"}], "]"}], ",", 
      RowBox[{
       RowBox[{"2", 
        SuperscriptBox["n", "2"]}], "+", "n"}]}], "]"}]}], "]"}], "//", 
  "Grid"}]], "Input",
 CellChangeTimes->{{3.520262413943492*^9, 3.520262414974203*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "1", "1", "2", "0", "0", "0", "0"},
    {"0", "1", "4", "3", "0", "0", "0", "0"},
    {"0", "1", "3", "4", "0", "0", "0", "0"},
    {"0", "1", "3", "3", "2", "0", "0", "0"},
    {"0", "1", "3", "2", "3", "0", "0", "0"},
    {"0", "1", "2", "3", "3", "0", "0", "0"},
    {"0", "4", "3", "3", "3", "0", "0", "0"},
    {"0", "3", "4", "3", "3", "0", "0", "0"},
    {"0", "3", "3", "4", "3", "0", "0", "0"},
    {"0", "3", "3", "3", "4", "0", "0", "0"},
    {"0", "3", "3", "3", "3", "2", "0", "0"},
    {"0", "3", "3", "3", "2", "3", "0", "0"},
    {"0", "3", "3", "2", "3", "3", "0", "0"},
    {"0", "3", "2", "3", "3", "3", "0", "0"},
    {"0", "2", "3", "3", "3", "3", "0", "0"},
    {"0", "5", "3", "3", "3", "3", "0", "0"},
    {"0", "1", "5", "3", "3", "3", "0", "0"},
    {"0", "1", "1", "5", "3", "3", "0", "0"},
    {"0", "1", "1", "1", "5", "3", "0", "0"},
    {"0", "1", "1", "1", "1", "5", "0", "0"},
    {"0", "1", "1", "1", "1", "1", "1", "0"},
    {"0", "1", "1", "1", "1", "1", "1", "0"}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{3.520262418449033*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "2", ",", "_"}], "}"}], "\[Rule]", "3"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "1", ",", "2"}], "}"}], "\[Rule]", "2"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "0", ",", "_"}], "}"}], "\[Rule]", "1"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "_", ",", "_"}], "}"}], "\[Rule]", "3"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "3", ",", "_"}], "}"}], "\[Rule]", "1"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "x_", ",", "_"}], "}"}], "\[Rule]", "x"}]}], 
  "}"}]], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CAEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CAStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"GeneralCARule", "[", 
     RowBox[{"rule_", ",", 
      RowBox[{"r_Integer", ":", "1"}]}], "]"}], ",", "a_List"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Partition", "[", 
    RowBox[{"a", ",", 
     RowBox[{
      RowBox[{"2", " ", "r"}], "+", "1"}], ",", "1", ",", 
     RowBox[{"r", "+", "1"}]}], "]"}], "/.", "\[InvisibleSpace]", 
   "rule"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"n", "=", "3"}], "}"}], ",", 
    RowBox[{"CAEvolveList", "[", 
     RowBox[{
      RowBox[{"GeneralCARule", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "2", ",", "_"}], "}"}], "\[Rule]", "3"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "1", ",", "2"}], "}"}], "\[Rule]", "2"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"3", ",", "0", ",", "_"}], "}"}], "\[Rule]", "1"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"3", ",", "_", ",", "_"}], "}"}], "\[Rule]", "3"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "3", ",", "_"}], "}"}], "\[Rule]", "1"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "x_", ",", "_"}], "}"}], "\[Rule]", "x"}]}], 
        "}"}], "]"}], ",", 
      RowBox[{"Flatten", "[", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"Append", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{"1", ",", 
             RowBox[{"{", 
              RowBox[{"n", "-", "1"}], "}"}]}], "]"}], ",", "2"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{"0", ",", 
           RowBox[{"{", 
            RowBox[{"n", "+", "1"}], "}"}]}], "]"}]}], "}"}], "]"}], ",", 
      RowBox[{"3", "n"}]}], "]"}]}], "]"}], "//", "Grid"}]], "Input",
 CellChangeTimes->{{3.5202624239731493`*^9, 3.520262424316695*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "1", "1", "2", "0", "0", "0", "0"},
    {"0", "1", "2", "3", "0", "0", "0", "0"},
    {"0", "2", "3", "1", "1", "0", "0", "0"},
    {"0", "3", "1", "3", "1", "0", "0", "0"},
    {"0", "1", "3", "1", "3", "0", "0", "0"},
    {"0", "1", "1", "3", "1", "1", "0", "0"},
    {"0", "1", "1", "1", "3", "1", "0", "0"},
    {"0", "1", "1", "1", "1", "3", "0", "0"},
    {"0", "1", "1", "1", "1", "1", "1", "0"},
    {"0", "1", "1", "1", "1", "1", "1", "0"}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{{3.520262426223072*^9, 3.520262441520471*^9}}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{704, 852},
WindowMargins->{{10, Automatic}, {Automatic, 0}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic},
CellContext->CellGroup,
Magnification->1,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 5, \
2011)",
StyleDefinitions->Notebook[{
   Cell[
    CellGroupData[{
      Cell["Style Definitions for NKS Webcode", "Subtitle"], 
      Cell[
      "Modify the definitions below to change the default appearance of all \
cells in a given style.  Make modifications to any definition using commands \
in the Format menu.", "Text"], 
      Cell[
       CellGroupData[{
         Cell["Style Environment Names", "Section"], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{12, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 9], 
         Cell[
          StyleData[All, "Presentation"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{24, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 12], 
         Cell[
          StyleData[All, "Condensed"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{8, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 8], 
         Cell[
          StyleData[All, "Printout"], PageWidth -> PaperWidth, 
          CellLabelMargins -> {{2, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 5, 
          PrivateFontOptions -> {"FontType" -> "Outline"}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Notebook Options", "Section"], 
         Cell[
         "The options defined for the style below will be used at the \
Notebook level.", "Text"], 
         Cell[
          StyleData["Notebook"], PageHeaders -> {{
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"], None, 
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"]}, {
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"], None, 
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"]}}, CellFrameLabelMargins -> 
          6, StyleMenuListing -> None]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headings", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Title"], ShowCellBracket -> False, 
             CellMargins -> {{36, 6}, {20, 3}}, 
             CellGroupingRules -> {"TitleGrouping", 0}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
             "NaturalLanguage", CounterIncrements -> "Title", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}, {"Subtitle", 0}, {"Subsubtitle", 0}}, FontSize -> 
             36], 
            Cell[
             StyleData["Title", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 40}}, LineSpacing -> {1, 0}, 
             FontSize -> 44], 
            Cell[
             StyleData["Title", "Condensed"], 
             CellMargins -> {{8, 10}, {4, 8}}, FontSize -> 20], 
            Cell[
             StyleData["Title", "Printout"], 
             CellMargins -> {{2, 10}, {12, 30}}, FontSize -> 24]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["TitleHeader"], CellFrame -> {{0, 0}, {0.25, 0}}, 
             ShowCellBracket -> False, 
             CellMargins -> {{36, Inherited}, {3, 25}}, 
             CellGroupingRules -> {"TitleGrouping", 20}, PageBreakBelow -> 
             False, CellFrameMargins -> {{8, 8}, {4, 8}}, 
             DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
             "NaturalLanguage", FontSize -> 14], 
            Cell[
             StyleData["TitleHeader", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 20}}, LineSpacing -> {1, 0}, 
             FontSize -> 24], 
            Cell[
             StyleData["TitleHeader", "Condensed"], 
             CellMargins -> {{8, 10}, {8, 8}}, FontSize -> 12], 
            Cell[
             StyleData["TitleHeader", "Printout"], 
             CellMargins -> {{2, 10}, {12, 8}}, FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subtitle"], 
             CellMargins -> {{12, Inherited}, {20, 15}}, 
             CellGroupingRules -> {"TitleGrouping", 10}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subtitle", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}, {"Subsubtitle", 0}}, FontFamily -> "Helvetica", 
             FontSize -> 24], 
            Cell[
             StyleData["Subtitle", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 20}}, LineSpacing -> {1, 0}, 
             FontSize -> 36], 
            Cell[
             StyleData["Subtitle", "Condensed"], 
             CellMargins -> {{8, 10}, {4, 4}}, FontSize -> 14], 
            Cell[
             StyleData["Subtitle", "Printout"], 
             CellMargins -> {{2, 10}, {12, 8}}, FontSize -> 18]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellFrame -> {{0, 0}, {0.25, 0}}, 
             ShowCellBracket -> False, ShowGroupOpener -> True, 
             CellMargins -> {{36, 3}, {8, 20}}, 
             CellGroupingRules -> {"SectionGrouping", 30}, PageBreakBelow -> 
             False, 
             CellFrameMargins -> {{Inherited, Inherited}, {4, Inherited}}, 
             CellFrameColor -> GrayLevel[0.6], DefaultNewInlineCellStyle -> 
             "None", InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Section", 
             CounterAssignments -> {{"Subsection", 0}, {"Subsubsection", 0}}, 
             FontFamily -> "Helvetica", FontSize -> 18], 
            Cell[
             StyleData["Section", "Presentation"], 
             CellMargins -> {{40, 10}, {11, 32}}, LineSpacing -> {1, 0}, 
             FontSize -> 24], 
            Cell[
             StyleData["Section", "Condensed"], 
             CellMargins -> {{18, Inherited}, {6, 12}}, FontSize -> 12], 
            Cell[
             StyleData["Section", "Printout"], 
             CellMargins -> {{13, 0}, {7, 22}}, FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], ShowCellBracket -> False, 
             ShowGroupOpener -> True, CellMargins -> {{50, 6}, {8, 20}}, 
             CellGroupingRules -> {"SectionGrouping", 40}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subsection", CounterAssignments -> {{"Subsubsection", 0}}, 
             FontFamily -> "Helvetica", FontSize -> 14, FontWeight -> "Bold", 
             GridBoxOptions -> {
              GridBoxAlignment -> {
                "Columns" -> {Left, {Right}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Baseline}}, "RowsIndexed" -> {}}, 
               GridBoxItemSize -> {"Columns" -> {
                   Scaled[0.8], {
                    Scaled[0.2]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
                 "RowsIndexed" -> {}}}], 
            Cell[
             StyleData["Subsection", "Presentation"], 
             CellMargins -> {{36, 10}, {11, 32}}, LineSpacing -> {1, 0}, 
             FontSize -> 22], 
            Cell[
             StyleData["Subsection", "Condensed"], 
             CellMargins -> {{16, Inherited}, {6, 12}}, FontSize -> 12], 
            Cell[
             StyleData["Subsection", "Printout"], 
             CellMargins -> {{9, 0}, {7, 22}}, FontSize -> 12]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsection"], CellFrame -> 2, ShowCellBracket -> 
             False, ShowGroupOpener -> True, 
             CellMargins -> {{70, 2}, {8, 18}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             Evaluatable -> False, 
             CellGroupingRules -> {"SectionGrouping", 50}, PageBreakBelow -> 
             False, CellFrameColor -> RGBColor[1, 0.730007, 0.360006], 
             DefaultFormatType -> DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
             FormatType -> InputForm, ShowStringCharacters -> True, 
             NumberMarks -> True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1},
              CounterIncrements -> "Subsubsection", FontWeight -> "Bold", 
             Background -> RGBColor[1, 0.970001, 0.840009]], 
            Cell[
             StyleData["Subsubsection", "Presentation"], 
             CellMargins -> {{34, 10}, {11, 26}}, LineSpacing -> {1, 0}, 
             FontSize -> 18], 
            Cell[
             StyleData["Subsubsection", "Condensed"], 
             CellMargins -> {{17, Inherited}, {6, 12}}, FontSize -> 10], 
            Cell[
             StyleData["Subsubsection", "Printout"], 
             CellMargins -> {{9, 0}, {7, 14}}, FontSize -> 11]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["TitleCell1"], ShowCellBracket -> False, 
             CellMargins -> {{0, 0}, {20, 0}}, 
             CellFrameMargins -> {{-1, 0}, {-1, -1}}, Hyphenation -> True, 
             StyleMenuListing -> None, FontSize -> 2, Magnification -> 1, 
             Background -> GrayLevel[0.2]], 
            Cell[
             StyleData["TitleCell1", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, FontSize -> 16], 
            Cell[
             StyleData["TitleCell1", "Condensed"], 
             CellMargins -> {{8, 10}, {6, 6}}, FontSize -> 11], 
            Cell[
             StyleData["TitleCell1", "Printout"], 
             CellMargins -> {{2, 2}, {6, 6}}, TextJustification -> 0.5, 
             FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["TitleCell2"], ShowCellBracket -> False, 
             CellMargins -> {{12, 10}, {-3, 7}}, Hyphenation -> True, 
             StyleMenuListing -> None, Background -> GrayLevel[0.98999]], 
            Cell[
             StyleData["TitleCell2", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, FontSize -> 16], 
            Cell[
             StyleData["TitleCell2", "Condensed"], 
             CellMargins -> {{8, 10}, {6, 6}}, FontSize -> 11], 
            Cell[
             StyleData["TitleCell2", "Printout"], 
             CellMargins -> {{2, 2}, {6, 6}}, TextJustification -> 0.5, 
             FontSize -> 10]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Body Text", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Text"], CellMargins -> {{80, 10}, {7, 7}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             Hyphenation -> True, LineSpacing -> {1, 3}, CounterIncrements -> 
             "Text"], 
            Cell[
             StyleData["Text", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 16], 
            Cell[
             StyleData["Text", "Condensed"], CellMargins -> {{8, 10}, {6, 6}},
              LineSpacing -> {1, 1}, FontSize -> 11], 
            Cell[
             StyleData["Text", "Printout"], CellMargins -> {{2, 2}, {6, 6}}, 
             TextJustification -> 0.5, FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SmallText"], CellMargins -> {{12, 10}, {6, 6}}, 
             DefaultNewInlineCellStyle -> "None", Hyphenation -> True, 
             LineSpacing -> {1, 3}, LanguageCategory -> "NaturalLanguage", 
             CounterIncrements -> "SmallText", FontFamily -> "Helvetica", 
             FontSize -> 9], 
            Cell[
             StyleData["SmallText", "Presentation"], 
             CellMargins -> {{24, 10}, {8, 8}}, LineSpacing -> {1, 5}, 
             FontSize -> 12], 
            Cell[
             StyleData["SmallText", "Condensed"], 
             CellMargins -> {{8, 10}, {5, 5}}, LineSpacing -> {1, 2}, 
             FontSize -> 9], 
            Cell[
             StyleData["SmallText", "Printout"], 
             CellMargins -> {{2, 2}, {5, 5}}, TextJustification -> 0.5, 
             FontSize -> 7]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Input/Output", "Section"], 
         Cell[
         "The cells in this section define styles used for input and output \
to the kernel.  Be careful when modifying, renaming, or removing these \
styles, because the front end associates special meanings with these style \
names. Some attributes for these styles are actually set in FormatType Styles \
(in the last section of this stylesheet). ", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Input"], CellMargins -> {{80, 10}, {5, 7}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             Evaluatable -> True, CellGroupingRules -> "InputGrouping", 
             CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, DefaultFormatType -> 
             DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
             FormatType -> InputForm, ShowStringCharacters -> True, 
             NumberMarks -> True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1},
              CounterIncrements -> "Input", FontWeight -> "Bold"], 
            Cell[
             StyleData["Input", "Presentation"], 
             CellMargins -> {{72, Inherited}, {8, 10}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["Input", "Condensed"], 
             CellMargins -> {{40, 10}, {2, 3}}, FontSize -> 11], 
            Cell[
             StyleData["Input", "Printout"], CellMargins -> {{39, 0}, {4, 6}},
              LinebreakAdjustments -> {0.85, 2, 10, 1, 1}, FontSize -> 9]}, 
           Closed]], 
         Cell[
          StyleData["InputOnly"], Evaluatable -> True, CellGroupingRules -> 
          "InputGrouping", CellHorizontalScrolling -> True, DefaultFormatType -> 
          DefaultInputFormatType, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
          FormatType -> InputForm, ShowStringCharacters -> True, NumberMarks -> 
          True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, 
          CounterIncrements -> "Input", StyleMenuListing -> None, FontWeight -> 
          "Bold"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Output"], CellMargins -> {{80, 10}, {7, 5}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             CellEditDuplicate -> True, CellGroupingRules -> "OutputGrouping",
              CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, DefaultFormatType -> 
             DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Output"], 
            Cell[
             StyleData["Output", "Presentation"], 
             CellMargins -> {{72, Inherited}, {10, 8}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["Output", "Condensed"], 
             CellMargins -> {{41, Inherited}, {3, 2}}, FontSize -> 11], 
            Cell[
             StyleData["Output", "Printout"], 
             CellMargins -> {{39, 0}, {6, 4}}, FontSize -> 9]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Message"], 
             CellMargins -> {{80, Inherited}, {Inherited, Inherited}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             CellGroupingRules -> "OutputGrouping", PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             DefaultFormatType -> DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Message", StyleMenuListing -> 
             None, FontSize -> 11, FontColor -> RGBColor[0, 0, 1]], 
            Cell[
             StyleData["Message", "Presentation"], 
             CellMargins -> {{72, Inherited}, {Inherited, Inherited}}, 
             LineSpacing -> {1, 0}, FontSize -> 16], 
            Cell[
             StyleData["Message", "Condensed"], 
             CellMargins -> {{41, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 11], 
            Cell[
             StyleData["Message", "Printout"], 
             CellMargins -> {{39, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 7, FontColor -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Print"], 
             CellMargins -> {{80, Inherited}, {Inherited, Inherited}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, ShowCellLabel -> 
             False, DefaultFormatType -> DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Print", StyleMenuListing -> 
             None], 
            Cell[
             StyleData["Print", "Presentation"], 
             CellMargins -> {{72, Inherited}, {Inherited, Inherited}}, 
             LineSpacing -> {1, 0}, FontSize -> 16], 
            Cell[
             StyleData["Print", "Condensed"], 
             CellMargins -> {{41, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 11], 
            Cell[
             StyleData["Print", "Printout"], 
             CellMargins -> {{39, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 8]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Graphics"], 
             CellMargins -> {{80, Inherited}, {Inherited, Inherited}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             CellGroupingRules -> "GraphicsGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             DefaultFormatType -> DefaultOutputFormatType, LanguageCategory -> 
             None, FormatType -> InputForm, CounterIncrements -> "Graphics", 
             ImageMargins -> {{43, Inherited}, {Inherited, 0}}, 
             StyleMenuListing -> None, FontFamily -> "Courier", FontSize -> 
             10], 
            Cell[
             StyleData["Graphics", "Presentation"], 
             ImageMargins -> {{62, Inherited}, {Inherited, 0}}], 
            Cell[
             StyleData["Graphics", "Condensed"], 
             ImageMargins -> {{38, Inherited}, {Inherited, 0}}, Magnification -> 
             0.6], 
            Cell[
             StyleData["Graphics", "Printout"], 
             ImageMargins -> {{30, Inherited}, {Inherited, 0}}, Magnification -> 
             0.8]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["CellLabel"], LanguageCategory -> None, 
             StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 
             9, FontColor -> RGBColor[0, 0, 1]], 
            Cell[
             StyleData["CellLabel", "Presentation"], FontSize -> 12], 
            Cell[
             StyleData["CellLabel", "Condensed"], FontSize -> 9], 
            Cell[
             StyleData["CellLabel", "Printout"], FontFamily -> "Courier", 
             FontSize -> 8, FontSlant -> "Italic", FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["FrameLabel"], LanguageCategory -> None, 
             StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 
             9], 
            Cell[
             StyleData["FrameLabel", "Presentation"], FontSize -> 12], 
            Cell[
             StyleData["FrameLabel", "Condensed"], FontSize -> 9], 
            Cell[
             StyleData["FrameLabel", "Printout"], FontFamily -> "Courier", 
             FontSize -> 8, FontSlant -> "Italic", FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Inline Formatting", "Section"], 
         Cell[
         "These styles are for modifying individual words or letters in a \
cell exclusive of the cell tag.", "Text"], 
         Cell[
          StyleData["RM"], StyleMenuListing -> None, FontWeight -> "Plain", 
          FontSlant -> "Plain"], 
         Cell[
          StyleData["BF"], StyleMenuListing -> None, FontWeight -> "Bold"], 
         Cell[
          StyleData["IT"], StyleMenuListing -> None, FontSlant -> "Italic"], 
         Cell[
          StyleData["TR"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["TI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["TB"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["TBI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["MR"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["MO"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["MB"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["MBO"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["SR"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["SO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["SB"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["SBO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SO10"], StyleMenuListing -> None, FontFamily -> 
             "Helvetica", FontSize -> 10, FontWeight -> "Plain", FontSlant -> 
             "Italic"], 
            Cell[
             StyleData["SO10", "Printout"], StyleMenuListing -> None, 
             FontFamily -> "Helvetica", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"], 
            Cell[
             StyleData["SO10", "EnhancedPrintout"], StyleMenuListing -> None, 
             FontFamily -> "Futura", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Hyperlink Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making hypertext \
ButtonBoxes.  The \"Hyperlink\" style is for links within the same Notebook, \
or between Notebooks.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Hyperlink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonNote -> 
               ButtonData}], 
            Cell[
             StyleData["Hyperlink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["Hyperlink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["Hyperlink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headers and Footers", "Section"], 
         Cell[
          StyleData["Header"], CellMargins -> {{0, 0}, {4, 1}}, 
          DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
          "NaturalLanguage", StyleMenuListing -> None, FontSize -> 10, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["Footer"], CellMargins -> {{0, 0}, {0, 4}}, 
          DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
          "NaturalLanguage", StyleMenuListing -> None, FontSize -> 9, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["PageNumber"], CellMargins -> {{0, 0}, {4, 1}}, 
          StyleMenuListing -> None, FontFamily -> "Times", FontSize -> 10]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Palette Styles", "Section"], 
         Cell[
         "The cells below define styles that define standard ButtonFunctions, \
for use in palette buttons.", "Text"], 
         Cell[
          StyleData["Paste"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, After]}]& )}], 
         Cell[
          StyleData["Evaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["EvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionMove[
                FrontEnd`InputNotebook[], All, Cell, 1], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Placeholder Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making placeholder objects \
in palette templates.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Placeholder"], Placeholder -> True, StyleMenuListing -> 
             None, FontSlant -> "Italic", FontColor -> 
             RGBColor[0.890623, 0.864698, 0.384756], 
             TagBoxOptions -> {
              Editable -> False, Selectable -> False, StripWrapperBoxes -> 
               False}], 
            Cell[
             StyleData["Placeholder", "Presentation"]], 
            Cell[
             StyleData["Placeholder", "Condensed"]], 
            Cell[
             StyleData["Placeholder", "Printout"]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["PrimaryPlaceholder"], StyleMenuListing -> None, 
             DrawHighlighted -> True, FontSlant -> "Italic", Background -> 
             RGBColor[0.912505, 0.891798, 0.507774], 
             TagBoxOptions -> {
              Editable -> False, Selectable -> False, StripWrapperBoxes -> 
               False}], 
            Cell[
             StyleData["PrimaryPlaceholder", "Presentation"]], 
            Cell[
             StyleData["PrimaryPlaceholder", "Condensed"]], 
            Cell[
             StyleData["PrimaryPlaceholder", "Printout"]]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["FormatType Styles", "Section"], 
         Cell[
         "The cells below define styles that are mixed in with the styles of \
most cells.  If a cell's FormatType matches the name of one of the styles \
defined below, then that style is applied between the cell's style and its \
own options. This is particularly true of Input and Output.", "Text"], 
         Cell[
          StyleData["CellExpression"], PageWidth -> Infinity, 
          CellMargins -> {{6, Inherited}, {Inherited, Inherited}}, 
          ShowCellLabel -> False, ShowSpecialCharacters -> False, 
          AllowInlineCells -> False, Hyphenation -> False, 
          AutoItalicWords -> {}, StyleMenuListing -> None, FontFamily -> 
          "Courier", FontSize -> 12, Background -> GrayLevel[1]], 
         Cell[
          StyleData["InputForm"], InputAutoReplacements -> {}, 
          AllowInlineCells -> False, Hyphenation -> False, StyleMenuListing -> 
          None, FontFamily -> "Courier"], 
         Cell[
          StyleData["OutputForm"], PageWidth -> Infinity, TextAlignment -> 
          Left, LineSpacing -> {0.6, 1}, StyleMenuListing -> None, FontFamily -> 
          "Courier"], 
         Cell[
          StyleData["StandardForm"], 
          InputAutoReplacements -> {
           "->" -> "\[Rule]", ":>" -> "\[RuleDelayed]", "<=" -> 
            "\[LessEqual]", ">=" -> "\[GreaterEqual]", "!=" -> "\[NotEqual]", 
            "==" -> "\[Equal]", Inherited}, LineSpacing -> {1.25, 0}, 
          StyleMenuListing -> None, FontFamily -> "Courier"], 
         Cell[
          StyleData["TraditionalForm"], 
          InputAutoReplacements -> {
           "->" -> "\[Rule]", ":>" -> "\[RuleDelayed]", "<=" -> 
            "\[LessEqual]", ">=" -> "\[GreaterEqual]", "!=" -> "\[NotEqual]", 
            "==" -> "\[Equal]", Inherited}, LineSpacing -> {1.25, 0}, 
          SingleLetterItalics -> True, TraditionalFunctionNotation -> True, 
          DelimiterMatching -> None, StyleMenuListing -> None], 
         Cell[
         "The style defined below is mixed in to any cell that is in an \
inline cell within another.", "Text"], 
         Cell[
          StyleData["InlineCell"], LanguageCategory -> "Formula", ScriptLevel -> 
          1, StyleMenuListing -> None], 
         Cell[
          StyleData["InlineCellEditing"], StyleMenuListing -> None, 
          Background -> RGBColor[1, 0.749996, 0.8]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Automatic Styles", "Section"], 
         Cell[
         "The cells below define styles that are used to affect the display \
of certain types of objects in typeset expressions.  For example, \
\"UnmatchedBracket\" style defines how unmatched bracket, curly bracket, and \
parenthesis characters are displayed (typically by coloring them to make them \
stand out).", "Text"], 
         Cell[
          StyleData["UnmatchedBracket"], StyleMenuListing -> None, FontColor -> 
          RGBColor[0.760006, 0.330007, 0.8]]}, Closed]]}, Open]]}, Visible -> 
  False, FrontEndVersion -> 
  "8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 5, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[1235, 30, 1845, 38, 25, "TitleCell1"],
Cell[3083, 70, 234, 7, 24, "Text"],
Cell[3320, 79, 43, 0, 46, "TitleHeader"],
Cell[CellGroupData[{
Cell[3388, 83, 59, 0, 59, "Title"],
Cell[CellGroupData[{
Cell[3472, 87, 48, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[3545, 91, 177, 5, 46, "Subsection"],
Cell[CellGroupData[{
Cell[3747, 100, 186, 5, 58, "Subsubsection"],
Cell[CellGroupData[{
Cell[3958, 109, 316, 10, 24, "Input"],
Cell[4277, 121, 93, 2, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4407, 128, 322, 10, 24, "Input"],
Cell[4732, 140, 97, 3, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4866, 148, 559, 16, 55, "Input"],
Cell[5428, 166, 1117, 16, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6582, 187, 84, 2, 24, "Input"],
Cell[6669, 191, 401, 12, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7131, 210, 154, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[7310, 218, 518, 17, 58, "Subsubsection"],
Cell[CellGroupData[{
Cell[7853, 239, 977, 29, 24, "Input"],
Cell[8833, 270, 170, 4, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[9052, 280, 534, 17, 44, "Subsubsection"],
Cell[CellGroupData[{
Cell[9611, 301, 622, 18, 24, "Input"],
Cell[10236, 321, 212, 5, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[10497, 332, 886, 27, 50, "Subsubsection"],
Cell[CellGroupData[{
Cell[11408, 363, 1731, 46, 70, "Input"],
Cell[13142, 411, 231, 5, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[13446, 424, 47, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[13518, 428, 167, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[13710, 436, 777, 25, 74, "Subsubsection"],
Cell[CellGroupData[{
Cell[14512, 465, 997, 31, 55, "Input"],
Cell[15512, 498, 190, 4, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[15751, 508, 1980, 63, 94, "Subsubsection"],
Cell[17734, 573, 723, 22, 70, "Input"],
Cell[CellGroupData[{
Cell[18482, 599, 3445, 99, 165, "Input"],
Cell[21930, 700, 2037, 47, 100, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[24016, 753, 790, 26, 61, "Subsubsection"],
Cell[24809, 781, 723, 22, 70, "Input"],
Cell[CellGroupData[{
Cell[25557, 807, 2052, 60, 117, "Input"],
Cell[27612, 869, 2036, 47, 100, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[29721, 924, 52, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[29798, 928, 174, 5, 46, "Subsection"],
Cell[CellGroupData[{
Cell[29997, 937, 275, 7, 58, "Subsubsection"],
Cell[CellGroupData[{
Cell[30297, 948, 1030, 31, 55, "Input"],
Cell[31330, 981, 114, 3, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[31493, 990, 2409, 68, 144, "Subsubsection"],
Cell[33905, 1060, 2401, 68, 124, "Input"],
Cell[CellGroupData[{
Cell[36331, 1132, 847, 27, 40, "Input"],
Cell[37181, 1161, 2175, 67, 85, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[39405, 1234, 305, 9, 44, "Subsubsection"],
Cell[CellGroupData[{
Cell[39735, 1247, 2855, 80, 130, "Input"],
Cell[42593, 1329, 2168, 62, 100, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[44822, 1398, 142, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[44989, 1405, 890, 29, 104, "Subsubsection"],
Cell[45882, 1436, 1786, 63, 40, "Input"],
Cell[CellGroupData[{
Cell[47693, 1503, 691, 21, 40, "Input"],
Cell[48387, 1526, 355, 10, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[48803, 1543, 135, 3, 46, "Subsection"],
Cell[48941, 1548, 447, 9, 74, "Subsubsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49425, 1562, 140, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[49590, 1569, 335, 9, 58, "Subsubsection"],
Cell[CellGroupData[{
Cell[49950, 1582, 861, 24, 55, "Input"],
Cell[50814, 1608, 31, 0, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[50906, 1615, 137, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[51068, 1622, 1927, 60, 158, "Subsubsection"],
Cell[52998, 1684, 1540, 49, 79, "Input"],
Cell[CellGroupData[{
Cell[54563, 1737, 540, 16, 40, "Input"],
Cell[55106, 1755, 34, 0, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[55177, 1760, 55, 1, 24, "Input"],
Cell[55235, 1763, 34, 0, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[55330, 1770, 138, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[55493, 1777, 3036, 82, 223, "Subsubsection"],
Cell[58532, 1861, 539, 17, 24, "Input"],
Cell[CellGroupData[{
Cell[59096, 1882, 2540, 65, 150, "Input"],
Cell[61639, 1949, 1887, 64, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[63563, 2018, 3043, 78, 165, "Input"],
Cell[66609, 2098, 160, 4, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[66806, 2107, 193, 5, 24, "Input"],
Cell[67002, 2114, 160, 4, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[67223, 2125, 137, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[67385, 2132, 1258, 38, 89, "Subsubsection"],
Cell[CellGroupData[{
Cell[68668, 2174, 2366, 72, 100, "Input"],
Cell[71037, 2248, 28, 0, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[71126, 2255, 134, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[71285, 2262, 2506, 74, 179, "Subsubsection"],
Cell[73794, 2338, 2220, 64, 115, "Input"],
Cell[CellGroupData[{
Cell[76039, 2406, 325, 11, 24, "Input"],
Cell[76367, 2419, 31, 0, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[76459, 2426, 136, 3, 46, "Subsection"],
Cell[76598, 2431, 205, 5, 58, "Subsubsection"],
Cell[76806, 2438, 235, 7, 44, "Subsubsection"],
Cell[CellGroupData[{
Cell[77066, 2449, 621, 20, 44, "Subsubsection"],
Cell[CellGroupData[{
Cell[77712, 2473, 712, 23, 24, "Input"],
Cell[78427, 2498, 34, 0, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[78510, 2504, 1621, 48, 90, "Subsubsection"],
Cell[80134, 2554, 1613, 48, 70, "Input"],
Cell[CellGroupData[{
Cell[81772, 2606, 387, 13, 24, "Input"],
Cell[82162, 2621, 107, 2, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[82318, 2629, 2746, 93, 195, "Subsubsection"],
Cell[85067, 2724, 2098, 72, 100, "Input"],
Cell[CellGroupData[{
Cell[87190, 2800, 827, 26, 40, "Input"],
Cell[88020, 2828, 83, 2, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[88130, 2834, 156, 5, 44, "Subsubsection"],
Cell[88289, 2841, 237, 8, 44, "Subsubsection"],
Cell[88529, 2851, 592, 19, 54, "Subsubsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[89158, 2875, 161, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[89344, 2883, 1324, 40, 119, "Subsubsection"],
Cell[90671, 2925, 511, 16, 40, "Input"],
Cell[91185, 2943, 787, 23, 40, "Input"],
Cell[CellGroupData[{
Cell[91997, 2970, 1255, 40, 52, "Input"],
Cell[93255, 3012, 1038, 32, 55, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[94354, 3051, 164, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[94543, 3059, 7031, 184, 224, "Subsubsection"],
Cell[101577, 3245, 7023, 184, 205, "Input"],
Cell[CellGroupData[{
Cell[108625, 3433, 973, 32, 40, "Input"],
Cell[109601, 3467, 8687, 266, 265, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[118349, 3740, 164, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[118538, 3748, 9923, 266, 314, "Subsubsection"],
Cell[128464, 4016, 9915, 266, 310, "Input"],
Cell[CellGroupData[{
Cell[138404, 4286, 1391, 44, 70, "Input"],
Cell[139798, 4332, 3374, 99, 70, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[143233, 4438, 167, 4, 46, "Subsection"],
Cell[143403, 4444, 219, 5, 58, "Subsubsection"],
Cell[143625, 4451, 244, 5, 44, "Subsubsection"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[143918, 4462, 67, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[144010, 4466, 133, 3, 46, "Subsection"],
Cell[144146, 4471, 963, 34, 58, "Subsubsection"],
Cell[145112, 4507, 1324, 42, 60, "Subsubsection"],
Cell[146439, 4551, 1200, 35, 60, "Subsubsection"],
Cell[147642, 4588, 836, 26, 44, "Subsubsection"],
Cell[CellGroupData[{
Cell[148503, 4618, 803, 26, 60, "Subsubsection"],
Cell[CellGroupData[{
Cell[149331, 4648, 1964, 59, 85, "Input"],
Cell[151298, 4709, 1584, 50, 40, "Output"]
}, Open  ]]
}, Closed]],
Cell[152909, 4763, 699, 23, 44, "Subsubsection"],
Cell[153611, 4788, 699, 23, 44, "Subsubsection"],
Cell[CellGroupData[{
Cell[154335, 4815, 1356, 42, 75, "Subsubsection"],
Cell[CellGroupData[{
Cell[155716, 4861, 2417, 72, 70, "Input"],
Cell[158136, 4935, 2430, 75, 55, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[160627, 5017, 145, 3, 46, "Subsection"],
Cell[160775, 5022, 907, 29, 74, "Subsubsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[161719, 5056, 164, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[161908, 5064, 5299, 172, 254, "Subsubsection"],
Cell[167210, 5238, 1538, 51, 55, "Input"],
Cell[CellGroupData[{
Cell[168773, 5293, 4012, 118, 115, "Input"],
Cell[172788, 5413, 9876, 287, 280, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[182725, 5707, 166, 4, 46, "Subsection"],
Cell[182894, 5713, 434, 14, 58, "Subsubsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[183365, 5732, 166, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[183556, 5740, 404, 13, 58, "Subsubsection"],
Cell[CellGroupData[{
Cell[183985, 5757, 524, 17, 24, "Input"],
Cell[184512, 5776, 2013, 63, 55, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[186562, 5844, 576, 18, 24, "Input"],
Cell[187141, 5864, 236, 5, 40, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[187414, 5874, 234, 8, 30, "Input"],
Cell[187651, 5884, 236, 5, 40, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[187948, 5896, 166, 4, 46, "Subsection"],
Cell[188117, 5902, 790, 24, 58, "Subsubsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[188944, 5931, 160, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[189129, 5939, 1018, 32, 93, "Subsubsection"],
Cell[CellGroupData[{
Cell[190172, 5975, 331, 11, 24, "Input"],
Cell[190506, 5988, 530, 20, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[191097, 6015, 182, 5, 46, "Subsection"],
Cell[191282, 6022, 240, 8, 58, "Subsubsection"],
Cell[191525, 6032, 241, 8, 44, "Subsubsection"],
Cell[191769, 6042, 144, 3, 44, "Subsubsection"],
Cell[191916, 6047, 319, 10, 44, "Subsubsection"],
Cell[192238, 6059, 324, 10, 44, "Subsubsection"],
Cell[192565, 6071, 986, 29, 55, "Subsubsection"],
Cell[193554, 6102, 331, 9, 50, "Subsubsection"],
Cell[193888, 6113, 511, 16, 44, "Subsubsection"],
Cell[194402, 6131, 321, 10, 44, "Subsubsection"],
Cell[194726, 6143, 361, 12, 44, "Subsubsection"],
Cell[195090, 6157, 1038, 31, 75, "Subsubsection"],
Cell[196131, 6190, 201, 6, 44, "Subsubsection"],
Cell[196335, 6198, 255, 8, 44, "Subsubsection"],
Cell[196593, 6208, 321, 10, 44, "Subsubsection"],
Cell[196917, 6220, 4122, 135, 121, "Subsubsection"],
Cell[201042, 6357, 821, 25, 63, "Subsubsection"],
Cell[201866, 6384, 668, 22, 44, "Subsubsection"],
Cell[202537, 6408, 3079, 95, 143, "Subsubsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[205653, 6508, 158, 4, 46, "Subsection"],
Cell[205814, 6514, 701, 20, 58, "Subsubsection"],
Cell[206518, 6536, 1271, 34, 44, "Subsubsection"],
Cell[207792, 6572, 2353, 56, 60, "Subsubsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[210182, 6633, 134, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[210341, 6640, 917, 29, 119, "Subsubsection"],
Cell[211261, 6671, 853, 26, 55, "Input"],
Cell[CellGroupData[{
Cell[212139, 6701, 91, 2, 24, "Input"],
Cell[212233, 6705, 28, 0, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[212298, 6710, 91, 2, 24, "Input"],
Cell[212392, 6714, 29, 0, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[212458, 6719, 91, 2, 24, "Input"],
Cell[212552, 6723, 32, 0, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[212645, 6730, 173, 5, 46, "Subsection"],
Cell[CellGroupData[{
Cell[212843, 6739, 1498, 50, 134, "Subsubsection"],
Cell[214344, 6791, 1476, 48, 100, "Input"],
Cell[CellGroupData[{
Cell[215845, 6843, 54, 1, 24, "Input"],
Cell[215902, 6846, 73, 2, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[216012, 6853, 54, 1, 24, "Input"],
Cell[216069, 6856, 93, 2, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[216223, 6865, 140, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[216388, 6872, 151, 4, 58, "Subsubsection"],
Cell[CellGroupData[{
Cell[216564, 6880, 143, 4, 24, "Input"],
Cell[216710, 6886, 97, 1, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[216856, 6893, 287, 9, 44, "Subsubsection"],
Cell[CellGroupData[{
Cell[217168, 6906, 279, 9, 24, "Input"],
Cell[217450, 6917, 96, 1, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[217595, 6924, 218, 6, 44, "Subsubsection"],
Cell[CellGroupData[{
Cell[217838, 6934, 210, 6, 24, "Input"],
Cell[218051, 6942, 97, 1, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[218209, 6950, 182, 5, 46, "Subsection"],
Cell[CellGroupData[{
Cell[218416, 6959, 427, 13, 58, "Subsubsection"],
Cell[CellGroupData[{
Cell[218868, 6976, 646, 20, 40, "Input"],
Cell[219517, 6998, 345, 10, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[219911, 7014, 880, 27, 60, "Subsubsection"],
Cell[CellGroupData[{
Cell[220816, 7045, 1127, 34, 55, "Input"],
Cell[221946, 7081, 721, 24, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[222728, 7112, 166, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[222919, 7120, 1490, 42, 124, "Subsubsection"],
Cell[CellGroupData[{
Cell[224434, 7166, 2035, 58, 130, "Input"],
Cell[226472, 7226, 30, 0, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[226563, 7233, 141, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[226729, 7240, 388, 12, 89, "Subsubsection"],
Cell[CellGroupData[{
Cell[227142, 7256, 398, 13, 24, "Input"],
Cell[227543, 7271, 73, 2, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[227677, 7280, 144, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[227846, 7287, 302, 10, 58, "Subsubsection"],
Cell[CellGroupData[{
Cell[228173, 7301, 653, 22, 40, "Input"],
Cell[228829, 7325, 73, 2, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[228963, 7334, 144, 3, 46, "Subsection"],
Cell[229110, 7339, 953, 31, 58, "Subsubsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[230100, 7375, 167, 4, 46, "Subsection"],
Cell[230270, 7381, 296, 6, 74, "Subsubsection"],
Cell[CellGroupData[{
Cell[230591, 7391, 325, 10, 44, "Subsubsection"],
Cell[CellGroupData[{
Cell[230941, 7405, 474, 15, 24, "Input"],
Cell[231418, 7422, 927, 29, 40, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[232406, 7458, 164, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[232595, 7466, 2428, 72, 190, "Subsubsection"],
Cell[235026, 7540, 390, 12, 24, "Input"],
Cell[CellGroupData[{
Cell[235441, 7556, 2704, 77, 167, "Input"],
Cell[238148, 7635, 94, 2, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[238279, 7642, 817, 26, 40, "Input"],
Cell[239099, 7670, 407, 14, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[239567, 7691, 167, 4, 46, "Subsection"],
Cell[239737, 7697, 479, 15, 58, "Subsubsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[240253, 7717, 173, 5, 46, "Subsection"],
Cell[CellGroupData[{
Cell[240451, 7726, 294, 9, 58, "Subsubsection"],
Cell[CellGroupData[{
Cell[240770, 7739, 506, 15, 40, "Input"],
Cell[241279, 7756, 1244, 42, 55, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[242584, 7805, 169, 4, 46, "Subsection"],
Cell[242756, 7811, 9863, 312, 179, "Subsubsection"],
Cell[252622, 8125, 1076, 32, 44, "Subsubsection"],
Cell[253701, 8159, 62, 0, 44, "Subsubsection"],
Cell[253766, 8161, 2583, 75, 75, "Subsubsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[256386, 8241, 157, 4, 46, "Subsection"],
Cell[256546, 8247, 968, 32, 58, "Subsubsection"],
Cell[257517, 8281, 1287, 40, 44, "Subsubsection"],
Cell[258807, 8323, 798, 24, 44, "Subsubsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[259642, 8352, 174, 5, 46, "Subsection"],
Cell[259819, 8359, 3041, 108, 104, "Subsubsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[262897, 8472, 163, 4, 46, "Subsection"],
Cell[263063, 8478, 617, 21, 58, "Subsubsection"],
Cell[263683, 8501, 444, 14, 44, "Subsubsection"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[264176, 8521, 47, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[264248, 8525, 164, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[264437, 8533, 1427, 44, 104, "Subsubsection"],
Cell[265867, 8579, 723, 22, 70, "Input"],
Cell[CellGroupData[{
Cell[266615, 8605, 2239, 62, 132, "Input"],
Cell[268857, 8669, 1210, 28, 362, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[270116, 8703, 670, 21, 60, "Subsubsection"],
Cell[270789, 8726, 723, 22, 70, "Input"],
Cell[CellGroupData[{
Cell[271537, 8752, 1585, 44, 100, "Input"],
Cell[273125, 8798, 682, 16, 170, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

(* NotebookSignature RupeJzWuj7X9xAwvXGHss#dL *)
